import { autocompletion as ge, closeBrackets as be } from "@codemirror/autocomplete";
import { defaultKeymap as ye, historyKeymap as xe, history as ke } from "@codemirror/commands";
import { javascript as ve } from "@codemirror/lang-javascript";
import { bracketMatching as we, syntaxHighlighting as je, defaultHighlightStyle as Pe } from "@codemirror/language";
import { StateEffect as w, StateField as T, RangeSetBuilder as Ue, Prec as X, Compartment as Ae, EditorState as Fe } from "@codemirror/state";
import { hoverTooltip as Se, Decoration as d, EditorView as x, ViewPlugin as Y, keymap as q, WidgetType as J, lineNumbers as Ce, highlightActiveLine as qe, highlightActiveLineGutter as Te, drawSelection as Be } from "@codemirror/view";
import { pure as De, ref as Re, Pattern as K, repl as Ee } from "@strudel/core";
import { setTheme as Me, Drawer as _e, cleanupDraw as O } from "@strudel/draw";
import { emacs as Le } from "@replit/codemirror-emacs";
import { vim as Ne } from "@replit/codemirror-vim";
import { vscodeKeymap as ze } from "@replit/codemirror-vscode-keymap";
import { abcdef as He, androidstudio as Ge, atomone as Ie, aura as Oe, bespin as We, darcula as Ve, dracula as $e, duotoneDark as Qe, eclipse as Xe, githubDark as Ye, gruvboxDark as Je, materialDark as Ke, nord as Ze, okaidia as en, solarizedDark as nn, sublime as tn, tokyoNight as an, tokyoNightStorm as sn, vscodeDark as on, xcodeDark as rn, bbedit as pn, duotoneLight as ln, githubLight as mn, gruvboxLight as cn, materialLight as dn, noctisLilac as un, solarizedLight as hn, tokyoNightDay as fn, xcodeLight as gn } from "@uiw/codemirror-themes-all";
import { tags as t } from "@lezer/highlight";
import { createTheme as b } from "@uiw/codemirror-themes";
import { getWidgetID as bn, registerWidgetType as yn } from "@strudel/transpiler";
import { persistentAtom as xn } from "@nanostores/persistent";
const kn = [
  {
    comment: `/**
 * Displays a slider widget to allow the user manipulate a value
 *
 * @name slider
 * @param {number} value Initial value
 * @param {number} min Minimum value - optional, defaults to 0
 * @param {number} max Maximum value - optional, defaults to 1
 * @param {number} step Step size - optional
 */`,
    meta: {
      filename: "slider.mjs",
      lineno: 116,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/codemirror",
      code: {}
    },
    description: "<p>Displays a slider widget to allow the user manipulate a value</p>",
    name: "slider",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Initial value</p>",
        name: "value"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Minimum value - optional, defaults to 0</p>",
        name: "min"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Maximum value - optional, defaults to 1</p>",
        name: "max"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Step size - optional</p>",
        name: "step"
      }
    ],
    longname: "slider",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Select a sound / sample by name. When using mininotation, you can also optionally supply 'n' and 'gain' parameters
 * separated by ':'.
 *
 * @name s
 * @param {string | Pattern} sound The sound / pattern of sounds to pick
 * @synonyms sound
 * @example
 * s("bd hh")
 * @example
 * s("bd:0 bd:1 bd:0:0.3 bd:1:1.4")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 61,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Select a sound / sample by name. When using mininotation, you can also optionally supply 'n' and 'gain' parameters
separated by ':'.</p>`,
    name: "s",
    params: [
      {
        type: {
          names: [
            "string",
            "Pattern"
          ]
        },
        description: "<p>The sound / pattern of sounds to pick</p>",
        name: "sound"
      }
    ],
    synonyms_text: "sound",
    synonyms: [
      "sound"
    ],
    examples: [
      's("bd hh")',
      's("bd:0 bd:1 bd:0:0.3 bd:1:1.4")'
    ],
    longname: "s",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Define a custom webaudio node to use as a sound source.
 *
 * @name source
 * @param {function} getSource
 * @synonyms src
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 76,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Define a custom webaudio node to use as a sound source.</p>",
    name: "source",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "getSource"
      }
    ],
    synonyms_text: "src",
    synonyms: [
      "src"
    ],
    longname: "source",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Selects the given index from the sample map.
 * Numbers too high will wrap around.
 * \`n\` can also be used to play midi numbers, but it is recommended to use \`note\` instead.
 *
 * @name n
 * @param {number | Pattern} value sample index starting from 0
 * @example
 * s("bd sd [~ bd] sd,hh*6").n("<0 1>")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 85,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Selects the given index from the sample map.
Numbers too high will wrap around.
<code>n</code> can also be used to play midi numbers, but it is recommended to use <code>note</code> instead.</p>`,
    name: "n",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>sample index starting from 0</p>",
        name: "value"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*6").n("<0 1>")'
    ],
    longname: "n",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Plays the given note name or midi number. A note name consists of
 *
 * - a letter (a-g or A-G)
 * - optional accidentals (b or #)
 * - optional octave number (0-9). Defaults to 3
 *
 * Examples of valid note names: \`c\`, \`bb\`, \`Bb\`, \`f#\`, \`c3\`, \`A4\`, \`Eb2\`, \`c#5\`
 *
 * You can also use midi numbers instead of note names, where 69 is mapped to A4 440Hz in 12EDO.
 *
 * @name note
 * @example
 * note("c a f e")
 * @example
 * note("c4 a4 f4 e4")
 * @example
 * note("60 69 65 64")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 97,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Plays the given note name or midi number. A note name consists of</p>
<ul>
<li>a letter (a-g or A-G)</li>
<li>optional accidentals (b or #)</li>
<li>optional octave number (0-9). Defaults to 3</li>
</ul>
<p>Examples of valid note names: <code>c</code>, <code>bb</code>, <code>Bb</code>, <code>f#</code>, <code>c3</code>, <code>A4</code>, <code>Eb2</code>, <code>c#5</code></p>
<p>You can also use midi numbers instead of note names, where 69 is mapped to A4 440Hz in 12EDO.</p>`,
    name: "note",
    examples: [
      'note("c a f e")',
      'note("c4 a4 f4 e4")',
      'note("60 69 65 64")'
    ],
    longname: "note",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * A pattern of numbers that speed up (or slow down) samples while they play. Currently only supported by osc / superdirt.
 *
 * @name accelerate
 * @param {number | Pattern} amount acceleration.
 * @superdirtOnly
 * @example
 * s("sax").accelerate("<0 1 2 4 8 16>").slow(2).osc()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 118,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>A pattern of numbers that speed up (or slow down) samples while they play. Currently only supported by osc / superdirt.</p>",
    name: "accelerate",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>acceleration.</p>",
        name: "amount"
      }
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    examples: [
      's("sax").accelerate("<0 1 2 4 8 16>").slow(2).osc()'
    ],
    longname: "accelerate",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *
 * Sets the velocity from 0 to 1. Is multiplied together with gain.
 * @name velocity
 * @example
 * s("hh*8")
 * .gain(".4!2 1 .4!2 1 .4 1")
 * .velocity(".4 1")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 129,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the velocity from 0 to 1. Is multiplied together with gain.</p>",
    name: "velocity",
    examples: [
      `s("hh*8")
.gain(".4!2 1 .4!2 1 .4 1")
.velocity(".4 1")`
    ],
    longname: "velocity",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Controls the gain by an exponential amount.
 *
 * @name gain
 * @param {number | Pattern} amount gain.
 * @example
 * s("hh*8").gain(".4!2 1 .4!2 1 .4 1").fast(2)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 139,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Controls the gain by an exponential amount.</p>",
    name: "gain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>gain.</p>",
        name: "amount"
      }
    ],
    examples: [
      's("hh*8").gain(".4!2 1 .4!2 1 .4 1").fast(2)'
    ],
    longname: "gain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Gain applied after all effects have been processed.
 *
 * @name postgain
 * @example
 * s("bd sd [~ bd] sd,hh*8")
 * .compressor("-20:20:10:.002:.02").postgain(1.5)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 149,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Gain applied after all effects have been processed.</p>",
    name: "postgain",
    examples: [
      `s("bd sd [~ bd] sd,hh*8")
.compressor("-20:20:10:.002:.02").postgain(1.5)`
    ],
    longname: "postgain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Like \`gain\`, but linear.
 *
 * @name amp
 * @param {number | Pattern} amount gain.
 * @superdirtOnly
 * @example
 * s("bd*8").amp(".1*2 .5 .1*2 .5 .1 .5").osc()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 159,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like <code>gain</code>, but linear.</p>",
    name: "amp",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>gain.</p>",
        name: "amount"
      }
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    examples: [
      's("bd*8").amp(".1*2 .5 .1*2 .5 .1 .5").osc()'
    ],
    longname: "amp",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Amplitude envelope attack time: Specifies how long it takes for the sound to reach its peak value, relative to the onset.
 *
 * @name attack
 * @param {number | Pattern} attack time in seconds.
 * @synonyms att
 * @example
 * note("c3 e3 f3 g3").attack("<0 .1 .5>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 170,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Amplitude envelope attack time: Specifies how long it takes for the sound to reach its peak value, relative to the onset.</p>",
    name: "attack",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time in seconds.</p>",
        name: "attack"
      }
    ],
    synonyms_text: "att",
    synonyms: [
      "att"
    ],
    examples: [
      'note("c3 e3 f3 g3").attack("<0 .1 .5>")'
    ],
    longname: "attack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the Frequency Modulation Harmonicity Ratio.
 * Controls the timbre of the sound.
 * Whole numbers and simple ratios sound more natural,
 * while decimal numbers and complex ratios sound metallic.
 *
 * @name fmh
 * @param {number | Pattern} harmonicity
 * @example
 * note("c e g b g e")
 * .fm(4)
 * .fmh("<1 2 1.5 1.61>")
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 182,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the Frequency Modulation Harmonicity Ratio.
Controls the timbre of the sound.
Whole numbers and simple ratios sound more natural,
while decimal numbers and complex ratios sound metallic.</p>`,
    name: "fmh",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "harmonicity"
      }
    ],
    examples: [
      `note("c e g b g e")
.fm(4)
.fmh("<1 2 1.5 1.61>")
.scope()`
    ],
    longname: "fmh",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the Frequency Modulation of the synth.
 * Controls the modulation index, which defines the brightness of the sound.
 *
 * @name fm
 * @param {number | Pattern} brightness modulation index
 * @synonyms fmi
 * @example
 * note("c e g b g e")
 * .fm("<0 1 2 8 32>")
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 198,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the Frequency Modulation of the synth.
Controls the modulation index, which defines the brightness of the sound.</p>`,
    name: "fm",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>modulation index</p>",
        name: "brightness"
      }
    ],
    synonyms_text: "fmi",
    synonyms: [
      "fmi"
    ],
    examples: [
      `note("c e g b g e")
.fm("<0 1 2 8 32>")
.scope()`
    ],
    longname: "fm",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Ramp type of fm envelope. Exp might be a bit broken..
 *
 * @name fmenv
 * @param {number | Pattern} type lin | exp
 * @example
 * note("c e g b g e")
 * .fm(4)
 * .fmdecay(.2)
 * .fmsustain(0)
 * .fmenv("<exp lin>")
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 213,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Ramp type of fm envelope. Exp might be a bit broken..</p>",
    name: "fmenv",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>lin | exp</p>",
        name: "type"
      }
    ],
    examples: [
      `note("c e g b g e")
.fm(4)
.fmdecay(.2)
.fmsustain(0)
.fmenv("<exp lin>")
.scope()`
    ],
    longname: "fmenv",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Attack time for the FM envelope: time it takes to reach maximum modulation
 *
 * @name fmattack
 * @param {number | Pattern} time attack time
 * @example
 * note("c e g b g e")
 * .fm(4)
 * .fmattack("<0 .05 .1 .2>")
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 228,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Attack time for the FM envelope: time it takes to reach maximum modulation</p>",
    name: "fmattack",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>attack time</p>",
        name: "time"
      }
    ],
    examples: [
      `note("c e g b g e")
.fm(4)
.fmattack("<0 .05 .1 .2>")
.scope()`
    ],
    longname: "fmattack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Decay time for the FM envelope: seconds until the sustain level is reached after the attack phase.
 *
 * @name fmdecay
 * @param {number | Pattern} time decay time
 * @example
 * note("c e g b g e")
 * .fm(4)
 * .fmdecay("<.01 .05 .1 .2>")
 * .fmsustain(.4)
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 241,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Decay time for the FM envelope: seconds until the sustain level is reached after the attack phase.</p>",
    name: "fmdecay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>decay time</p>",
        name: "time"
      }
    ],
    examples: [
      `note("c e g b g e")
.fm(4)
.fmdecay("<.01 .05 .1 .2>")
.fmsustain(.4)
.scope()`
    ],
    longname: "fmdecay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sustain level for the FM envelope: how much modulation is applied after the decay phase
 *
 * @name fmsustain
 * @param {number | Pattern} level sustain level
 * @example
 * note("c e g b g e")
 * .fm(4)
 * .fmdecay(.1)
 * .fmsustain("<1 .75 .5 0>")
 * .scope()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 255,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sustain level for the FM envelope: how much modulation is applied after the decay phase</p>",
    name: "fmsustain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>sustain level</p>",
        name: "level"
      }
    ],
    examples: [
      `note("c e g b g e")
.fm(4)
.fmdecay(.1)
.fmsustain("<1 .75 .5 0>")
.scope()`
    ],
    longname: "fmsustain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Select the sound bank to use. To be used together with \`s\`. The bank name (+ "_") will be prepended to the value of \`s\`.
 *
 * @name bank
 * @param {string | Pattern} bank the name of the bank
 * @example
 * s("bd sd [~ bd] sd").bank('RolandTR909') // = s("RolandTR909_bd RolandTR909_sd")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 273,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Select the sound bank to use. To be used together with <code>s</code>. The bank name (+ &quot;_&quot;) will be prepended to the value of <code>s</code>.</p>",
    name: "bank",
    params: [
      {
        type: {
          names: [
            "string",
            "Pattern"
          ]
        },
        description: "<p>the name of the bank</p>",
        name: "bank"
      }
    ],
    examples: [
      `s("bd sd [~ bd] sd").bank('RolandTR909') // = s("RolandTR909_bd RolandTR909_sd")`
    ],
    longname: "bank",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Amplitude envelope decay time: the time it takes after the attack time to reach the sustain level.
 * Note that the decay is only audible if the sustain value is lower than 1.
 *
 * @name decay
 * @param {number | Pattern} time decay time in seconds
 * @example
 * note("c3 e3 f3 g3").decay("<.1 .2 .3 .4>").sustain(0)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 289,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Amplitude envelope decay time: the time it takes after the attack time to reach the sustain level.
Note that the decay is only audible if the sustain value is lower than 1.</p>`,
    name: "decay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>decay time in seconds</p>",
        name: "time"
      }
    ],
    examples: [
      'note("c3 e3 f3 g3").decay("<.1 .2 .3 .4>").sustain(0)'
    ],
    longname: "decay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Amplitude envelope sustain level: The level which is reached after attack / decay, being sustained until the offset.
 *
 * @name sustain
 * @param {number | Pattern} gain sustain level between 0 and 1
 * @synonyms sus
 * @example
 * note("c3 e3 f3 g3").decay(.2).sustain("<0 .1 .4 .6 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 300,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Amplitude envelope sustain level: The level which is reached after attack / decay, being sustained until the offset.</p>",
    name: "sustain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>sustain level between 0 and 1</p>",
        name: "gain"
      }
    ],
    synonyms_text: "sus",
    synonyms: [
      "sus"
    ],
    examples: [
      'note("c3 e3 f3 g3").decay(.2).sustain("<0 .1 .4 .6 1>")'
    ],
    longname: "sustain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Amplitude envelope release time: The time it takes after the offset to go from sustain level to zero.
 *
 * @name release
 * @param {number | Pattern} time release time in seconds
 * @synonyms rel
 * @example
 * note("c3 e3 g3 c4").release("<0 .1 .4 .6 1>/2")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 311,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Amplitude envelope release time: The time it takes after the offset to go from sustain level to zero.</p>",
    name: "release",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>release time in seconds</p>",
        name: "time"
      }
    ],
    synonyms_text: "rel",
    synonyms: [
      "rel"
    ],
    examples: [
      'note("c3 e3 g3 c4").release("<0 .1 .4 .6 1>/2")'
    ],
    longname: "release",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the center frequency of the **b**and-**p**ass **f**ilter. When using mininotation, you
 * can also optionally supply the 'bpq' parameter separated by ':'.
 *
 * @name bpf
 * @param {number | Pattern} frequency center frequency
 * @synonyms bandf, bp
 * @example
 * s("bd sd [~ bd] sd,hh*6").bpf("<1000 2000 4000 8000>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 324,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the center frequency of the <strong>b</strong>and-<strong>p</strong>ass <strong>f</strong>ilter. When using mininotation, you
can also optionally supply the 'bpq' parameter separated by ':'.</p>`,
    name: "bpf",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>center frequency</p>",
        name: "frequency"
      }
    ],
    synonyms_text: "bandf, bp",
    synonyms: [
      "bandf",
      "bp"
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*6").bpf("<1000 2000 4000 8000>")'
    ],
    longname: "bpf",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the **b**and-**p**ass **q**-factor (resonance).
 *
 * @name bpq
 * @param {number | Pattern} q q factor
 * @synonyms bandq
 * @example
 * s("bd sd [~ bd] sd").bpf(500).bpq("<0 1 2 3>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 337,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the <strong>b</strong>and-<strong>p</strong>ass <strong>q</strong>-factor (resonance).</p>",
    name: "bpq",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>q factor</p>",
        name: "q"
      }
    ],
    synonyms_text: "bandq",
    synonyms: [
      "bandq"
    ],
    examples: [
      's("bd sd [~ bd] sd").bpf(500).bpq("<0 1 2 3>")'
    ],
    longname: "bpq",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * a pattern of numbers from 0 to 1. Skips the beginning of each sample, e.g. \`0.25\` to cut off the first quarter from each sample.
 *
 * @memberof Pattern
 * @name begin
 * @param {number | Pattern} amount between 0 and 1, where 1 is the length of the sample
 * @example
 * samples({ rave: 'rave/AREUREADY.wav' }, 'github:tidalcycles/dirt-samples')
 * s("rave").begin("<0 .25 .5 .75>").fast(2)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 350,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>a pattern of numbers from 0 to 1. Skips the beginning of each sample, e.g. <code>0.25</code> to cut off the first quarter from each sample.</p>",
    memberof: "Pattern",
    name: "begin",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1, where 1 is the length of the sample</p>",
        name: "amount"
      }
    ],
    examples: [
      `samples({ rave: 'rave/AREUREADY.wav' }, 'github:tidalcycles/dirt-samples')
s("rave").begin("<0 .25 .5 .75>").fast(2)`
    ],
    scope: "static",
    longname: "Pattern.begin",
    kind: "member"
  },
  {
    comment: `/**
 * The same as .begin, but cuts off the end off each sample.
 *
 * @memberof Pattern
 * @name end
 * @param {number | Pattern} length 1 = whole sample, .5 = half sample, .25 = quarter sample etc..
 * @example
 * s("bd*2,oh*4").end("<.1 .2 .5 1>").fast(2)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 362,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The same as .begin, but cuts off the end off each sample.</p>",
    memberof: "Pattern",
    name: "end",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>1 = whole sample, .5 = half sample, .25 = quarter sample etc..</p>",
        name: "length"
      }
    ],
    examples: [
      's("bd*2,oh*4").end("<.1 .2 .5 1>").fast(2)'
    ],
    scope: "static",
    longname: "Pattern.end",
    kind: "member"
  },
  {
    comment: `/**
 * Loops the sample.
 * Note that the tempo of the loop is not synced with the cycle tempo.
 * To change the loop region, use loopBegin / loopEnd.
 *
 * @name loop
 * @param {number | Pattern} on If 1, the sample is looped
 * @example
 * s("casio").loop(1)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 373,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Loops the sample.
Note that the tempo of the loop is not synced with the cycle tempo.
To change the loop region, use loopBegin / loopEnd.</p>`,
    name: "loop",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>If 1, the sample is looped</p>",
        name: "on"
      }
    ],
    examples: [
      's("casio").loop(1)'
    ],
    longname: "loop",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Begin to loop at a specific point in the sample (inbetween \`begin\` and \`end\`).
 * Note that the loop point must be inbetween \`begin\` and \`end\`, and before \`loopEnd\`!
 * Note: Samples starting with wt_ will automatically loop! (wt = wavetable)
 *
 * @name loopBegin
 * @param {number | Pattern} time between 0 and 1, where 1 is the length of the sample
 * @synonyms loopb
 * @example
 * s("space").loop(1)
 * .loopBegin("<0 .125 .25>").scope()
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 385,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Begin to loop at a specific point in the sample (inbetween <code>begin</code> and <code>end</code>).
Note that the loop point must be inbetween <code>begin</code> and <code>end</code>, and before <code>loopEnd</code>!
Note: Samples starting with wt_ will automatically loop! (wt = wavetable)</p>`,
    name: "loopBegin",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1, where 1 is the length of the sample</p>",
        name: "time"
      }
    ],
    synonyms_text: "loopb",
    synonyms: [
      "loopb"
    ],
    examples: [
      `s("space").loop(1)
.loopBegin("<0 .125 .25>").scope()`
    ],
    longname: "loopBegin",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *
 * End the looping section at a specific point in the sample (inbetween \`begin\` and \`end\`).
 * Note that the loop point must be inbetween \`begin\` and \`end\`, and after \`loopBegin\`!
 *
 * @name loopEnd
 * @param {number | Pattern} time between 0 and 1, where 1 is the length of the sample
 * @synonyms loope
 * @example
 * s("space").loop(1)
 * .loopEnd("<1 .75 .5 .25>").scope()
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 398,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>End the looping section at a specific point in the sample (inbetween <code>begin</code> and <code>end</code>).
Note that the loop point must be inbetween <code>begin</code> and <code>end</code>, and after <code>loopBegin</code>!</p>`,
    name: "loopEnd",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1, where 1 is the length of the sample</p>",
        name: "time"
      }
    ],
    synonyms_text: "loope",
    synonyms: [
      "loope"
    ],
    examples: [
      `s("space").loop(1)
.loopEnd("<1 .75 .5 .25>").scope()`
    ],
    longname: "loopEnd",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * bit crusher effect.
 *
 * @name crush
 * @param {number | Pattern} depth between 1 (for drastic reduction in bit-depth) to 16 (for barely no reduction).
 * @example
 * s("<bd sd>,hh*3").fast(2).crush("<16 8 7 6 5 4 3 2>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 411,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>bit crusher effect.</p>",
    name: "crush",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 1 (for drastic reduction in bit-depth) to 16 (for barely no reduction).</p>",
        name: "depth"
      }
    ],
    examples: [
      's("<bd sd>,hh*3").fast(2).crush("<16 8 7 6 5 4 3 2>")'
    ],
    longname: "crush",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * fake-resampling for lowering the sample rate. Caution: This effect seems to only work in chromium based browsers
 *
 * @name coarse
 * @param {number | Pattern} factor 1 for original 2 for half, 3 for a third and so on.
 * @example
 * s("bd sd [~ bd] sd,hh*8").coarse("<1 4 8 16 32>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 422,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>fake-resampling for lowering the sample rate. Caution: This effect seems to only work in chromium based browsers</p>",
    name: "coarse",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>1 for original 2 for half, 3 for a third and so on.</p>",
        name: "factor"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").coarse("<1 4 8 16 32>")'
    ],
    longname: "coarse",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * filter overdrive for supported filter types
 *
 * @name drive
 * @param {number | Pattern} amount
 * @example
 * note("{f g g c d a a#}%16".sub(17)).s("supersaw").lpenv(8).lpf(150).lpq(.8).ftype('ladder').drive("<.5 4>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 433,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>filter overdrive for supported filter types</p>",
    name: "drive",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "amount"
      }
    ],
    examples: [
      `note("{f g g c d a a#}%16".sub(17)).s("supersaw").lpenv(8).lpf(150).lpq(.8).ftype('ladder').drive("<.5 4>")`
    ],
    longname: "drive",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Allows you to set the output channels on the interface
 *
 * @name channels
 * @synonyms ch
 *
 * @param {number | Pattern} channels pattern the output channels
 * @example
 * note("e a d b g").channels("3:4")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 444,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Allows you to set the output channels on the interface</p>",
    name: "channels",
    synonyms_text: "ch",
    synonyms: [
      "ch"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>pattern the output channels</p>",
        name: "channels"
      }
    ],
    examples: [
      'note("e a d b g").channels("3:4")'
    ],
    longname: "channels",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Phaser audio effect that approximates popular guitar pedals.
 *
 * @name phaser
 * @synonyms ph
 * @param {number | Pattern} speed speed of modulation
 * @example
 * n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
 * .phaser("<1 2 4 8>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 460,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Phaser audio effect that approximates popular guitar pedals.</p>",
    name: "phaser",
    synonyms_text: "ph",
    synonyms: [
      "ph"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>speed of modulation</p>",
        name: "speed"
      }
    ],
    examples: [
      `n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
.phaser("<1 2 4 8>")`
    ],
    longname: "phaser",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * The frequency sweep range of the lfo for the phaser effect. Defaults to 2000
 *
 * @name phasersweep
 * @synonyms phs
 * @param {number | Pattern} phasersweep most useful values are between 0 and 4000
 * @example
 * n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
 * .phaser(2).phasersweep("<800 2000 4000>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 473,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The frequency sweep range of the lfo for the phaser effect. Defaults to 2000</p>",
    name: "phasersweep",
    synonyms_text: "phs",
    synonyms: [
      "phs"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>most useful values are between 0 and 4000</p>",
        name: "phasersweep"
      }
    ],
    examples: [
      `n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
.phaser(2).phasersweep("<800 2000 4000>")`
    ],
    longname: "phasersweep",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *  The center frequency of the phaser in HZ. Defaults to 1000
 *
 * @name phasercenter
 * @synonyms phc
 * @param {number | Pattern} centerfrequency in HZ
 * @example
 * n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
 * .phaser(2).phasercenter("<800 2000 4000>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 486,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The center frequency of the phaser in HZ. Defaults to 1000</p>",
    name: "phasercenter",
    synonyms_text: "phc",
    synonyms: [
      "phc"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>in HZ</p>",
        name: "centerfrequency"
      }
    ],
    examples: [
      `n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
.phaser(2).phasercenter("<800 2000 4000>")`
    ],
    longname: "phasercenter",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * The amount the signal is affected by the phaser effect. Defaults to 0.75
 *
 * @name phaserdepth
 * @synonyms phd
 * @param {number | Pattern} depth number between 0 and 1
 * @example
 * n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
 * .phaser(2).phaserdepth("<0 .5 .75 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 500,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The amount the signal is affected by the phaser effect. Defaults to 0.75</p>",
    name: "phaserdepth",
    synonyms_text: "phd",
    synonyms: [
      "phd"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>number between 0 and 1</p>",
        name: "depth"
      }
    ],
    examples: [
      `n(run(8)).scale("D:pentatonic").s("sawtooth").release(0.5)
.phaser(2).phaserdepth("<0 .5 .75 1>")`
    ],
    longname: "phaserdepth",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * choose the channel the pattern is sent to in superdirt
 *
 * @name channel
 * @param {number | Pattern} channel channel number
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 514,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>choose the channel the pattern is sent to in superdirt</p>",
    name: "channel",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>channel number</p>",
        name: "channel"
      }
    ],
    longname: "channel",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * In the style of classic drum-machines, \`cut\` will stop a playing sample as soon as another samples with in same cutgroup is to be played. An example would be an open hi-hat followed by a closed one, essentially muting the open.
 *
 * @name cut
 * @param {number | Pattern} group cut group number
 * @example
 * s("[oh hh]*4").cut(1)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 522,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>In the style of classic drum-machines, <code>cut</code> will stop a playing sample as soon as another samples with in same cutgroup is to be played. An example would be an open hi-hat followed by a closed one, essentially muting the open.</p>",
    name: "cut",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>cut group number</p>",
        name: "group"
      }
    ],
    examples: [
      's("[oh hh]*4").cut(1)'
    ],
    longname: "cut",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Applies the cutoff frequency of the **l**ow-**p**ass **f**ilter.
 *
 * When using mininotation, you can also optionally add the 'lpq' parameter, separated by ':'.
 *
 * @name lpf
 * @param {number | Pattern} frequency audible between 0 and 20000
 * @synonyms cutoff, ctf, lp
 * @example
 * s("bd sd [~ bd] sd,hh*6").lpf("<4000 2000 1000 500 200 100>")
 * @example
 * s("bd*16").lpf("1000:0 1000:10 1000:20 1000:30")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 532,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Applies the cutoff frequency of the <strong>l</strong>ow-<strong>p</strong>ass <strong>f</strong>ilter.</p>
<p>When using mininotation, you can also optionally add the 'lpq' parameter, separated by ':'.</p>`,
    name: "lpf",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>audible between 0 and 20000</p>",
        name: "frequency"
      }
    ],
    synonyms_text: "cutoff, ctf, lp",
    synonyms: [
      "cutoff",
      "ctf",
      "lp"
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*6").lpf("<4000 2000 1000 500 200 100>")',
      's("bd*16").lpf("1000:0 1000:10 1000:20 1000:30")'
    ],
    longname: "lpf",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the lowpass filter envelope modulation depth.
 * @name lpenv
 * @param {number | Pattern} modulation depth of the lowpass filter envelope between 0 and _n_
 * @synonyms lpe
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .lpf(300)
 * .lpa(.5)
 * .lpenv("<4 2 1 0 -1 -2 -4>/4")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 548,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the lowpass filter envelope modulation depth.</p>",
    name: "lpenv",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>depth of the lowpass filter envelope between 0 and <em>n</em></p>",
        name: "modulation"
      }
    ],
    synonyms_text: "lpe",
    synonyms: [
      "lpe"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.lpf(300)
.lpa(.5)
.lpenv("<4 2 1 0 -1 -2 -4>/4")`
    ],
    longname: "lpenv",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the highpass filter envelope modulation depth.
 * @name hpenv
 * @param {number | Pattern} modulation depth of the highpass filter envelope between 0 and _n_
 * @synonyms hpe
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .hpf(500)
 * .hpa(.5)
 * .hpenv("<4 2 1 0 -1 -2 -4>/4")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 561,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the highpass filter envelope modulation depth.</p>",
    name: "hpenv",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>depth of the highpass filter envelope between 0 and <em>n</em></p>",
        name: "modulation"
      }
    ],
    synonyms_text: "hpe",
    synonyms: [
      "hpe"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.hpf(500)
.hpa(.5)
.hpenv("<4 2 1 0 -1 -2 -4>/4")`
    ],
    longname: "hpenv",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the bandpass filter envelope modulation depth.
 * @name bpenv
 * @param {number | Pattern} modulation depth of the bandpass filter envelope between 0 and _n_
 * @synonyms bpe
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .bpf(500)
 * .bpa(.5)
 * .bpenv("<4 2 1 0 -1 -2 -4>/4")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 574,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the bandpass filter envelope modulation depth.</p>",
    name: "bpenv",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>depth of the bandpass filter envelope between 0 and <em>n</em></p>",
        name: "modulation"
      }
    ],
    synonyms_text: "bpe",
    synonyms: [
      "bpe"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.bpf(500)
.bpa(.5)
.bpenv("<4 2 1 0 -1 -2 -4>/4")`
    ],
    longname: "bpenv",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the attack duration for the lowpass filter envelope.
 * @name lpattack
 * @param {number | Pattern} attack time of the filter envelope
 * @synonyms lpa
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .lpf(300)
 * .lpa("<.5 .25 .1 .01>/4")
 * .lpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 587,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the attack duration for the lowpass filter envelope.</p>",
    name: "lpattack",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the filter envelope</p>",
        name: "attack"
      }
    ],
    synonyms_text: "lpa",
    synonyms: [
      "lpa"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.lpf(300)
.lpa("<.5 .25 .1 .01>/4")
.lpenv(4)`
    ],
    longname: "lpattack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the attack duration for the highpass filter envelope.
 * @name hpattack
 * @param {number | Pattern} attack time of the highpass filter envelope
 * @synonyms hpa
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .hpf(500)
 * .hpa("<.5 .25 .1 .01>/4")
 * .hpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 600,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the attack duration for the highpass filter envelope.</p>",
    name: "hpattack",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the highpass filter envelope</p>",
        name: "attack"
      }
    ],
    synonyms_text: "hpa",
    synonyms: [
      "hpa"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.hpf(500)
.hpa("<.5 .25 .1 .01>/4")
.hpenv(4)`
    ],
    longname: "hpattack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the attack duration for the bandpass filter envelope.
 * @name bpattack
 * @param {number | Pattern} attack time of the bandpass filter envelope
 * @synonyms bpa
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .bpf(500)
 * .bpa("<.5 .25 .1 .01>/4")
 * .bpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 613,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the attack duration for the bandpass filter envelope.</p>",
    name: "bpattack",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the bandpass filter envelope</p>",
        name: "attack"
      }
    ],
    synonyms_text: "bpa",
    synonyms: [
      "bpa"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.bpf(500)
.bpa("<.5 .25 .1 .01>/4")
.bpenv(4)`
    ],
    longname: "bpattack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the decay duration for the lowpass filter envelope.
 * @name lpdecay
 * @param {number | Pattern} decay time of the filter envelope
 * @synonyms lpd
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .lpf(300)
 * .lpd("<.5 .25 .1 0>/4")
 * .lpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 626,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the decay duration for the lowpass filter envelope.</p>",
    name: "lpdecay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the filter envelope</p>",
        name: "decay"
      }
    ],
    synonyms_text: "lpd",
    synonyms: [
      "lpd"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.lpf(300)
.lpd("<.5 .25 .1 0>/4")
.lpenv(4)`
    ],
    longname: "lpdecay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the decay duration for the highpass filter envelope.
 * @name hpdecay
 * @param {number | Pattern} decay time of the highpass filter envelope
 * @synonyms hpd
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .hpf(500)
 * .hpd("<.5 .25 .1 0>/4")
 * .hps(0.2)
 * .hpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 639,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the decay duration for the highpass filter envelope.</p>",
    name: "hpdecay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the highpass filter envelope</p>",
        name: "decay"
      }
    ],
    synonyms_text: "hpd",
    synonyms: [
      "hpd"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.hpf(500)
.hpd("<.5 .25 .1 0>/4")
.hps(0.2)
.hpenv(4)`
    ],
    longname: "hpdecay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the decay duration for the bandpass filter envelope.
 * @name bpdecay
 * @param {number | Pattern} decay time of the bandpass filter envelope
 * @synonyms bpd
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .bpf(500)
 * .bpd("<.5 .25 .1 0>/4")
 * .bps(0.2)
 * .bpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 653,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the decay duration for the bandpass filter envelope.</p>",
    name: "bpdecay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the bandpass filter envelope</p>",
        name: "decay"
      }
    ],
    synonyms_text: "bpd",
    synonyms: [
      "bpd"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.bpf(500)
.bpd("<.5 .25 .1 0>/4")
.bps(0.2)
.bpenv(4)`
    ],
    longname: "bpdecay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the sustain amplitude for the lowpass filter envelope.
 * @name lpsustain
 * @param {number | Pattern} sustain amplitude of the lowpass filter envelope
 * @synonyms lps
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .lpf(300)
 * .lpd(.5)
 * .lps("<0 .25 .5 1>/4")
 * .lpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 667,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the sustain amplitude for the lowpass filter envelope.</p>",
    name: "lpsustain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>amplitude of the lowpass filter envelope</p>",
        name: "sustain"
      }
    ],
    synonyms_text: "lps",
    synonyms: [
      "lps"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.lpf(300)
.lpd(.5)
.lps("<0 .25 .5 1>/4")
.lpenv(4)`
    ],
    longname: "lpsustain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the sustain amplitude for the highpass filter envelope.
 * @name hpsustain
 * @param {number | Pattern} sustain amplitude of the highpass filter envelope
 * @synonyms hps
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .hpf(500)
 * .hpd(.5)
 * .hps("<0 .25 .5 1>/4")
 * .hpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 681,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the sustain amplitude for the highpass filter envelope.</p>",
    name: "hpsustain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>amplitude of the highpass filter envelope</p>",
        name: "sustain"
      }
    ],
    synonyms_text: "hps",
    synonyms: [
      "hps"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.hpf(500)
.hpd(.5)
.hps("<0 .25 .5 1>/4")
.hpenv(4)`
    ],
    longname: "hpsustain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the sustain amplitude for the bandpass filter envelope.
 * @name bpsustain
 * @param {number | Pattern} sustain amplitude of the bandpass filter envelope
 * @synonyms bps
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .bpf(500)
 * .bpd(.5)
 * .bps("<0 .25 .5 1>/4")
 * .bpenv(4)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 695,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the sustain amplitude for the bandpass filter envelope.</p>",
    name: "bpsustain",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>amplitude of the bandpass filter envelope</p>",
        name: "sustain"
      }
    ],
    synonyms_text: "bps",
    synonyms: [
      "bps"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.bpf(500)
.bpd(.5)
.bps("<0 .25 .5 1>/4")
.bpenv(4)`
    ],
    longname: "bpsustain",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the release time for the lowpass filter envelope.
 * @name lprelease
 * @param {number | Pattern} release time of the filter envelope
 * @synonyms lpr
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .clip(.5)
 * .lpf(300)
 * .lpenv(4)
 * .lpr("<.5 .25 .1 0>/4")
 * .release(.5)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 709,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the release time for the lowpass filter envelope.</p>",
    name: "lprelease",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the filter envelope</p>",
        name: "release"
      }
    ],
    synonyms_text: "lpr",
    synonyms: [
      "lpr"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.clip(.5)
.lpf(300)
.lpenv(4)
.lpr("<.5 .25 .1 0>/4")
.release(.5)`
    ],
    longname: "lprelease",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the release time for the highpass filter envelope.
 * @name hprelease
 * @param {number | Pattern} release time of the highpass filter envelope
 * @synonyms hpr
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .clip(.5)
 * .hpf(500)
 * .hpenv(4)
 * .hpr("<.5 .25 .1 0>/4")
 * .release(.5)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 724,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the release time for the highpass filter envelope.</p>",
    name: "hprelease",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the highpass filter envelope</p>",
        name: "release"
      }
    ],
    synonyms_text: "hpr",
    synonyms: [
      "hpr"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.clip(.5)
.hpf(500)
.hpenv(4)
.hpr("<.5 .25 .1 0>/4")
.release(.5)`
    ],
    longname: "hprelease",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the release time for the bandpass filter envelope.
 * @name bprelease
 * @param {number | Pattern} release time of the bandpass filter envelope
 * @synonyms bpr
 * @example
 * note("c2 e2 f2 g2")
 * .sound('sawtooth')
 * .clip(.5)
 * .bpf(500)
 * .bpenv(4)
 * .bpr("<.5 .25 .1 0>/4")
 * .release(.5)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 739,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the release time for the bandpass filter envelope.</p>",
    name: "bprelease",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time of the bandpass filter envelope</p>",
        name: "release"
      }
    ],
    synonyms_text: "bpr",
    synonyms: [
      "bpr"
    ],
    examples: [
      `note("c2 e2 f2 g2")
.sound('sawtooth')
.clip(.5)
.bpf(500)
.bpenv(4)
.bpr("<.5 .25 .1 0>/4")
.release(.5)`
    ],
    longname: "bprelease",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the filter type. The ladder filter is more aggressive. More types might be added in the future.
 * @name ftype
 * @param {number | Pattern} type 12db (0), ladder (1), or 24db (2)
 * @example
 * note("{f g g c d a a#}%8").s("sawtooth").lpenv(4).lpf(500).ftype("<0 1 2>").lpq(1)
 * @example
 * note("c f g g a c d4").fast(2)
 * .sound('sawtooth')
 * .lpf(200).fanchor(0)
 * .lpenv(3).lpq(1)
 * .ftype("<ladder 12db 24db>")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 754,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the filter type. The ladder filter is more aggressive. More types might be added in the future.</p>",
    name: "ftype",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>12db (0), ladder (1), or 24db (2)</p>",
        name: "type"
      }
    ],
    examples: [
      'note("{f g g c d a a#}%8").s("sawtooth").lpenv(4).lpf(500).ftype("<0 1 2>").lpq(1)',
      `note("c f g g a c d4").fast(2)
.sound('sawtooth')
.lpf(200).fanchor(0)
.lpenv(3).lpq(1)
.ftype("<ladder 12db 24db>")`
    ],
    longname: "ftype",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * controls the center of the filter envelope. 0 is unipolar positive, .5 is bipolar, 1 is unipolar negative
 * @name fanchor
 * @param {number | Pattern} center 0 to 1
 * @example
 * note("{f g g c d a a#}%8").s("sawtooth").lpf("{1000}%2")
 * .lpenv(8).fanchor("<0 .5 1>")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 769,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>controls the center of the filter envelope. 0 is unipolar positive, .5 is bipolar, 1 is unipolar negative</p>",
    name: "fanchor",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>0 to 1</p>",
        name: "center"
      }
    ],
    examples: [
      `note("{f g g c d a a#}%8").s("sawtooth").lpf("{1000}%2")
.lpenv(8).fanchor("<0 .5 1>")`
    ],
    longname: "fanchor",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Applies the cutoff frequency of the **h**igh-**p**ass **f**ilter.
 *
 * When using mininotation, you can also optionally add the 'hpq' parameter, separated by ':'.
 *
 * @name hpf
 * @param {number | Pattern} frequency audible between 0 and 20000
 * @synonyms hp, hcutoff
 * @example
 * s("bd sd [~ bd] sd,hh*8").hpf("<4000 2000 1000 500 200 100>")
 * @example
 * s("bd sd [~ bd] sd,hh*8").hpf("<2000 2000:25>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 778,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Applies the cutoff frequency of the <strong>h</strong>igh-<strong>p</strong>ass <strong>f</strong>ilter.</p>
<p>When using mininotation, you can also optionally add the 'hpq' parameter, separated by ':'.</p>`,
    name: "hpf",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>audible between 0 and 20000</p>",
        name: "frequency"
      }
    ],
    synonyms_text: "hp, hcutoff",
    synonyms: [
      "hp",
      "hcutoff"
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").hpf("<4000 2000 1000 500 200 100>")',
      's("bd sd [~ bd] sd,hh*8").hpf("<2000 2000:25>")'
    ],
    longname: "hpf",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Applies a vibrato to the frequency of the oscillator.
 *
 * @name vib
 * @synonyms vibrato, v
 * @param {number | Pattern} frequency of the vibrato in hertz
 * @example
 * note("a e")
 * .vib("<.5 1 2 4 8 16>")
 * @example
 * // change the modulation depth with ":"
 * note("a e")
 * .vib("<.5 1 2 4 8 16>:12")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 794,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Applies a vibrato to the frequency of the oscillator.</p>",
    name: "vib",
    synonyms_text: "vibrato, v",
    synonyms: [
      "vibrato",
      "v"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>of the vibrato in hertz</p>",
        name: "frequency"
      }
    ],
    examples: [
      `note("a e")
.vib("<.5 1 2 4 8 16>")`,
      `// change the modulation depth with ":"
note("a e")
.vib("<.5 1 2 4 8 16>:12")`
    ],
    longname: "vib",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Adds pink noise to the mix
 *
 * @name noise
 * @param {number | Pattern} wet wet amount
 * @example
 * sound("<white pink brown>/2")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 809,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Adds pink noise to the mix</p>",
    name: "noise",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>wet amount</p>",
        name: "wet"
      }
    ],
    examples: [
      'sound("<white pink brown>/2")'
    ],
    longname: "noise",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the vibrato depth in semitones. Only has an effect if \`vibrato\` | \`vib\` | \`v\` is is also set
 *
 * @name vibmod
 * @synonyms vmod
 * @param {number | Pattern} depth of vibrato (in semitones)
 * @example
 * note("a e").vib(4)
 * .vibmod("<.25 .5 1 2 12>")
 * @example
 * // change the vibrato frequency with ":"
 * note("a e")
 * .vibmod("<.25 .5 1 2 12>:8")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 818,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the vibrato depth in semitones. Only has an effect if <code>vibrato</code> | <code>vib</code> | <code>v</code> is is also set</p>",
    name: "vibmod",
    synonyms_text: "vmod",
    synonyms: [
      "vmod"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>of vibrato (in semitones)</p>",
        name: "depth"
      }
    ],
    examples: [
      `note("a e").vib(4)
.vibmod("<.25 .5 1 2 12>")`,
      `// change the vibrato frequency with ":"
note("a e")
.vibmod("<.25 .5 1 2 12>:8")`
    ],
    longname: "vibmod",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Controls the **h**igh-**p**ass **q**-value.
 *
 * @name hpq
 * @param {number | Pattern} q resonance factor between 0 and 50
 * @synonyms hresonance
 * @example
 * s("bd sd [~ bd] sd,hh*8").hpf(2000).hpq("<0 10 20 30>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 834,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Controls the <strong>h</strong>igh-<strong>p</strong>ass <strong>q</strong>-value.</p>",
    name: "hpq",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>resonance factor between 0 and 50</p>",
        name: "q"
      }
    ],
    synonyms_text: "hresonance",
    synonyms: [
      "hresonance"
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").hpf(2000).hpq("<0 10 20 30>")'
    ],
    longname: "hpq",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Controls the **l**ow-**p**ass **q**-value.
 *
 * @name lpq
 * @param {number | Pattern} q resonance factor between 0 and 50
 * @synonyms resonance
 * @example
 * s("bd sd [~ bd] sd,hh*8").lpf(2000).lpq("<0 10 20 30>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 845,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Controls the <strong>l</strong>ow-<strong>p</strong>ass <strong>q</strong>-value.</p>",
    name: "lpq",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>resonance factor between 0 and 50</p>",
        name: "q"
      }
    ],
    synonyms_text: "resonance",
    synonyms: [
      "resonance"
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").lpf(2000).lpq("<0 10 20 30>")'
    ],
    longname: "lpq",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * DJ filter, below 0.5 is low pass filter, above is high pass filter.
 *
 * @name djf
 * @param {number | Pattern} cutoff below 0.5 is low pass filter, above is high pass filter
 * @example
 * n("0 3 7 [10,24]").s('superzow').octave(3).djf("<.5 .25 .5 .75>").osc()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 857,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>DJ filter, below 0.5 is low pass filter, above is high pass filter.</p>",
    name: "djf",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>below 0.5 is low pass filter, above is high pass filter</p>",
        name: "cutoff"
      }
    ],
    examples: [
      `n("0 3 7 [10,24]").s('superzow').octave(3).djf("<.5 .25 .5 .75>").osc()`
    ],
    longname: "djf",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the level of the delay signal.
 *
 * When using mininotation, you can also optionally add the 'delaytime' and 'delayfeedback' parameter,
 * separated by ':'.
 *
 *
 * @name delay
 * @param {number | Pattern} level between 0 and 1
 * @example
 * s("bd bd").delay("<0 .25 .5 1>")
 * @example
 * s("bd bd").delay("0.65:0.25:0.9 0.65:0.125:0.7")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 869,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the level of the delay signal.</p>
<p>When using mininotation, you can also optionally add the 'delaytime' and 'delayfeedback' parameter,
separated by ':'.</p>`,
    name: "delay",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "level"
      }
    ],
    examples: [
      's("bd bd").delay("<0 .25 .5 1>")',
      's("bd bd").delay("0.65:0.25:0.9 0.65:0.125:0.7")'
    ],
    longname: "delay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the level of the signal that is fed back into the delay.
 * Caution: Values >= 1 will result in a signal that gets louder and louder! Don't do it
 *
 * @name delayfeedback
 * @param {number | Pattern} feedback between 0 and 1
 * @synonyms delayfb, dfb
 * @example
 * s("bd").delay(.25).delayfeedback("<.25 .5 .75 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 885,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the level of the signal that is fed back into the delay.
Caution: Values &gt;= 1 will result in a signal that gets louder and louder! Don't do it</p>`,
    name: "delayfeedback",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "feedback"
      }
    ],
    synonyms_text: "delayfb, dfb",
    synonyms: [
      "delayfb",
      "dfb"
    ],
    examples: [
      's("bd").delay(.25).delayfeedback("<.25 .5 .75 1>")'
    ],
    longname: "delayfeedback",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the time of the delay effect.
 *
 * @name delaytime
 * @param {number | Pattern} seconds between 0 and Infinity
 * @synonyms delayt, dt
 * @example
 * s("bd bd").delay(.25).delaytime("<.125 .25 .5 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 897,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the time of the delay effect.</p>",
    name: "delaytime",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and Infinity</p>",
        name: "seconds"
      }
    ],
    synonyms_text: "delayt, dt",
    synonyms: [
      "delayt",
      "dt"
    ],
    examples: [
      's("bd bd").delay(.25).delaytime("<.125 .25 .5 1>")'
    ],
    longname: "delaytime",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Set detune for stacked voices of supported oscillators
 *
 * @name detune
 * @param {number | Pattern} amount
 * @synonyms det
 * @example
 * note("d f a a# a d3").fast(2).s("supersaw").detune("<.1 .2 .5 24.1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 918,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Set detune for stacked voices of supported oscillators</p>",
    name: "detune",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "amount"
      }
    ],
    synonyms_text: "det",
    synonyms: [
      "det"
    ],
    examples: [
      'note("d f a a# a d3").fast(2).s("supersaw").detune("<.1 .2 .5 24.1>")'
    ],
    longname: "detune",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Set number of stacked voices for supported oscillators
 *
 * @name unison
 * @param {number | Pattern} numvoices
 * @example
 * note("d f a a# a d3").fast(2).s("supersaw").unison("<1 2 7>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 929,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Set number of stacked voices for supported oscillators</p>",
    name: "unison",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "numvoices"
      }
    ],
    examples: [
      'note("d f a a# a d3").fast(2).s("supersaw").unison("<1 2 7>")'
    ],
    longname: "unison",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Set the stereo pan spread for supported oscillators
 *
 * @name spread
 * @param {number | Pattern} spread between 0 and 1
 * @example
 * note("d f a a# a d3").fast(2).s("supersaw").spread("<0 .3 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 940,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Set the stereo pan spread for supported oscillators</p>",
    name: "spread",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "spread"
      }
    ],
    examples: [
      'note("d f a a# a d3").fast(2).s("supersaw").spread("<0 .3 1>")'
    ],
    longname: "spread",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Set dryness of reverb. See \`room\` and \`size\` for more information about reverb.
 *
 * @name dry
 * @param {number | Pattern} dry 0 = wet, 1 = dry
 * @example
 * n("[0,3,7](3,8)").s("superpiano").room(.7).dry("<0 .5 .75 1>").osc()
 * @superdirtOnly
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 950,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Set dryness of reverb. See <code>room</code> and <code>size</code> for more information about reverb.</p>",
    name: "dry",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>0 = wet, 1 = dry</p>",
        name: "dry"
      }
    ],
    examples: [
      'n("[0,3,7](3,8)").s("superpiano").room(.7).dry("<0 .5 .75 1>").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "dry",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Set frequency of sound.
 *
 * @name freq
 * @param {number | Pattern} frequency in Hz. the audible range is between 20 and 20000 Hz
 * @example
 * freq("220 110 440 110").s("superzow").osc()
 * @example
 * freq("110".mul.out(".5 1.5 .6 [2 3]")).s("superzow").osc()
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 974,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Set frequency of sound.</p>",
    name: "freq",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>in Hz. the audible range is between 20 and 20000 Hz</p>",
        name: "frequency"
      }
    ],
    examples: [
      'freq("220 110 440 110").s("superzow").osc()',
      'freq("110".mul.out(".5 1.5 .6 [2 3]")).s("superzow").osc()'
    ],
    longname: "freq",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Attack time of pitch envelope.
 *
 * @name pattack
 * @synonyms patt
 * @param {number | Pattern} time time in seconds
 * @example
 * note("c eb g bb").pattack("0 .1 .25 .5").slow(2)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 987,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Attack time of pitch envelope.</p>",
    name: "pattack",
    synonyms_text: "patt",
    synonyms: [
      "patt"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time in seconds</p>",
        name: "time"
      }
    ],
    examples: [
      'note("c eb g bb").pattack("0 .1 .25 .5").slow(2)'
    ],
    longname: "pattack",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Decay time of pitch envelope.
 *
 * @name pdecay
 * @synonyms pdec
 * @param {number | Pattern} time time in seconds
 * @example
 * note("<c eb g bb>").pdecay("<0 .1 .25 .5>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 998,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Decay time of pitch envelope.</p>",
    name: "pdecay",
    synonyms_text: "pdec",
    synonyms: [
      "pdec"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time in seconds</p>",
        name: "time"
      }
    ],
    examples: [
      'note("<c eb g bb>").pdecay("<0 .1 .25 .5>")'
    ],
    longname: "pdecay",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Release time of pitch envelope
 *
 * @name prelease
 * @synonyms prel
 * @param {number | Pattern} time time in seconds
 * @example
 * note("<c eb g bb> ~")
 * .release(.5) // to hear the pitch release
 * .prelease("<0 .1 .25 .5>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1011,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Release time of pitch envelope</p>",
    name: "prelease",
    synonyms_text: "prel",
    synonyms: [
      "prel"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>time in seconds</p>",
        name: "time"
      }
    ],
    examples: [
      `note("<c eb g bb> ~")
.release(.5) // to hear the pitch release
.prelease("<0 .1 .25 .5>")`
    ],
    longname: "prelease",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Amount of pitch envelope. Negative values will flip the envelope.
 * If you don't set other pitch envelope controls, \`pattack:.2\` will be the default.
 *
 * @name penv
 * @param {number | Pattern} semitones change in semitones
 * @example
 * note("c")
 * .penv("<12 7 1 .5 0 -1 -7 -12>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1024,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Amount of pitch envelope. Negative values will flip the envelope.
If you don't set other pitch envelope controls, <code>pattack:.2</code> will be the default.</p>`,
    name: "penv",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>change in semitones</p>",
        name: "semitones"
      }
    ],
    examples: [
      `note("c")
.penv("<12 7 1 .5 0 -1 -7 -12>")`
    ],
    longname: "penv",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Curve of envelope. Defaults to linear. exponential is good for kicks
 *
 * @name pcurve
 * @param {number | Pattern} type 0 = linear, 1 = exponential
 * @example
 * note("g1*4")
 * .s("sine").pdec(.5)
 * .penv(32)
 * .pcurve("<0 1>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1036,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Curve of envelope. Defaults to linear. exponential is good for kicks</p>",
    name: "pcurve",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>0 = linear, 1 = exponential</p>",
        name: "type"
      }
    ],
    examples: [
      `note("g1*4")
.s("sine").pdec(.5)
.penv(32)
.pcurve("<0 1>")`
    ],
    longname: "pcurve",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the range anchor of the envelope:
 * - anchor 0: range = [note, note + penv]
 * - anchor 1: range = [note - penv, note]
 * If you don't set an anchor, the value will default to the psustain value.
 *
 * @name panchor
 * @param {number | Pattern} anchor anchor offset
 * @example
 * note("c c4").penv(12).panchor("<0 .5 1 .5>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1049,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the range anchor of the envelope:</p>
<ul>
<li>anchor 0: range = [note, note + penv]</li>
<li>anchor 1: range = [note - penv, note]
If you don't set an anchor, the value will default to the psustain value.</li>
</ul>`,
    name: "panchor",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>anchor offset</p>",
        name: "anchor"
      }
    ],
    examples: [
      'note("c c4").penv(12).panchor("<0 .5 1 .5>")'
    ],
    longname: "panchor",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Emulation of a Leslie speaker: speakers rotating in a wooden amplified cabinet.
 *
 * @name leslie
 * @param {number | Pattern} wet between 0 and 1
 * @example
 * n("0,4,7").s("supersquare").leslie("<0 .4 .6 1>").osc()
 * @superdirtOnly
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1073,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Emulation of a Leslie speaker: speakers rotating in a wooden amplified cabinet.</p>",
    name: "leslie",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "wet"
      }
    ],
    examples: [
      'n("0,4,7").s("supersquare").leslie("<0 .4 .6 1>").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "leslie",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Rate of modulation / rotation for leslie effect
 *
 * @name lrate
 * @param {number | Pattern} rate 6.7 for fast, 0.7 for slow
 * @example
 * n("0,4,7").s("supersquare").leslie(1).lrate("<1 2 4 8>").osc()
 * @superdirtOnly
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1084,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Rate of modulation / rotation for leslie effect</p>",
    name: "lrate",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>6.7 for fast, 0.7 for slow</p>",
        name: "rate"
      }
    ],
    examples: [
      'n("0,4,7").s("supersquare").leslie(1).lrate("<1 2 4 8>").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "lrate",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Physical size of the cabinet in meters. Be careful, it might be slightly larger than your computer. Affects the Doppler amount (pitch warble)
 *
 * @name lsize
 * @param {number | Pattern} meters somewhere between 0 and 1
 * @example
 * n("0,4,7").s("supersquare").leslie(1).lrate(2).lsize("<.1 .5 1>").osc()
 * @superdirtOnly
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1096,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Physical size of the cabinet in meters. Be careful, it might be slightly larger than your computer. Affects the Doppler amount (pitch warble)</p>",
    name: "lsize",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>somewhere between 0 and 1</p>",
        name: "meters"
      }
    ],
    examples: [
      'n("0,4,7").s("supersquare").leslie(1).lrate(2).lsize("<.1 .5 1>").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "lsize",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the displayed text for an event on the pianoroll
 *
 * @name label
 * @param {string} label text to display
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1107,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the displayed text for an event on the pianoroll</p>",
    name: "label",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>text to display</p>",
        name: "label"
      }
    ],
    longname: "label",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the default octave of a synth.
 *
 * @name octave
 * @param {number | Pattern} octave octave number
 * @example
 * n("0,4,7").s('supersquare').octave("<3 4 5 6>").osc()
 * @superDirtOnly
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1143,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the default octave of a synth.</p>",
    name: "octave",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>octave number</p>",
        name: "octave"
      }
    ],
    examples: [
      `n("0,4,7").s('supersquare').octave("<3 4 5 6>").osc()`
    ],
    tags: [
      {
        originalTitle: "superDirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "octave",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * An \`orbit\` is a global parameter context for patterns. Patterns with the same orbit will share the same global effects.
 *
 * @name orbit
 * @param {number | Pattern} number
 * @example
 * stack(
 *   s("hh*6").delay(.5).delaytime(.25).orbit(1),
 *   s("~ sd ~ sd").delay(.5).delaytime(.125).orbit(2)
 * )
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1156,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>An <code>orbit</code> is a global parameter context for patterns. Patterns with the same orbit will share the same global effects.</p>",
    name: "orbit",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "number"
      }
    ],
    examples: [
      `stack(
  s("hh*6").delay(.5).delaytime(.25).orbit(1),
  s("~ sd ~ sd").delay(.5).delaytime(.125).orbit(2)
)`
    ],
    longname: "orbit",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets position in stereo.
 *
 * @name pan
 * @param {number | Pattern} pan between 0 and 1, from left to right (assuming stereo), once round a circle (assuming multichannel)
 * @example
 * s("[bd hh]*2").pan("<.5 1 .5 0>")
 * @example
 * s("bd rim sd rim bd ~ cp rim").pan(sine.slow(2))
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1172,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets position in stereo.</p>",
    name: "pan",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1, from left to right (assuming stereo), once round a circle (assuming multichannel)</p>",
        name: "pan"
      }
    ],
    examples: [
      's("[bd hh]*2").pan("<.5 1 .5 0>")',
      's("bd rim sd rim bd ~ cp rim").pan(sine.slow(2))'
    ],
    longname: "pan",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the level of reverb.
 *
 * When using mininotation, you can also optionally add the 'size' parameter, separated by ':'.
 *
 * @name room
 * @param {number | Pattern} level between 0 and 1
 * @example
 * s("bd sd [~ bd] sd").room("<0 .2 .4 .6 .8 1>")
 * @example
 * s("bd sd [~ bd] sd").room("<0.9:1 0.9:4>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1235,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the level of reverb.</p>
<p>When using mininotation, you can also optionally add the 'size' parameter, separated by ':'.</p>`,
    name: "room",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "level"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd").room("<0 .2 .4 .6 .8 1>")',
      's("bd sd [~ bd] sd").room("<0.9:1 0.9:4>")'
    ],
    longname: "room",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Reverb lowpass starting frequency (in hertz).
 * When this property is changed, the reverb will be recaculated, so only change this sparsely..
 *
 * @name roomlp
 * @synonyms rlp
 * @param {number} frequency between 0 and 20000hz
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(10000)
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(5000)
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1249,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Reverb lowpass starting frequency (in hertz).
When this property is changed, the reverb will be recaculated, so only change this sparsely..</p>`,
    name: "roomlp",
    synonyms_text: "rlp",
    synonyms: [
      "rlp"
    ],
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>between 0 and 20000hz</p>",
        name: "frequency"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd").room(0.5).rlp(10000)',
      's("bd sd [~ bd] sd").room(0.5).rlp(5000)'
    ],
    longname: "roomlp",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Reverb lowpass frequency at -60dB (in hertz).
 * When this property is changed, the reverb will be recaculated, so only change this sparsely..
 *
 * @name roomdim
 * @synonyms rdim
 * @param {number} frequency between 0 and 20000hz
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(10000).rdim(8000)
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(5000).rdim(400)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1262,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Reverb lowpass frequency at -60dB (in hertz).
When this property is changed, the reverb will be recaculated, so only change this sparsely..</p>`,
    name: "roomdim",
    synonyms_text: "rdim",
    synonyms: [
      "rdim"
    ],
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>between 0 and 20000hz</p>",
        name: "frequency"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd").room(0.5).rlp(10000).rdim(8000)',
      's("bd sd [~ bd] sd").room(0.5).rlp(5000).rdim(400)'
    ],
    longname: "roomdim",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Reverb fade time (in seconds).
 * When this property is changed, the reverb will be recaculated, so only change this sparsely..
 *
 * @name roomfade
 * @synonyms rfade
 * @param {number} seconds for the reverb to fade
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(10000).rfade(0.5)
 * @example
 * s("bd sd [~ bd] sd").room(0.5).rlp(5000).rfade(4)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1276,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Reverb fade time (in seconds).
When this property is changed, the reverb will be recaculated, so only change this sparsely..</p>`,
    name: "roomfade",
    synonyms_text: "rfade",
    synonyms: [
      "rfade"
    ],
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>for the reverb to fade</p>",
        name: "seconds"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd").room(0.5).rlp(10000).rfade(0.5)',
      's("bd sd [~ bd] sd").room(0.5).rlp(5000).rfade(4)'
    ],
    longname: "roomfade",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the sample to use as an impulse response for the reverb.
 * @name iresponse
 * @param {string | Pattern} sample to use as an impulse response
 * @synonyms ir
 * @example
 * s("bd sd [~ bd] sd").room(.8).ir("<shaker_large:0 shaker_large:2>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1290,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the sample to use as an impulse response for the reverb.</p>",
    name: "iresponse",
    params: [
      {
        type: {
          names: [
            "string",
            "Pattern"
          ]
        },
        description: "<p>to use as an impulse response</p>",
        name: "sample"
      }
    ],
    synonyms_text: "ir",
    synonyms: [
      "ir"
    ],
    examples: [
      's("bd sd [~ bd] sd").room(.8).ir("<shaker_large:0 shaker_large:2>")'
    ],
    longname: "iresponse",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the room size of the reverb, see \`room\`.
 * When this property is changed, the reverb will be recaculated, so only change this sparsely..
 *
 * @name roomsize
 * @param {number | Pattern} size between 0 and 10
 * @synonyms rsize, sz, size
 * @example
 * s("bd sd [~ bd] sd").room(.8).rsize(1)
 * @example
 * s("bd sd [~ bd] sd").room(.8).rsize(4)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1300,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Sets the room size of the reverb, see <code>room</code>.
When this property is changed, the reverb will be recaculated, so only change this sparsely..</p>`,
    name: "roomsize",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 10</p>",
        name: "size"
      }
    ],
    synonyms_text: "rsize, sz, size",
    synonyms: [
      "rsize",
      "sz",
      "size"
    ],
    examples: [
      's("bd sd [~ bd] sd").room(.8).rsize(1)',
      's("bd sd [~ bd] sd").room(.8).rsize(4)'
    ],
    longname: "roomsize",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * (Deprecated) Wave shaping distortion. WARNING: can suddenly get unpredictably loud.
 * Please use distort instead, which has a more predictable response curve
 * second option in optional array syntax (ex: ".9:.5") applies a postgain to the output
 *
 *
 * @name shape
 * @param {number | Pattern} distortion between 0 and 1
 * @example
 * s("bd sd [~ bd] sd,hh*8").shape("<0 .2 .4 .6 .8>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1321,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>(Deprecated) Wave shaping distortion. WARNING: can suddenly get unpredictably loud.
Please use distort instead, which has a more predictable response curve
second option in optional array syntax (ex: &quot;.9:.5&quot;) applies a postgain to the output</p>`,
    name: "shape",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>between 0 and 1</p>",
        name: "distortion"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").shape("<0 .2 .4 .6 .8>")'
    ],
    longname: "shape",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Wave shaping distortion. CAUTION: it can get loud.
 * Second option in optional array syntax (ex: ".9:.5") applies a postgain to the output.
 * Most useful values are usually between 0 and 10 (depending on source gain). If you are feeling adventurous, you can turn it up to 11 and beyond ;)
 *
 * @name distort
 * @synonyms dist
 * @param {number | Pattern} distortion
 * @example
 * s("bd sd [~ bd] sd,hh*8").distort("<0 2 3 10:.5>")
 * @example
 * note("d1!8").s("sine").penv(36).pdecay(.12).decay(.23).distort("8:.4")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1334,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Wave shaping distortion. CAUTION: it can get loud.
Second option in optional array syntax (ex: &quot;.9:.5&quot;) applies a postgain to the output.
Most useful values are usually between 0 and 10 (depending on source gain). If you are feeling adventurous, you can turn it up to 11 and beyond ;)</p>`,
    name: "distort",
    synonyms_text: "dist",
    synonyms: [
      "dist"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        name: "distortion"
      }
    ],
    examples: [
      's("bd sd [~ bd] sd,hh*8").distort("<0 2 3 10:.5>")',
      'note("d1!8").s("sine").penv(36).pdecay(.12).decay(.23).distort("8:.4")'
    ],
    longname: "distort",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Dynamics Compressor. The params are \`compressor("threshold:ratio:knee:attack:release")\`
 * More info [here](https://developer.mozilla.org/en-US/docs/Web/API/DynamicsCompressorNode?retiredLocale=de#instance_properties)
 *
 * @name compressor
 * @example
 * s("bd sd [~ bd] sd,hh*8")
 * .compressor("-20:20:10:.002:.02")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1349,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Dynamics Compressor. The params are <code>compressor(&quot;threshold:ratio:knee:attack:release&quot;)</code>
More info <a href="https://developer.mozilla.org/en-US/docs/Web/API/DynamicsCompressorNode?retiredLocale=de#instance_properties">here</a></p>`,
    name: "compressor",
    examples: [
      `s("bd sd [~ bd] sd,hh*8")
.compressor("-20:20:10:.002:.02")`
    ],
    longname: "compressor",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Changes the speed of sample playback, i.e. a cheap way of changing pitch.
 *
 * @name speed
 * @param {number | Pattern} speed -inf to inf, negative numbers play the sample backwards.
 * @example
 * s("bd*6").speed("1 2 4 1 -2 -4")
 * @example
 * speed("1 1.5*2 [2 1.1]").s("piano").clip(1)
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1370,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Changes the speed of sample playback, i.e. a cheap way of changing pitch.</p>",
    name: "speed",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>inf to inf, negative numbers play the sample backwards.</p>",
        name: "speed"
      }
    ],
    examples: [
      's("bd*6").speed("1 2 4 1 -2 -4")',
      'speed("1 1.5*2 [2 1.1]").s("piano").clip(1)'
    ],
    longname: "speed",
    kind: "member",
    scope: "global"
  },
  {
    comment: '/**\n * Used in conjunction with `speed`, accepts values of "r" (rate, default behavior), "c" (cycles), or "s" (seconds). Using `unit "c"` means `speed` will be interpreted in units of cycles, e.g. `speed "1"` means samples will be stretched to fill a cycle. Using `unit "s"` means the playback speed will be adjusted so that the duration is the number of seconds specified by `speed`.\n *\n * @name unit\n * @param {number | string | Pattern} unit see description above\n * @example\n * speed("1 2 .5 3").s("bd").unit("c").osc()\n * @superdirtOnly\n *\n */',
    meta: {
      filename: "controls.mjs",
      lineno: 1382,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Used in conjunction with <code>speed</code>, accepts values of &quot;r&quot; (rate, default behavior), &quot;c&quot; (cycles), or &quot;s&quot; (seconds). Using <code>unit &quot;c&quot;</code> means <code>speed</code> will be interpreted in units of cycles, e.g. <code>speed &quot;1&quot;</code> means samples will be stretched to fill a cycle. Using <code>unit &quot;s&quot;</code> means the playback speed will be adjusted so that the duration is the number of seconds specified by <code>speed</code>.</p>",
    name: "unit",
    params: [
      {
        type: {
          names: [
            "number",
            "string",
            "Pattern"
          ]
        },
        description: "<p>see description above</p>",
        name: "unit"
      }
    ],
    examples: [
      'speed("1 2 .5 3").s("bd").unit("c").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "unit",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Made by Calum Gunn. Reminiscent of some weird mixture of filter, ring-modulator and pitch-shifter. The SuperCollider manual defines Squiz as:
 *
 * "A simplistic pitch-raising algorithm. It's not meant to sound natural; its sound is reminiscent of some weird mixture of filter, ring-modulator and pitch-shifter, depending on the input. The algorithm works by cutting the signal into fragments (delimited by upwards-going zero-crossings) and squeezing those fragments in the time domain (i.e. simply playing them back faster than they came in), leaving silences inbetween. All the parameters apart from memlen can be modulated."
 *
 * @name squiz
 * @param {number | Pattern} squiz Try passing multiples of 2 to it - 2, 4, 8 etc.
 * @example
 * squiz("2 4/2 6 [8 16]").s("bd").osc()
 * @superdirtOnly
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1393,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Made by Calum Gunn. Reminiscent of some weird mixture of filter, ring-modulator and pitch-shifter. The SuperCollider manual defines Squiz as:</p>
<p>&quot;A simplistic pitch-raising algorithm. It's not meant to sound natural; its sound is reminiscent of some weird mixture of filter, ring-modulator and pitch-shifter, depending on the input. The algorithm works by cutting the signal into fragments (delimited by upwards-going zero-crossings) and squeezing those fragments in the time domain (i.e. simply playing them back faster than they came in), leaving silences inbetween. All the parameters apart from memlen can be modulated.&quot;</p>`,
    name: "squiz",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>Try passing multiples of 2 to it - 2, 4, 8 etc.</p>",
        name: "squiz"
      }
    ],
    examples: [
      'squiz("2 4/2 6 [8 16]").s("bd").osc()'
    ],
    tags: [
      {
        originalTitle: "superdirtOnly",
        title: "superdirtonly",
        text: ""
      }
    ],
    longname: "squiz",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *
 * Formant filter to make things sound like vowels.
 *
 * @name vowel
 * @param {string | Pattern} vowel You can use a e i o u ae aa oe ue y uh un en an on, corresponding to [a] [e] [i] [o] [u] [æ] [ɑ] [ø] [y] [ɯ] [ʌ] [œ̃] [ɛ̃] [ɑ̃] [ɔ̃]. Aliases: aa = å = ɑ, oe = ø = ö, y = ı, ae = æ.
 * @example
 * note("[c2 <eb2 <g2 g1>>]*2").s('sawtooth')
 * .vowel("<a e i <o u>>")
 * @example
 * s("bd sd mt ht bd [~ cp] ht lt").vowel("[a|e|i|o|u]")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1418,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Formant filter to make things sound like vowels.</p>",
    name: "vowel",
    params: [
      {
        type: {
          names: [
            "string",
            "Pattern"
          ]
        },
        description: "<p>You can use a e i o u ae aa oe ue y uh un en an on, corresponding to [a] [e] [i] [o] [u] [æ] [ɑ] [ø] [y] [ɯ] [ʌ] [œ̃] [ɛ̃] [ɑ̃] [ɔ̃]. Aliases: aa = å = ɑ, oe = ø = ö, y = ı, ae = æ.</p>",
        name: "vowel"
      }
    ],
    examples: [
      `note("[c2 <eb2 <g2 g1>>]*2").s('sawtooth')
.vowel("<a e i <o u>>")`,
      's("bd sd mt ht bd [~ cp] ht lt").vowel("[a|e|i|o|u]")'
    ],
    longname: "vowel",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Multiplies the duration with the given number. Also cuts samples off at the end if they exceed the duration.
 *
 * @name clip
 * @synonyms legato
 * @param {number | Pattern} factor >= 0
 * @example
 * note("c a f e").s("piano").clip("<.5 1 2>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1514,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Multiplies the duration with the given number. Also cuts samples off at the end if they exceed the duration.</p>",
    name: "clip",
    synonyms_text: "legato",
    synonyms: [
      "legato"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: `<blockquote>
<p>= 0</p>
</blockquote>`,
        name: "factor"
      }
    ],
    examples: [
      'note("c a f e").s("piano").clip("<.5 1 2>")'
    ],
    longname: "clip",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the duration of the event in cycles. Similar to clip / legato, it also cuts samples off at the end if they exceed the duration.
 *
 * @name duration
 * @synonyms dur
 * @param {number | Pattern} seconds >= 0
 * @example
 * note("c a f e").s("piano").dur("<.5 1 2>")
 *
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1526,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the duration of the event in cycles. Similar to clip / legato, it also cuts samples off at the end if they exceed the duration.</p>",
    name: "duration",
    synonyms_text: "dur",
    synonyms: [
      "dur"
    ],
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: `<blockquote>
<p>= 0</p>
</blockquote>`,
        name: "seconds"
      }
    ],
    examples: [
      'note("c a f e").s("piano").dur("<.5 1 2>")'
    ],
    longname: "duration",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Sets the color of the hap in visualizations like pianoroll or highlighting.
 * @name color
 * @synonyms colour
 * @param {string} color Hexadecimal or CSS color name
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1556,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Sets the color of the hap in visualizations like pianoroll or highlighting.</p>",
    name: "color",
    synonyms_text: "colour",
    synonyms: [
      "colour"
    ],
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>Hexadecimal or CSS color name</p>",
        name: "color"
      }
    ],
    longname: "color",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * ADSR envelope: Combination of Attack, Decay, Sustain, and Release.
 *
 * @name adsr
 * @param {number | Pattern} time attack time in seconds
 * @param {number | Pattern} time decay time in seconds
 * @param {number | Pattern} gain sustain level (0 to 1)
 * @param {number | Pattern} time release time in seconds
 * @example
 * note("[c3 bb2 f3 eb3]*2").sound("sawtooth").lpf(600).adsr(".1:.1:.5:.2")
 */`,
    meta: {
      filename: "controls.mjs",
      lineno: 1569,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>ADSR envelope: Combination of Attack, Decay, Sustain, and Release.</p>",
    name: "adsr",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>attack time in seconds</p>",
        name: "time"
      },
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>decay time in seconds</p>",
        name: "time"
      },
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>sustain level (0 to 1)</p>",
        name: "gain"
      },
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>release time in seconds</p>",
        name: "time"
      }
    ],
    examples: [
      'note("[c3 bb2 f3 eb3]*2").sound("sawtooth").lpf(600).adsr(".1:.1:.5:.2")'
    ],
    longname: "adsr",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Intended for a debugging, drawLine renders the pattern as a string, where each character represents the same time span.
 * Should only be used with single characters as values, otherwise the character slots will be messed up.
 * Character legend:
 *
 * - "|" cycle separator
 * - "-" hold previous value
 * - "." silence
 *
 * @param {Pattern} pattern the pattern to use
 * @param {number} chars max number of characters (approximately)
 * @returns string
 * @example
 * const line = drawLine("0 [1 2 3]", 10); // |0--123|0--123
 * console.log(line);
 * silence;
 */`,
    meta: {
      range: [
        1426,
        2796
      ],
      filename: "drawLine.mjs",
      lineno: 26,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100010638",
        name: "drawLine",
        type: "FunctionDeclaration",
        paramnames: [
          "pat",
          "chars"
        ]
      },
      vars: {
        cycle: "drawLine~cycle",
        pos: "drawLine~pos",
        lines: "drawLine~lines",
        emptyLine: "drawLine~emptyLine",
        haps: "drawLine~haps",
        durations: "drawLine~durations",
        "": null,
        charFraction: "drawLine~charFraction",
        totalSlots: "drawLine~totalSlots",
        i: "drawLine~i",
        undefined: null,
        matches: "drawLine~matches",
        missingLines: "drawLine~missingLines"
      }
    },
    description: `<p>Intended for a debugging, drawLine renders the pattern as a string, where each character represents the same time span.
Should only be used with single characters as values, otherwise the character slots will be messed up.
Character legend:</p>
<ul>
<li>&quot;|&quot; cycle separator</li>
<li>&quot;-&quot; hold previous value</li>
<li>&quot;.&quot; silence</li>
</ul>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        description: "<p>the pattern to use</p>",
        name: "pattern"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>max number of characters (approximately)</p>",
        name: "chars"
      }
    ],
    returns: [
      {
        description: "<p>string</p>"
      }
    ],
    examples: [
      `const line = drawLine("0 [1 2 3]", 10); // |0--123|0--123
console.log(line);
silence;`
    ],
    name: "drawLine",
    longname: "drawLine",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/**
 * Changes the structure of the pattern to form an euclidean rhythm.
 * Euclidian rhythms are rhythms obtained using the greatest common
 * divisor of two numbers.  They were described in 2004 by Godfried
 * Toussaint, a canadian computer scientist.  Euclidian rhythms are
 * really useful for computer/algorithmic music because they can
 * describe a large number of rhythms with a couple of numbers.
 *
 * @memberof Pattern
 * @name euclid
 * @param {number} pulses the number of onsets / beats
 * @param {number} steps the number of steps to fill
 * @returns Pattern
 * @example
 * // The Cuban tresillo pattern.
 * note("c3").euclid(3,8)
 */`,
    meta: {
      filename: "euclid.mjs",
      lineno: 57,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Changes the structure of the pattern to form an euclidean rhythm.
Euclidian rhythms are rhythms obtained using the greatest common
divisor of two numbers.  They were described in 2004 by Godfried
Toussaint, a canadian computer scientist.  Euclidian rhythms are
really useful for computer/algorithmic music because they can
describe a large number of rhythms with a couple of numbers.</p>`,
    memberof: "Pattern",
    name: "euclid",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of onsets / beats</p>",
        name: "pulses"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of steps to fill</p>",
        name: "steps"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `// The Cuban tresillo pattern.
note("c3").euclid(3,8)`
    ],
    scope: "static",
    longname: "Pattern.euclid",
    kind: "member"
  },
  {
    comment: `/**
 * Like \`euclid\`, but has an additional parameter for 'rotating' the resulting sequence.
 * @memberof Pattern
 * @name euclidRot
 * @param {number} pulses the number of onsets / beats
 * @param {number} steps the number of steps to fill
 * @param {number} rotation offset in steps
 * @returns Pattern
 * @example
 * // A Samba rhythm necklace from Brazil
 * note("c3").euclidRot(3,16,14)
 */`,
    meta: {
      filename: "euclid.mjs",
      lineno: 75,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like <code>euclid</code>, but has an additional parameter for 'rotating' the resulting sequence.</p>",
    memberof: "Pattern",
    name: "euclidRot",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of onsets / beats</p>",
        name: "pulses"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of steps to fill</p>",
        name: "steps"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>offset in steps</p>",
        name: "rotation"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `// A Samba rhythm necklace from Brazil
note("c3").euclidRot(3,16,14)`
    ],
    scope: "static",
    longname: "Pattern.euclidRot",
    kind: "member"
  },
  {
    comment: `/**
 * @example // A thirteenth century Persian rhythm called Khafif-e-ramal.
 * note("c3").euclid(2,5)
 * @example // The archetypal pattern of the Cumbia from Colombia, as well as a Calypso rhythm from Trinidad.
 * note("c3").euclid(3,4)
 * @example // Another thirteenth century Persian rhythm by the name of Khafif-e-ramal, as well as a Rumanian folk-dance rhythm.
 * note("c3").euclidRot(3,5,2)
 * @example // A Ruchenitza rhythm used in a Bulgarian folk-dance.
 * note("c3").euclid(3,7)
 * @example // The Cuban tresillo pattern.
 * note("c3").euclid(3,8)
 * @example // Another Ruchenitza Bulgarian folk-dance rhythm.
 * note("c3").euclid(4,7)
 * @example // The Aksak rhythm of Turkey.
 * note("c3").euclid(4,9)
 * @example // The metric pattern used by Frank Zappa in his piece titled Outside Now.
 * note("c3").euclid(4,11)
 * @example // Yields the York-Samai pattern, a popular Arab rhythm.
 * note("c3").euclid(5,6)
 * @example // The Nawakhat pattern, another popular Arab rhythm.
 * note("c3").euclid(5,7)
 * @example // The Cuban cinquillo pattern.
 * note("c3").euclid(5,8)
 * @example // A popular Arab rhythm called Agsag-Samai.
 * note("c3").euclid(5,9)
 * @example // The metric pattern used by Moussorgsky in Pictures at an Exhibition.
 * note("c3").euclid(5,11)
 * @example // The Venda clapping pattern of a South African children’s song.
 * note("c3").euclid(5,12)
 * @example // The Bossa-Nova rhythm necklace of Brazil.
 * note("c3").euclid(5,16)
 * @example // A typical rhythm played on the Bendir (frame drum).
 * note("c3").euclid(7,8)
 * @example // A common West African bell pattern.
 * note("c3").euclid(7,12)
 * @example // A Samba rhythm necklace from Brazil.
 * note("c3").euclidRot(7,16,14)
 * @example // A rhythm necklace used in the Central African Republic.
 * note("c3").euclid(9,16)
 * @example // A rhythm necklace of the Aka Pygmies of Central Africa.
 * note("c3").euclidRot(11,24,14)
 * @example // Another rhythm necklace of the Aka Pygmies of the upper Sangha.
 * note("c3").euclidRot(13,24,5)
 */`,
    meta: {
      range: [
        5273,
        5425
      ],
      filename: "euclid.mjs",
      lineno: 133,
      columnno: 6,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100011142",
        name: "_euclidRot",
        type: "FunctionExpression"
      },
      vars: {
        b: "_euclidRot~b"
      }
    },
    examples: [
      `// A thirteenth century Persian rhythm called Khafif-e-ramal.
note("c3").euclid(2,5)`,
      `// The archetypal pattern of the Cumbia from Colombia, as well as a Calypso rhythm from Trinidad.
note("c3").euclid(3,4)`,
      `// Another thirteenth century Persian rhythm by the name of Khafif-e-ramal, as well as a Rumanian folk-dance rhythm.
note("c3").euclidRot(3,5,2)`,
      `// A Ruchenitza rhythm used in a Bulgarian folk-dance.
note("c3").euclid(3,7)`,
      `// The Cuban tresillo pattern.
note("c3").euclid(3,8)`,
      `// Another Ruchenitza Bulgarian folk-dance rhythm.
note("c3").euclid(4,7)`,
      `// The Aksak rhythm of Turkey.
note("c3").euclid(4,9)`,
      `// The metric pattern used by Frank Zappa in his piece titled Outside Now.
note("c3").euclid(4,11)`,
      `// Yields the York-Samai pattern, a popular Arab rhythm.
note("c3").euclid(5,6)`,
      `// The Nawakhat pattern, another popular Arab rhythm.
note("c3").euclid(5,7)`,
      `// The Cuban cinquillo pattern.
note("c3").euclid(5,8)`,
      `// A popular Arab rhythm called Agsag-Samai.
note("c3").euclid(5,9)`,
      `// The metric pattern used by Moussorgsky in Pictures at an Exhibition.
note("c3").euclid(5,11)`,
      `// The Venda clapping pattern of a South African children’s song.
note("c3").euclid(5,12)`,
      `// The Bossa-Nova rhythm necklace of Brazil.
note("c3").euclid(5,16)`,
      `// A typical rhythm played on the Bendir (frame drum).
note("c3").euclid(7,8)`,
      `// A common West African bell pattern.
note("c3").euclid(7,12)`,
      `// A Samba rhythm necklace from Brazil.
note("c3").euclidRot(7,16,14)`,
      `// A rhythm necklace used in the Central African Republic.
note("c3").euclid(9,16)`,
      `// A rhythm necklace of the Aka Pygmies of Central Africa.
note("c3").euclidRot(11,24,14)`,
      `// Another rhythm necklace of the Aka Pygmies of the upper Sangha.
note("c3").euclidRot(13,24,5)`
    ],
    name: "_euclidRot",
    longname: "_euclidRot",
    kind: "function",
    scope: "global",
    params: []
  },
  {
    comment: `/**
 * Similar to \`euclid\`, but each pulse is held until the next pulse,
 * so there will be no gaps.
 * @name euclidLegato
 * @memberof Pattern
 * @param {number} pulses the number of onsets / beats
 * @param {number} steps the number of steps to fill
 * @example
 * note("c3").euclidLegato(3,8)
 */`,
    meta: {
      filename: "euclid.mjs",
      lineno: 149,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Similar to <code>euclid</code>, but each pulse is held until the next pulse,
so there will be no gaps.</p>`,
    name: "euclidLegato",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of onsets / beats</p>",
        name: "pulses"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of steps to fill</p>",
        name: "steps"
      }
    ],
    examples: [
      'note("c3").euclidLegato(3,8)'
    ],
    scope: "static",
    longname: "Pattern.euclidLegato",
    kind: "member"
  },
  {
    comment: `/**
 * Similar to \`euclid\`, but each pulse is held until the next pulse,
 * so there will be no gaps, and has an additional parameter for 'rotating'
 * the resulting sequence
 * @name euclidLegatoRot
 * @memberof Pattern
 * @param {number} pulses the number of onsets / beats
 * @param {number} steps the number of steps to fill
 * @param {number} rotation offset in steps
 * @example
 * note("c3").euclidLegatoRot(3,5,2)
 */`,
    meta: {
      filename: "euclid.mjs",
      lineno: 177,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Similar to <code>euclid</code>, but each pulse is held until the next pulse,
so there will be no gaps, and has an additional parameter for 'rotating'
the resulting sequence</p>`,
    name: "euclidLegatoRot",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of onsets / beats</p>",
        name: "pulses"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>the number of steps to fill</p>",
        name: "steps"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>offset in steps</p>",
        name: "rotation"
      }
    ],
    examples: [
      'note("c3").euclidLegatoRot(3,5,2)'
    ],
    scope: "static",
    longname: "Pattern.euclidLegatoRot",
    kind: "member"
  },
  {
    comment: "/** @class Class representing a pattern. */",
    meta: {
      range: [
        1674,
        26574
      ],
      filename: "pattern.mjs",
      lineno: 42,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100013715",
        name: "exports.Pattern",
        type: "ClassDeclaration"
      }
    },
    name: "Pattern",
    longname: "Pattern",
    kind: "class",
    classdesc: "<p>Class representing a pattern.</p>",
    scope: "global",
    description: "<p>Create a pattern. As an end user, you will most likely not create a Pattern directly.</p>",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>The function that maps a <code>State</code> to an array of <code>Hap</code>.</p>",
        name: "query"
      }
    ]
  },
  {
    comment: `/**
   * Returns a new pattern, with the function applied to the value of
   * each hap. It has the alias \`fmap\`.
   * @synonyms fmap
   * @param {Function} func to to apply to the value
   * @returns Pattern
   * @example
   * "0 1 2".withValue(v => v + 10).log()
   */`,
    meta: {
      range: [
        2994,
        3163
      ],
      filename: "pattern.mjs",
      lineno: 91,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100013823",
        name: "Pattern#withValue",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, with the function applied to the value of
each hap. It has the alias <code>fmap</code>.</p>`,
    synonyms_text: "fmap",
    synonyms: [
      "fmap"
    ],
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>to to apply to the value</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"0 1 2".withValue(v => v + 10).log()'
    ],
    name: "withValue",
    longname: "Pattern#withValue",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * see \`withValue\`
   * @noAutocomplete
   */`,
    meta: {
      range: [
        3221,
        3270
      ],
      filename: "pattern.mjs",
      lineno: 101,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100013860",
        name: "Pattern#fmap",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>see <code>withValue</code></p>",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "fmap",
    longname: "Pattern#fmap",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Assumes 'this' is a pattern of functions, and given a function to
   * resolve wholes, applies a given pattern of values to that
   * pattern of functions.
   * @param {Function} whole_func
   * @param {Function} func
   * @noAutocomplete
   * @returns Pattern
   */`,
    meta: {
      range: [
        3552,
        4294
      ],
      filename: "pattern.mjs",
      lineno: 114,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100013871",
        name: "Pattern#appWhole",
        type: "MethodDefinition",
        paramnames: [
          "whole_func",
          "pat_val"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Assumes 'this' is a pattern of functions, and given a function to
resolve wholes, applies a given pattern of values to that
pattern of functions.</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "whole_func"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    name: "appWhole",
    longname: "Pattern#appWhole",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * When this method is called on a pattern of functions, it matches its haps
   * with those in the given pattern of values.  A new pattern is returned, with
   * each matching value applied to the corresponding function.
   *
   * In this \`_appBoth\` variant, where timespans of the function and value haps
   * are not the same but do intersect, the resulting hap has a timespan of the
   * intersection. This applies to both the part and the whole timespan.
   * @param {Pattern} pat_val
   * @noAutocomplete
   * @returns Pattern
   */`,
    meta: {
      range: [
        4845,
        5270
      ],
      filename: "pattern.mjs",
      lineno: 150,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100013978",
        name: "Pattern#appBoth",
        type: "MethodDefinition",
        paramnames: [
          "pat_val"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>When this method is called on a pattern of functions, it matches its haps
with those in the given pattern of values.  A new pattern is returned, with
each matching value applied to the corresponding function.</p>
<p>In this <code>_appBoth</code> variant, where timespans of the function and value haps
are not the same but do intersect, the resulting hap has a timespan of the
intersection. This applies to both the part and the whole timespan.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat_val"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    name: "appBoth",
    longname: "Pattern#appBoth",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`appBoth\`, but the \`whole\` timespan is not the intersection,
   * but the timespan from the function of patterns that this method is called
   * on. In practice, this means that the pattern structure, including onsets,
   * are preserved from the pattern of functions (often referred to as the left
   * hand or inner pattern).
   * @param {Pattern} pat_val
   * @noAutocomplete
   * @returns Pattern
   */`,
    meta: {
      range: [
        5700,
        6504
      ],
      filename: "pattern.mjs",
      lineno: 177,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014038",
        name: "Pattern#appLeft",
        type: "MethodDefinition",
        paramnames: [
          "pat_val"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>As with <code>appBoth</code>, but the <code>whole</code> timespan is not the intersection,
but the timespan from the function of patterns that this method is called
on. In practice, this means that the pattern structure, including onsets,
are preserved from the pattern of functions (often referred to as the left
hand or inner pattern).</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat_val"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    name: "appLeft",
    longname: "Pattern#appLeft",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`appLeft\`, but \`whole\` timespans are instead taken from the
   * pattern of values, i.e. structure is preserved from the right hand/outer
   * pattern.
   * @param {Pattern} pat_val
   * @noAutocomplete
   * @returns Pattern
   */`,
    meta: {
      range: [
        6758,
        7566
      ],
      filename: "pattern.mjs",
      lineno: 210,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014160",
        name: "Pattern#appRight",
        type: "MethodDefinition",
        paramnames: [
          "pat_val"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>As with <code>appLeft</code>, but <code>whole</code> timespans are instead taken from the
pattern of values, i.e. structure is preserved from the right hand/outer
pattern.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat_val"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    name: "appRight",
    longname: "Pattern#appRight",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Query haps inside the given time span.
   *
   * @param {Fraction | number} begin from time
   * @param {Fraction | number} end to time
   * @returns Hap[]
   * @example
   * const pattern = sequence('a', ['b', 'c'])
   * const haps = pattern.queryArc(0, 1)
   * console.log(haps)
   * silence
   * @noAutocomplete
   */`,
    meta: {
      range: [
        13012,
        13228
      ],
      filename: "pattern.mjs",
      lineno: 397,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014796",
        name: "Pattern#queryArc",
        type: "MethodDefinition",
        paramnames: [
          "begin",
          "end",
          "controls"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Query haps inside the given time span.</p>",
    params: [
      {
        type: {
          names: [
            "Fraction",
            "number"
          ]
        },
        description: "<p>from time</p>",
        name: "begin"
      },
      {
        type: {
          names: [
            "Fraction",
            "number"
          ]
        },
        description: "<p>to time</p>",
        name: "end"
      }
    ],
    returns: [
      {
        description: "<p>Hap[]</p>"
      }
    ],
    examples: [
      `const pattern = sequence('a', ['b', 'c'])
const haps = pattern.queryArc(0, 1)
console.log(haps)
silence`
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "queryArc",
    longname: "Pattern#queryArc",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern, with queries split at cycle boundaries. This makes
   * some calculations easier to express, as all haps are then constrained to
   * happen within a cycle.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        13472,
        13672
      ],
      filename: "pattern.mjs",
      lineno: 413,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014832",
        name: "Pattern#splitQueries",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, with queries split at cycle boundaries. This makes
some calculations easier to express, as all haps are then constrained to
happen within a cycle.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "splitQueries",
    longname: "Pattern#splitQueries",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Returns a new pattern, where the given function is applied to the query
   * timespan before passing it to the original pattern.
   * @param {Function} func the function to apply
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        13915,
        14009
      ],
      filename: "pattern.mjs",
      lineno: 428,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014872",
        name: "Pattern#withQuerySpan",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, where the given function is applied to the query
timespan before passing it to the original pattern.</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withQuerySpan",
    longname: "Pattern#withQuerySpan",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`withQuerySpan\`, but the function is applied to both the
   * begin and end time of the query timespan.
   * @param {Function} func the function to apply
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        14469,
        14588
      ],
      filename: "pattern.mjs",
      lineno: 450,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014928",
        name: "Pattern#withQueryTime",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>As with <code>withQuerySpan</code>, but the function is applied to both the
begin and end time of the query timespan.</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withQueryTime",
    longname: "Pattern#withQueryTime",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Similar to \`withQuerySpan\`, but the function is applied to the timespans
   * of all haps returned by pattern queries (both \`part\` timespans, and where
   * present, \`whole\` timespans).
   * @param {Function} func
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        14866,
        14976
      ],
      filename: "pattern.mjs",
      lineno: 462,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014953",
        name: "Pattern#withHapSpan",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Similar to <code>withQuerySpan</code>, but the function is applied to the timespans
of all haps returned by pattern queries (both <code>part</code> timespans, and where
present, <code>whole</code> timespans).</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withHapSpan",
    longname: "Pattern#withHapSpan",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`withHapSpan\`, but the function is applied to both the
   * begin and end time of the hap timespans.
   * @param {Function} func the function to apply
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        15199,
        15282
      ],
      filename: "pattern.mjs",
      lineno: 473,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014978",
        name: "Pattern#withHapTime",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>As with <code>withHapSpan</code>, but the function is applied to both the
begin and end time of the hap timespans.</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withHapTime",
    longname: "Pattern#withHapTime",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern with the given function applied to the list of haps returned by every query.
   * @param {Function} func
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        15473,
        15620
      ],
      filename: "pattern.mjs",
      lineno: 483,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100014995",
        name: "Pattern#withHaps",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Returns a new pattern with the given function applied to the list of haps returned by every query.</p>",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withHaps",
    longname: "Pattern#withHaps",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`withHaps\`, but applies the function to every hap, rather than every list of haps.
   * @param {Function} func
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        15803,
        15874
      ],
      filename: "pattern.mjs",
      lineno: 495,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015025",
        name: "Pattern#withHap",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>As with <code>withHaps</code>, but applies the function to every hap, rather than every list of haps.</p>",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withHap",
    longname: "Pattern#withHap",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern with the context field set to every hap set to the given value.
   * @param {*} context
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        16048,
        16132
      ],
      filename: "pattern.mjs",
      lineno: 505,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015042",
        name: "Pattern#setContext",
        type: "MethodDefinition",
        paramnames: [
          "context"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Returns a new pattern with the context field set to every hap set to the given value.</p>",
    params: [
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "context"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "setContext",
    longname: "Pattern#setContext",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern with the given function applied to the context field of every hap.
   * @param {Function} func
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        16313,
        16553
      ],
      filename: "pattern.mjs",
      lineno: 515,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015059",
        name: "Pattern#withContext",
        type: "MethodDefinition",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Returns a new pattern with the given function applied to the context field of every hap.</p>",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withContext",
    longname: "Pattern#withContext",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern with the context field of every hap set to an empty object.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        16699,
        16773
      ],
      filename: "pattern.mjs",
      lineno: 529,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015107",
        name: "Pattern#stripContext",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: "<p>Returns a new pattern with the context field of every hap set to an empty object.</p>",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "stripContext",
    longname: "Pattern#stripContext",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Returns a new pattern with the given location information added to the
   * context of every hap.
   * @param {Number} start start offset
   * @param {Number} end end offset
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        17011,
        17378
      ],
      filename: "pattern.mjs",
      lineno: 541,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015123",
        name: "Pattern#withLoc",
        type: "MethodDefinition",
        paramnames: [
          "start",
          "end"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern with the given location information added to the
context of every hap.</p>`,
    params: [
      {
        type: {
          names: [
            "Number"
          ]
        },
        description: "<p>start offset</p>",
        name: "start"
      },
      {
        type: {
          names: [
            "Number"
          ]
        },
        description: "<p>end offset</p>",
        name: "end"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "withLoc",
    longname: "Pattern#withLoc",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new Pattern, which only returns haps that meet the given test.
   * @param {Function} hap_test - a function which returns false for haps to be removed from the pattern
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        17620,
        17717
      ],
      filename: "pattern.mjs",
      lineno: 563,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015187",
        name: "Pattern#filterHaps",
        type: "MethodDefinition",
        paramnames: [
          "hap_test"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Returns a new Pattern, which only returns haps that meet the given test.</p>",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>a function which returns false for haps to be removed from the pattern</p>",
        name: "hap_test"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "filterHaps",
    longname: "Pattern#filterHaps",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * As with \`filterHaps\`, but the function is applied to values
   * inside haps.
   * @param {Function} value_test
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        17893,
        18039
      ],
      filename: "pattern.mjs",
      lineno: 574,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015206",
        name: "Pattern#filterValues",
        type: "MethodDefinition",
        paramnames: [
          "value_test"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>As with <code>filterHaps</code>, but the function is applied to values
inside haps.</p>`,
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "value_test"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "filterValues",
    longname: "Pattern#filterValues",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns a new pattern, with haps containing undefined values removed from
   * query results.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        18197,
        18278
      ],
      filename: "pattern.mjs",
      lineno: 584,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015237",
        name: "Pattern#removeUndefineds",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, with haps containing undefined values removed from
query results.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "removeUndefineds",
    longname: "Pattern#removeUndefineds",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Returns a new pattern, with all haps without onsets filtered out. A hap
   * with an onset is one with a \`whole\` timespan that begins at the same time
   * as its \`part\` timespan.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        18522,
        18787
      ],
      filename: "pattern.mjs",
      lineno: 595,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015251",
        name: "Pattern#onsetsOnly",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, with all haps without onsets filtered out. A hap
with an onset is one with a <code>whole</code> timespan that begins at the same time
as its <code>part</code> timespan.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "onsetsOnly",
    longname: "Pattern#onsetsOnly",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Returns a new pattern, with 'continuous' haps (those without 'whole'
   * timespans) removed from query results.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        18964,
        19098
      ],
      filename: "pattern.mjs",
      lineno: 608,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015266",
        name: "Pattern#discreteOnly",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, with 'continuous' haps (those without 'whole'
timespans) removed from query results.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "discreteOnly",
    longname: "Pattern#discreteOnly",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Combines adjacent haps with the same value and whole.  Only
   * intended for use in tests.
   * @noAutocomplete
   */`,
    meta: {
      range: [
        19232,
        20677
      ],
      filename: "pattern.mjs",
      lineno: 618,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015280",
        name: "Pattern#defragmentHaps",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Combines adjacent haps with the same value and whole.  Only
intended for use in tests.</p>`,
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "defragmentHaps",
    longname: "Pattern#defragmentHaps",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Queries the pattern for the first cycle, returning Haps. Mainly of use when
   * debugging a pattern.
   * @param {Boolean} with_context - set to true, otherwise the context field
   * will be stripped from the resulting haps.
   * @returns [Hap]
   * @noAutocomplete
   */`,
    meta: {
      range: [
        20966,
        21164
      ],
      filename: "pattern.mjs",
      lineno: 673,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015511",
        name: "Pattern#firstCycle",
        type: "MethodDefinition",
        paramnames: [
          "with_context"
        ]
      },
      vars: {
        "": null
      }
    },
    description: `<p>Queries the pattern for the first cycle, returning Haps. Mainly of use when
debugging a pattern.</p>`,
    params: [
      {
        type: {
          names: [
            "Boolean"
          ]
        },
        description: `<p>set to true, otherwise the context field
will be stripped from the resulting haps.</p>`,
        name: "with_context",
        defaultvalue: !1
      }
    ],
    returns: [
      {
        description: "<p>[Hap]</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "firstCycle",
    longname: "Pattern#firstCycle",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Accessor for a list of values returned by querying the first cycle.
   * @noAutocomplete
   */`,
    meta: {
      range: [
        21274,
        21356
      ],
      filename: "pattern.mjs",
      lineno: 685,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015548",
        name: "Pattern#firstCycleValues",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: "<p>Accessor for a list of values returned by querying the first cycle.</p>",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "firstCycleValues",
    longname: "Pattern#firstCycleValues",
    kind: "member",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * More human-readable version of the \`firstCycleValues\` accessor.
   * @noAutocomplete
   */`,
    meta: {
      range: [
        21462,
        21625
      ],
      filename: "pattern.mjs",
      lineno: 693,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015565",
        name: "Pattern#showFirstCycle",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: "<p>More human-readable version of the <code>firstCycleValues</code> accessor.</p>",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "showFirstCycle",
    longname: "Pattern#showFirstCycle",
    kind: "member",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Returns a new pattern, which returns haps sorted in temporal order. Mainly
   * of use when comparing two patterns for equality, in tests.
   * @returns Pattern
   * @noAutocomplete
   */`,
    meta: {
      range: [
        21828,
        22101
      ],
      filename: "pattern.mjs",
      lineno: 705,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100015603",
        name: "Pattern#sortHapsByPart",
        type: "MethodDefinition",
        paramnames: []
      },
      vars: {
        "": null
      }
    },
    description: `<p>Returns a new pattern, which returns haps sorted in temporal order. Mainly
of use when comparing two patterns for equality, in tests.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "sortHapsByPart",
    longname: "Pattern#sortHapsByPart",
    kind: "function",
    memberof: "Pattern",
    scope: "instance",
    params: []
  },
  {
    comment: `/**
   * Layers the result of the given function(s). Like \`superimpose\`, but without the original pattern:
   * @name layer
   * @memberof Pattern
   * @synonyms apply
   * @returns Pattern
   * @example
   * "<0 2 4 6 ~ 4 ~ 2 0!3 ~!5>*8"
   *   .layer(x=>x.add("0,2"))
   *   .scale('C minor').note()
   */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 759,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Layers the result of the given function(s). Like <code>superimpose</code>, but without the original pattern:</p>",
    name: "layer",
    memberof: "Pattern",
    synonyms_text: "apply",
    synonyms: [
      "apply"
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"<0 2 4 6 ~ 4 ~ 2 0!3 ~!5>*8"
  .layer(x=>x.add("0,2"))
  .scale('C minor').note()`
    ],
    scope: "static",
    longname: "Pattern.layer",
    kind: "member"
  },
  {
    comment: `/**
   * Superimposes the result of the given function(s) on top of the original pattern:
   * @name superimpose
   * @memberof Pattern
   * @returns Pattern
   * @example
   * "<0 2 4 6 ~ 4 ~ 2 0!3 ~!5>*8"
   *   .superimpose(x=>x.add(2))
   *   .scale('C minor').note()
   */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 774,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Superimposes the result of the given function(s) on top of the original pattern:</p>",
    name: "superimpose",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"<0 2 4 6 ~ 4 ~ 2 0!3 ~!5>*8"
  .superimpose(x=>x.add(2))
  .scale('C minor').note()`
    ],
    scope: "static",
    longname: "Pattern.superimpose",
    kind: "member"
  },
  {
    comment: `/**
   * Stacks the given pattern(s) to the current pattern.
   * @name stack
   * @memberof Pattern
   * @example
   * s("hh*4").stack(
   *   note("c4(5,8)")
   * )
   */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 791,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Stacks the given pattern(s) to the current pattern.</p>",
    name: "stack",
    memberof: "Pattern",
    examples: [
      `s("hh*4").stack(
  note("c4(5,8)")
)`
    ],
    scope: "static",
    longname: "Pattern.stack",
    kind: "member"
  },
  {
    comment: `/**
   * Appends the given pattern(s) to the current pattern.
   * @name seq
   * @memberof Pattern
   * @synonyms sequence, fastcat
   * @example
   * s("hh*4").seq(
   *   note("c4(5,8)")
   * )
   */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 808,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Appends the given pattern(s) to the current pattern.</p>",
    name: "seq",
    memberof: "Pattern",
    synonyms_text: "sequence, fastcat",
    synonyms: [
      "sequence",
      "fastcat"
    ],
    examples: [
      `s("hh*4").seq(
  note("c4(5,8)")
)`
    ],
    scope: "static",
    longname: "Pattern.seq",
    kind: "member"
  },
  {
    comment: `/**
   * Appends the given pattern(s) to the next cycle.
   * @name cat
   * @memberof Pattern
   * @synonyms slowcat
   * @example
   * s("hh*4").cat(
   *   note("c4(5,8)")
   * )
   */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 822,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Appends the given pattern(s) to the next cycle.</p>",
    name: "cat",
    memberof: "Pattern",
    synonyms_text: "slowcat",
    synonyms: [
      "slowcat"
    ],
    examples: [
      `s("hh*4").cat(
  note("c4(5,8)")
)`
    ],
    scope: "static",
    longname: "Pattern.cat",
    kind: "member"
  },
  {
    comment: `/**
 * Selects indices in in stacked notes.
 * @example
 * note("<[c,eb,g]!2 [c,f,ab] [d,f,ab]>")
 * .arpWith(haps => haps[2])
 * */`,
    meta: {
      range: [
        27544,
        27754
      ],
      filename: "pattern.mjs",
      lineno: 916,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016224",
        name: "Pattern.prototype.arpWith",
        type: "FunctionExpression",
        paramnames: [
          "func"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Selects indices in in stacked notes.</p>",
    examples: [
      `note("<[c,eb,g]!2 [c,f,ab] [d,f,ab]>")
.arpWith(haps => haps[2])`
    ],
    name: "arpWith",
    longname: "Pattern#arpWith",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * Selects indices in in stacked notes.
 * @example
 * note("<[c,eb,g]!2 [c,f,ab] [d,f,ab]>")
 * .arp("0 [0,2] 1 [0,2]")
 * */`,
    meta: {
      range: [
        27888,
        28003
      ],
      filename: "pattern.mjs",
      lineno: 929,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016277",
        name: "Pattern.prototype.arp",
        type: "FunctionExpression",
        paramnames: [
          "pat"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p>Selects indices in in stacked notes.</p>",
    examples: [
      `note("<[c,eb,g]!2 [c,f,ab] [d,f,ab]>")
.arp("0 [0,2] 1 [0,2]")`
    ],
    name: "arp",
    longname: "Pattern#arp",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
     *
     * Assumes a pattern of numbers. Adds the given number to each item in the pattern.
     * @name add
     * @memberof Pattern
     * @example
     * // Here, the triad 0, 2, 4 is shifted by different amounts
     * n("0 2 4".add("<0 3 4 0>")).scale("C:major")
     * // Without add, the equivalent would be:
     * // n("<[0 2 4] [3 5 7] [4 6 8] [0 2 4]>").scale("C:major")
     * @example
     * // You can also use add with notes:
     * note("c3 e3 g3".add("<0 5 7 0>"))
     * // Behind the scenes, the notes are converted to midi numbers:
     * // note("48 52 55".add("<0 5 7 0>"))
     */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 990,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Assumes a pattern of numbers. Adds the given number to each item in the pattern.</p>",
    name: "add",
    memberof: "Pattern",
    examples: [
      `// Here, the triad 0, 2, 4 is shifted by different amounts
n("0 2 4".add("<0 3 4 0>")).scale("C:major")
// Without add, the equivalent would be:
// n("<[0 2 4] [3 5 7] [4 6 8] [0 2 4]>").scale("C:major")`,
      `// You can also use add with notes:
note("c3 e3 g3".add("<0 5 7 0>"))
// Behind the scenes, the notes are converted to midi numbers:
// note("48 52 55".add("<0 5 7 0>"))`
    ],
    scope: "static",
    longname: "Pattern.add",
    kind: "member"
  },
  {
    comment: `/**
     *
     * Like add, but the given numbers are subtracted.
     * @name sub
     * @memberof Pattern
     * @example
     * n("0 2 4".sub("<0 1 2 3>")).scale("C4:minor")
     * // See add for more information.
     */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1007,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like add, but the given numbers are subtracted.</p>",
    name: "sub",
    memberof: "Pattern",
    examples: [
      `n("0 2 4".sub("<0 1 2 3>")).scale("C4:minor")
// See add for more information.`
    ],
    scope: "static",
    longname: "Pattern.sub",
    kind: "member"
  },
  {
    comment: `/**
     *
     * Multiplies each number by the given factor.
     * @name mul
     * @memberof Pattern
     * @example
     * "<1 1.5 [1.66, <2 2.33>]>*4".mul(150).freq()
     */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1017,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Multiplies each number by the given factor.</p>",
    name: "mul",
    memberof: "Pattern",
    examples: [
      '"<1 1.5 [1.66, <2 2.33>]>*4".mul(150).freq()'
    ],
    scope: "static",
    longname: "Pattern.mul",
    kind: "member"
  },
  {
    comment: `/**
     *
     * Divides each number by the given factor.
     * @name div
     * @memberof Pattern
     */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1026,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Divides each number by the given factor.</p>",
    name: "div",
    memberof: "Pattern",
    scope: "static",
    longname: "Pattern.div",
    kind: "member"
  },
  {
    comment: `/**
   * Applies the given structure to the pattern:
   *
   * @example
   * note("c,eb,g")
   *   .struct("x ~ x ~ ~ x ~ x ~ ~ ~ x ~ x ~ ~")
   *   .slow(2)
   */`,
    meta: {
      range: [
        33828,
        33916
      ],
      filename: "pattern.mjs",
      lineno: 1121,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016806",
        name: "Pattern.prototype.struct",
        type: "FunctionExpression",
        paramnames: [
          "args"
        ]
      }
    },
    description: "<p>Applies the given structure to the pattern:</p>",
    examples: [
      `note("c,eb,g")
  .struct("x ~ x ~ ~ x ~ x ~ ~ ~ x ~ x ~ ~")
  .slow(2)`
    ],
    name: "struct",
    longname: "Pattern#struct",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Returns silence when mask is 0 or "~"
   *
   * @example
   * note("c [eb,g] d [eb,g]").mask("<1 [0 1]>")
   */`,
    meta: {
      range: [
        34136,
        34221
      ],
      filename: "pattern.mjs",
      lineno: 1133,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016846",
        name: "Pattern.prototype.mask",
        type: "FunctionExpression",
        paramnames: [
          "args"
        ]
      }
    },
    description: "<p>Returns silence when mask is 0 or &quot;~&quot;</p>",
    examples: [
      'note("c [eb,g] d [eb,g]").mask("<1 [0 1]>")'
    ],
    name: "mask",
    longname: "Pattern#mask",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Resets the pattern to the start of the cycle for each onset of the reset pattern.
   *
   * @example
   * s("[<bd lt> sd]*2, hh*8").reset("<x@3 x(5,8)>")
   */`,
    meta: {
      range: [
        34486,
        34575
      ],
      filename: "pattern.mjs",
      lineno: 1145,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016886",
        name: "Pattern.prototype.reset",
        type: "FunctionExpression",
        paramnames: [
          "args"
        ]
      }
    },
    description: "<p>Resets the pattern to the start of the cycle for each onset of the reset pattern.</p>",
    examples: [
      's("[<bd lt> sd]*2, hh*8").reset("<x@3 x(5,8)>")'
    ],
    name: "reset",
    longname: "Pattern#reset",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
   * Restarts the pattern for each onset of the restart pattern.
   * While reset will only reset the current cycle, restart will start from cycle 0.
   *
   * @example
   * s("[<bd lt> sd]*2, hh*8").restart("<x@3 x(5,8)>")
   */`,
    meta: {
      range: [
        34909,
        35002
      ],
      filename: "pattern.mjs",
      lineno: 1158,
      columnno: 2,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100016926",
        name: "Pattern.prototype.restart",
        type: "FunctionExpression",
        paramnames: [
          "args"
        ]
      }
    },
    description: `<p>Restarts the pattern for each onset of the restart pattern.
While reset will only reset the current cycle, restart will start from cycle 0.</p>`,
    examples: [
      's("[<bd lt> sd]*2, hh*8").restart("<x@3 x(5,8)>")'
    ],
    name: "restart",
    longname: "Pattern#restart",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * Does absolutely nothing, but with a given metrical 'tactus'
 * @name gap
 * @param  {number} tactus
 * @example
 * gap(3) // "~@3"
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1192,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Does absolutely nothing, but with a given metrical 'tactus'</p>",
    name: "gap",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "tactus"
      }
    ],
    examples: [
      'gap(3) // "~@3"'
    ],
    longname: "gap",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Does absolutely nothing..
 * @name silence
 * @example
 * silence // "~"
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1201,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Does absolutely nothing..</p>",
    name: "silence",
    examples: [
      'silence // "~"'
    ],
    longname: "silence",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/** A discrete value that repeats once per cycle.
 *
 * @returns {Pattern}
 * @example
 * pure('e4') // "e4"
 * @noAutocomplete
 */`,
    meta: {
      range: [
        36257,
        36514
      ],
      filename: "pattern.mjs",
      lineno: 1219,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017005",
        name: "exports.pure",
        type: "FunctionDeclaration",
        paramnames: [
          "value"
        ]
      }
    },
    description: "<p>A discrete value that repeats once per cycle.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `pure('e4') // "e4"`
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "pure",
    longname: "pure",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** The given items are played at the same time at the same length.
 *
 * @return {Pattern}
 * @synonyms polyrhythm, pr
 * @example
 * stack("g3", "b3", ["e4", "d4"]).note()
 * // "g3,b3,[e4,d4]".note()
 */`,
    meta: {
      range: [
        37660,
        38039
      ],
      filename: "pattern.mjs",
      lineno: 1263,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017095",
        name: "exports.stack",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: "<p>The given items are played at the same time at the same length.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    synonyms_text: "polyrhythm, pr",
    synonyms: [
      "polyrhythm",
      "pr"
    ],
    examples: [
      `stack("g3", "b3", ["e4", "d4"]).note()
// "g3,b3,[e4,d4]".note()`
    ],
    name: "stack",
    longname: "stack",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** Concatenation: combines a list of patterns, switching between them successively, one per cycle:
 *
 * synonyms: \`cat\`
 *
 * @return {Pattern}
 * @example
 * slowcat("e5", "b4", ["d5", "c5"])
 *
 */`,
    meta: {
      range: [
        39720,
        40774
      ],
      filename: "pattern.mjs",
      lineno: 1341,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017456",
        name: "exports.slowcat",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: `<p>Concatenation: combines a list of patterns, switching between them successively, one per cycle:</p>
<p>synonyms: <code>cat</code></p>`,
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'slowcat("e5", "b4", ["d5", "c5"])'
    ],
    name: "slowcat",
    longname: "slowcat",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** Concatenation: combines a list of patterns, switching between them successively, one per cycle. Unlike slowcat, this version will skip cycles.
 * @param {...any} items - The items to concatenate
 * @return {Pattern}
 */`,
    meta: {
      range: [
        41e3,
        41373
      ],
      filename: "pattern.mjs",
      lineno: 1371,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017616",
        name: "exports.slowcatPrime",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: "<p>Concatenation: combines a list of patterns, switching between them successively, one per cycle. Unlike slowcat, this version will skip cycles.</p>",
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        description: "<p>The items to concatenate</p>",
        name: "items"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "slowcatPrime",
    longname: "slowcatPrime",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** The given items are con**cat**enated, where each one takes one cycle.
 *
 * @param {...any} items - The items to concatenate
 * @synonyms slowcat
 * @return {Pattern}
 * @example
 * cat("e5", "b4", ["d5", "c5"]).note()
 * // "<e5 b4 [d5 c5]>".note()
 *
 */`,
    meta: {
      range: [
        41636,
        41695
      ],
      filename: "pattern.mjs",
      lineno: 1391,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017669",
        name: "exports.cat",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: "<p>The given items are con<strong>cat</strong>enated, where each one takes one cycle.</p>",
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        description: "<p>The items to concatenate</p>",
        name: "items"
      }
    ],
    synonyms_text: "slowcat",
    synonyms: [
      "slowcat"
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `cat("e5", "b4", ["d5", "c5"]).note()
// "<e5 b4 [d5 c5]>".note()`
    ],
    name: "cat",
    longname: "cat",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/**
 * Allows to arrange multiple patterns together over multiple cycles.
 * Takes a variable number of arrays with two elements specifying the number of cycles and the pattern to use.
 *
 * @return {Pattern}
 * @example
 * arrange(
 *   [4, "<c a f e>(3,8)"],
 *   [2, "<g a>(5,8)"]
 * ).note()
 */`,
    meta: {
      range: [
        41997,
        42229
      ],
      filename: "pattern.mjs",
      lineno: 1406,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017680",
        name: "exports.arrange",
        type: "FunctionDeclaration",
        paramnames: [
          "sections"
        ]
      }
    },
    description: `<p>Allows to arrange multiple patterns together over multiple cycles.
Takes a variable number of arrays with two elements specifying the number of cycles and the pattern to use.</p>`,
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `arrange(
  [4, "<c a f e>(3,8)"],
  [2, "<g a>(5,8)"]
).note()`
    ],
    name: "arrange",
    longname: "arrange",
    kind: "function",
    scope: "global"
  },
  {
    comment: "/** See `fastcat` */",
    meta: {
      range: [
        42442,
        42506
      ],
      filename: "pattern.mjs",
      lineno: 1422,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017765",
        name: "exports.sequence",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: "<p>See <code>fastcat</code></p>",
    name: "sequence",
    longname: "sequence",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** Like **cat**, but the items are crammed into one cycle.
 * @synonyms fastcat, sequence
 * @example
 * seq("e5", "b4", ["d5", "c5"]).note()
 * // "e5 b4 [d5 c5]".note()
 *
 */`,
    meta: {
      range: [
        42687,
        42746
      ],
      filename: "pattern.mjs",
      lineno: 1433,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100017776",
        name: "exports.seq",
        type: "FunctionDeclaration",
        paramnames: [
          "pats"
        ]
      }
    },
    description: "<p>Like <strong>cat</strong>, but the items are crammed into one cycle.</p>",
    synonyms_text: "fastcat, sequence",
    synonyms: [
      "fastcat",
      "sequence"
    ],
    examples: [
      `seq("e5", "b4", ["d5", "c5"]).note()
// "e5 b4 [d5 c5]".note()`
    ],
    name: "seq",
    longname: "seq",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/**
 * Registers a new pattern method. The method is added to the Pattern class + the standalone function is returned from register.
 *
 * @param {string} name name of the function
 * @param {function} func function with 1 or more params, where last is the current pattern
 * @noAutocomplete
 *
 */`,
    meta: {
      range: [
        44874,
        47430
      ],
      filename: "pattern.mjs",
      lineno: 1489,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100018296",
        name: "exports.register",
        type: "FunctionDeclaration",
        paramnames: [
          "name",
          "func",
          "patternify",
          "preserveTactus",
          "join"
        ]
      }
    },
    description: "<p>Registers a new pattern method. The method is added to the Pattern class + the standalone function is returned from register.</p>",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>name of the function</p>",
        name: "name"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function with 1 or more params, where last is the current pattern</p>",
        name: "func"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "register",
    longname: "register",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/**
 * Assumes a numerical pattern. Returns a new pattern with all values rounded
 * to the nearest integer.
 * @name round
 * @memberof Pattern
 * @returns Pattern
 * @example
 * n("0.5 1.5 2.5".round()).scale("C:major")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1578,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern. Returns a new pattern with all values rounded
to the nearest integer.</p>`,
    name: "round",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'n("0.5 1.5 2.5".round()).scale("C:major")'
    ],
    scope: "static",
    longname: "Pattern.round",
    kind: "member"
  },
  {
    comment: `/**
 * Assumes a numerical pattern. Returns a new pattern with all values set to
 * their mathematical floor. E.g. \`3.7\` replaced with to \`3\`, and \`-4.2\`
 * replaced with \`-5\`.
 * @name floor
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note("42 42.1 42.5 43".floor())
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1591,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern. Returns a new pattern with all values set to
their mathematical floor. E.g. <code>3.7</code> replaced with to <code>3</code>, and <code>-4.2</code>
replaced with <code>-5</code>.</p>`,
    name: "floor",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("42 42.1 42.5 43".floor())'
    ],
    scope: "static",
    longname: "Pattern.floor",
    kind: "member"
  },
  {
    comment: `/**
 * Assumes a numerical pattern. Returns a new pattern with all values set to
 * their mathematical ceiling. E.g. \`3.2\` replaced with \`4\`, and \`-4.2\`
 * replaced with \`-4\`.
 * @name ceil
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note("42 42.1 42.5 43".ceil())
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1605,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern. Returns a new pattern with all values set to
their mathematical ceiling. E.g. <code>3.2</code> replaced with <code>4</code>, and <code>-4.2</code>
replaced with <code>-4</code>.</p>`,
    name: "ceil",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("42 42.1 42.5 43".ceil())'
    ],
    scope: "static",
    longname: "Pattern.ceil",
    kind: "member"
  },
  {
    comment: `/**
 * Assumes a numerical pattern, containing unipolar values in the range 0 ..
 * 1. Returns a new pattern with values scaled to the bipolar range -1 .. 1
 * @returns Pattern
 * @noAutocomplete
 */`,
    meta: {
      range: [
        49077,
        49181
      ],
      filename: "pattern.mjs",
      lineno: 1624,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100018795",
        name: "exports.toBipolar",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Assumes a numerical pattern, containing unipolar values in the range 0 ..</p>
<ol>
<li>Returns a new pattern with values scaled to the bipolar range -1 .. 1</li>
</ol>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "toBipolar",
    longname: "toBipolar",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Assumes a numerical pattern, containing bipolar values in the range -1 .. 1
 * Returns a new pattern with values scaled to the unipolar range 0 .. 1
 * @returns Pattern
 * @noAutocomplete
 */`,
    meta: {
      range: [
        49382,
        49492
      ],
      filename: "pattern.mjs",
      lineno: 1634,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100018817",
        name: "exports.fromBipolar",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Assumes a numerical pattern, containing bipolar values in the range -1 .. 1
Returns a new pattern with values scaled to the unipolar range 0 .. 1</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "fromBipolar",
    longname: "fromBipolar",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Assumes a numerical pattern, containing unipolar values in the range 0 .. 1.
 * Returns a new pattern with values scaled to the given min/max range.
 * Most useful in combination with continuous patterns.
 * @name range
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("[bd sd]*2,hh*8")
 * .cutoff(sine.range(500,4000))
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1638,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern, containing unipolar values in the range 0 .. 1.
Returns a new pattern with values scaled to the given min/max range.
Most useful in combination with continuous patterns.</p>`,
    name: "range",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `s("[bd sd]*2,hh*8")
.cutoff(sine.range(500,4000))`
    ],
    scope: "static",
    longname: "Pattern.range",
    kind: "member"
  },
  {
    comment: `/**
 * Assumes a numerical pattern, containing unipolar values in the range 0 .. 1
 * Returns a new pattern with values scaled to the given min/max range,
 * following an exponential curve.
 * @name rangex
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("[bd sd]*2,hh*8")
 * .cutoff(sine.rangex(500,4000))
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1653,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern, containing unipolar values in the range 0 .. 1
Returns a new pattern with values scaled to the given min/max range,
following an exponential curve.</p>`,
    name: "rangex",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `s("[bd sd]*2,hh*8")
.cutoff(sine.rangex(500,4000))`
    ],
    scope: "static",
    longname: "Pattern.rangex",
    kind: "member"
  },
  {
    comment: `/**
 * Assumes a numerical pattern, containing bipolar values in the range -1 .. 1
 * Returns a new pattern with values scaled to the given min/max range.
 * @name range2
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("[bd sd]*2,hh*8")
 * .cutoff(sine2.range2(500,4000))
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1668,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Assumes a numerical pattern, containing bipolar values in the range -1 .. 1
Returns a new pattern with values scaled to the given min/max range.</p>`,
    name: "range2",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `s("[bd sd]*2,hh*8")
.cutoff(sine2.range2(500,4000))`
    ],
    scope: "static",
    longname: "Pattern.range2",
    kind: "member"
  },
  {
    comment: `/**
 * Allows dividing numbers via list notation using ":".
 * Returns a new pattern with just numbers.
 * @name ratio
 * @memberof Pattern
 * @returns Pattern
 * @example
 * ratio("1, 5:4, 3:2").mul(110)
 * .freq().s("piano")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1682,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Allows dividing numbers via list notation using &quot;:&quot;.
Returns a new pattern with just numbers.</p>`,
    name: "ratio",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `ratio("1, 5:4, 3:2").mul(110)
.freq().s("piano")`
    ],
    scope: "static",
    longname: "Pattern.ratio",
    kind: "member"
  },
  {
    comment: `/** Compress each cycle into the given timespan, leaving a gap
 * @example
 * cat(
 *   s("bd sd").compress(.25,.75),
 *   s("~ bd sd ~")
 * )
 */`,
    meta: {
      range: [
        51485,
        51738
      ],
      filename: "pattern.mjs",
      lineno: 1711,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100018962",
        name: "exports.compress",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Compress each cycle into the given timespan, leaving a gap</p>",
    examples: [
      `cat(
  s("bd sd").compress(.25,.75),
  s("~ bd sd ~")
)`
    ],
    name: "compress",
    longname: "compress",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * speeds up a pattern like fast, but rather than it playing multiple times as fast would it instead leaves a gap in the remaining space of the cycle. For example, the following will play the sound pattern "bd sn" only once but compressed into the first half of the cycle, i.e. twice as fast.
 * @name fastGap
 * @synonyms fastgap
 * @example
 * s("bd sd").fastGap(2)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1724,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>speeds up a pattern like fast, but rather than it playing multiple times as fast would it instead leaves a gap in the remaining space of the cycle. For example, the following will play the sound pattern &quot;bd sn&quot; only once but compressed into the first half of the cycle, i.e. twice as fast.</p>",
    name: "fastGap",
    synonyms_text: "fastgap",
    synonyms: [
      "fastgap"
    ],
    examples: [
      's("bd sd").fastGap(2)'
    ],
    longname: "fastGap",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Similar to \`compress\`, but doesn't leave gaps, and the 'focus' can be bigger than a cycle
 * @example
 * s("bd hh sd hh").focus(1/4, 3/4)
 */`,
    meta: {
      range: [
        53629,
        53798
      ],
      filename: "pattern.mjs",
      lineno: 1766,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019304",
        name: "exports.focus",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Similar to <code>compress</code>, but doesn't leave gaps, and the 'focus' can be bigger than a cycle</p>",
    examples: [
      's("bd hh sd hh").focus(1/4, 3/4)'
    ],
    name: "focus",
    longname: "focus",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** The ply function repeats each event the given number of times.
 * @example
 * s("bd ~ sd cp").ply("<1 2 3>")
 */`,
    meta: {
      range: [
        54065,
        54297
      ],
      filename: "pattern.mjs",
      lineno: 1780,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019379",
        name: "exports.ply",
        type: "VariableDeclaration"
      }
    },
    description: "<p>The ply function repeats each event the given number of times.</p>",
    examples: [
      's("bd ~ sd cp").ply("<1 2 3>")'
    ],
    name: "ply",
    longname: "ply",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Speed up a pattern by the given factor. Used by "*" in mini notation.
 *
 * @name fast
 * @synonyms density
 * @memberof Pattern
 * @param {number | Pattern} factor speed up factor
 * @returns Pattern
 * @example
 * s("bd hh sd hh").fast(2) // s("[bd hh sd hh]*2")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1788,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Speed up a pattern by the given factor. Used by &quot;*&quot; in mini notation.</p>",
    name: "fast",
    synonyms_text: "density",
    synonyms: [
      "density"
    ],
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>speed up factor</p>",
        name: "factor"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("bd hh sd hh").fast(2) // s("[bd hh sd hh]*2")'
    ],
    scope: "static",
    longname: "Pattern.fast",
    kind: "member"
  },
  {
    comment: `/**
 * Both speeds up the pattern (like 'fast') and the sample playback (like 'speed').
 * @example
 * s("bd sd:2").hurry("<1 2 4 3>").slow(1.5)
 */`,
    meta: {
      range: [
        55066,
        55175
      ],
      filename: "pattern.mjs",
      lineno: 1818,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019492",
        name: "exports.hurry",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Both speeds up the pattern (like 'fast') and the sample playback (like 'speed').</p>",
    examples: [
      's("bd sd:2").hurry("<1 2 4 3>").slow(1.5)'
    ],
    name: "hurry",
    longname: "hurry",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Slow down a pattern over the given number of cycles. Like the "/" operator in mini notation.
 *
 * @name slow
 * @synonyms sparsity
 * @memberof Pattern
 * @param {number | Pattern} factor slow down factor
 * @returns Pattern
 * @example
 * s("bd hh sd hh").slow(2) // s("[bd hh sd hh]/2")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1822,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Slow down a pattern over the given number of cycles. Like the &quot;/&quot; operator in mini notation.</p>",
    name: "slow",
    synonyms_text: "sparsity",
    synonyms: [
      "sparsity"
    ],
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>slow down factor</p>",
        name: "factor"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("bd hh sd hh").slow(2) // s("[bd hh sd hh]/2")'
    ],
    scope: "static",
    longname: "Pattern.slow",
    kind: "member"
  },
  {
    comment: `/**
 * Carries out an operation 'inside' a cycle.
 * @example
 * "0 1 2 3 4 3 2 1".inside(4, rev).scale('C major').note()
 * // "0 1 2 3 4 3 2 1".slow(4).rev().fast(4).scale('C major').note()
 */`,
    meta: {
      range: [
        55860,
        55977
      ],
      filename: "pattern.mjs",
      lineno: 1846,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019553",
        name: "exports.inside",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Carries out an operation 'inside' a cycle.</p>",
    examples: [
      `"0 1 2 3 4 3 2 1".inside(4, rev).scale('C major').note()
// "0 1 2 3 4 3 2 1".slow(4).rev().fast(4).scale('C major').note()`
    ],
    name: "inside",
    longname: "inside",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Carries out an operation 'outside' a cycle.
 * @example
 * "<[0 1] 2 [3 4] 5>".outside(4, rev).scale('C major').note()
 * // "<[0 1] 2 [3 4] 5>".fast(4).rev().slow(4).scale('C major').note()
 */`,
    meta: {
      range: [
        56181,
        56300
      ],
      filename: "pattern.mjs",
      lineno: 1856,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019577",
        name: "exports.outside",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Carries out an operation 'outside' a cycle.</p>",
    examples: [
      `"<[0 1] 2 [3 4] 5>".outside(4, rev).scale('C major').note()
// "<[0 1] 2 [3 4] 5>".fast(4).rev().slow(4).scale('C major').note()`
    ],
    name: "outside",
    longname: "outside",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Applies the given function every n cycles, starting from the last cycle.
 * @name lastOf
 * @memberof Pattern
 * @param {number} n how many cycles
 * @param {function} func function to apply
 * @returns Pattern
 * @example
 * note("c3 d3 e3 g3").lastOf(4, x=>x.rev())
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1860,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Applies the given function every n cycles, starting from the last cycle.</p>",
    name: "lastOf",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many cycles</p>",
        name: "n"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("c3 d3 e3 g3").lastOf(4, x=>x.rev())'
    ],
    scope: "static",
    longname: "Pattern.lastOf",
    kind: "member"
  },
  {
    comment: `/**
 * Applies the given function every n cycles, starting from the first cycle.
 * @name firstOf
 * @memberof Pattern
 * @param {number} n how many cycles
 * @param {function} func function to apply
 * @returns Pattern
 * @example
 * note("c3 d3 e3 g3").firstOf(4, x=>x.rev())
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1876,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Applies the given function every n cycles, starting from the first cycle.</p>",
    name: "firstOf",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many cycles</p>",
        name: "n"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("c3 d3 e3 g3").firstOf(4, x=>x.rev())'
    ],
    scope: "static",
    longname: "Pattern.firstOf",
    kind: "member"
  },
  {
    comment: `/**
 * An alias for \`firstOf\`
 * @name every
 * @memberof Pattern
 * @param {number} n how many cycles
 * @param {function} func function to apply
 * @returns Pattern
 * @example
 * note("c3 d3 e3 g3").every(4, x=>x.rev())
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1887,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>An alias for <code>firstOf</code></p>",
    name: "every",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many cycles</p>",
        name: "n"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("c3 d3 e3 g3").every(4, x=>x.rev())'
    ],
    scope: "static",
    longname: "Pattern.every",
    kind: "member"
  },
  {
    comment: `/**
 * Like layer, but with a single function:
 * @name apply
 * @memberof Pattern
 * @example
 * "<c3 eb3 g3>".scale('C minor').apply(scaleTranspose("0,2,4")).note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1903,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like layer, but with a single function:</p>",
    name: "apply",
    memberof: "Pattern",
    examples: [
      `"<c3 eb3 g3>".scale('C minor').apply(scaleTranspose("0,2,4")).note()`
    ],
    scope: "static",
    longname: "Pattern.apply",
    kind: "member"
  },
  {
    comment: `/**
 * Plays the pattern at the given cycles per minute.
 * @example
 * s("<bd sd>,hh*2").cpm(90) // = 90 bpm
 */`,
    meta: {
      range: [
        57929,
        58023
      ],
      filename: "pattern.mjs",
      lineno: 1921,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019696",
        name: "exports.cpm",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Plays the pattern at the given cycles per minute.</p>",
    examples: [
      's("<bd sd>,hh*2").cpm(90) // = 90 bpm'
    ],
    name: "cpm",
    longname: "cpm",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Nudge a pattern to start earlier in time. Equivalent of Tidal's <~ operator
 *
 * @name early
 * @memberof Pattern
 * @param {number | Pattern} cycles number of cycles to nudge left
 * @returns Pattern
 * @example
 * "bd ~".stack("hh ~".early(.1)).s()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1925,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Nudge a pattern to start earlier in time. Equivalent of Tidal's &lt;~ operator</p>",
    name: "early",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>number of cycles to nudge left</p>",
        name: "cycles"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"bd ~".stack("hh ~".early(.1)).s()'
    ],
    scope: "static",
    longname: "Pattern.early",
    kind: "member"
  },
  {
    comment: `/**
 * Nudge a pattern to start later in time. Equivalent of Tidal's ~> operator
 *
 * @name late
 * @memberof Pattern
 * @param {number | Pattern} cycles number of cycles to nudge right
 * @returns Pattern
 * @example
 * "bd ~".stack("hh ~".late(.1)).s()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 1945,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Nudge a pattern to start later in time. Equivalent of Tidal's ~&gt; operator</p>",
    name: "late",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>number of cycles to nudge right</p>",
        name: "cycles"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"bd ~".stack("hh ~".late(.1)).s()'
    ],
    scope: "static",
    longname: "Pattern.late",
    kind: "member"
  },
  {
    comment: `/**
 * Plays a portion of a pattern, specified by the beginning and end of a time span. The new resulting pattern is played over the time period of the original pattern:
 *
 * @example
 * s("bd*2 hh*3 [sd bd]*2 perc").zoom(0.25, 0.75)
 * // s("hh*3 [sd bd]*2") // equivalent
 */`,
    meta: {
      range: [
        59209,
        59631
      ],
      filename: "pattern.mjs",
      lineno: 1972,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019789",
        name: "exports.zoom",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Plays a portion of a pattern, specified by the beginning and end of a time span. The new resulting pattern is played over the time period of the original pattern:</p>",
    examples: [
      `s("bd*2 hh*3 [sd bd]*2 perc").zoom(0.25, 0.75)
// s("hh*3 [sd bd]*2") // equivalent`
    ],
    name: "zoom",
    longname: "zoom",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Selects the given fraction of the pattern and repeats that part to fill the remainder of the cycle.
 * @param {number} fraction fraction to select
 * @example
 * s("lt ht mt cp, [hh oh]*2").linger("<1 .5 .25 .125>")
 */`,
    meta: {
      range: [
        59989,
        60231
      ],
      filename: "pattern.mjs",
      lineno: 1997,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019920",
        name: "exports.linger",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Selects the given fraction of the pattern and repeats that part to fill the remainder of the cycle.</p>",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>fraction to select</p>",
        name: "fraction"
      }
    ],
    examples: [
      's("lt ht mt cp, [hh oh]*2").linger("<1 .5 .25 .125>")'
    ],
    name: "linger",
    longname: "linger",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Samples the pattern at a rate of n events per cycle. Useful for turning a continuous pattern into a discrete one.
 * @param {number} segments number of segments per cycle
 * @example
 * note(saw.range(40,52).segment(24))
 */`,
    meta: {
      range: [
        60465,
        60595
      ],
      filename: "pattern.mjs",
      lineno: 2017,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019971",
        name: "exports.segment",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Samples the pattern at a rate of n events per cycle. Useful for turning a continuous pattern into a discrete one.</p>",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>number of segments per cycle</p>",
        name: "segments"
      }
    ],
    examples: [
      "note(saw.range(40,52).segment(24))"
    ],
    name: "segment",
    longname: "segment",
    kind: "constant",
    scope: "global"
  },
  {
    comment: '/**\n * The function `swingBy x n` breaks each cycle into `n` slices, and then delays events in the second half of each slice by the amount `x`, which is relative to the size of the (half) slice. So if `x` is 0 it does nothing, `0.5` delays for half the note duration, and 1 will wrap around to doing nothing again. The end result is a shuffle or swing-like rhythm\n * @param {number} subdivision\n * @param {number} offset\n * @example\n * s("hh*8").swingBy(1/3, 4)\n */',
    meta: {
      range: [
        61063,
        61165
      ],
      filename: "pattern.mjs",
      lineno: 2028,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100019998",
        name: "exports.swingBy",
        type: "VariableDeclaration"
      }
    },
    description: "<p>The function <code>swingBy x n</code> breaks each cycle into <code>n</code> slices, and then delays events in the second half of each slice by the amount <code>x</code>, which is relative to the size of the (half) slice. So if <code>x</code> is 0 it does nothing, <code>0.5</code> delays for half the note duration, and 1 will wrap around to doing nothing again. The end result is a shuffle or swing-like rhythm</p>",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "subdivision"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "offset"
      }
    ],
    examples: [
      's("hh*8").swingBy(1/3, 4)'
    ],
    name: "swingBy",
    longname: "swingBy",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Shorthand for swingBy with 1/3:
 * @param {number} subdivision
 * @example
 * s("hh*8").swing(4)
 * // s("hh*8").swingBy(1/3, 4)
 */`,
    meta: {
      range: [
        61307,
        61381
      ],
      filename: "pattern.mjs",
      lineno: 2037,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020022",
        name: "exports.swing",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Shorthand for swingBy with 1/3:</p>",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "subdivision"
      }
    ],
    examples: [
      `s("hh*8").swing(4)
// s("hh*8").swingBy(1/3, 4)`
    ],
    name: "swing",
    longname: "swing",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Swaps 1s and 0s in a binary pattern.
 * @name invert
 * @synonyms inv
 * @example
 * s("bd").struct("1 0 0 1 0 0 1 0".lastOf(4, invert))
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2039,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Swaps 1s and 0s in a binary pattern.</p>",
    name: "invert",
    synonyms_text: "inv",
    synonyms: [
      "inv"
    ],
    examples: [
      's("bd").struct("1 0 0 1 0 0 1 0".lastOf(4, invert))'
    ],
    longname: "invert",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Applies the given function whenever the given pattern is in a true state.
 * @name when
 * @memberof Pattern
 * @param {Pattern} binary_pat
 * @param {function} func
 * @returns Pattern
 * @example
 * "c3 eb3 g3".when("<0 1>/2", x=>x.sub("5")).note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2056,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Applies the given function whenever the given pattern is in a true state.</p>",
    name: "when",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "binary_pat"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"c3 eb3 g3".when("<0 1>/2", x=>x.sub("5")).note()'
    ],
    scope: "static",
    longname: "Pattern.when",
    kind: "member"
  },
  {
    comment: `/**
 * Superimposes the function result on top of the original pattern, delayed by the given time.
 * @name off
 * @memberof Pattern
 * @param {Pattern | number} time offset time
 * @param {function} func function to apply
 * @returns Pattern
 * @example
 * "c3 eb3 g3".off(1/8, x=>x.add(7)).note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2070,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Superimposes the function result on top of the original pattern, delayed by the given time.</p>",
    name: "off",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "Pattern",
            "number"
          ]
        },
        description: "<p>offset time</p>",
        name: "time"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function to apply</p>",
        name: "func"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"c3 eb3 g3".off(1/8, x=>x.add(7)).note()'
    ],
    scope: "static",
    longname: "Pattern.off",
    kind: "member"
  },
  {
    comment: `/**
 * Returns a new pattern where every other cycle is played once, twice as
 * fast, and offset in time by one quarter of a cycle. Creates a kind of
 * breakbeat feel.
 * @returns Pattern
 */`,
    meta: {
      range: [
        62691,
        62829
      ],
      filename: "pattern.mjs",
      lineno: 2090,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020109",
        name: "exports.brak",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Returns a new pattern where every other cycle is played once, twice as
fast, and offset in time by one quarter of a cycle. Creates a kind of
breakbeat feel.</p>`,
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    name: "brak",
    longname: "brak",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Reverse all haps in a pattern
 *
 * @name rev
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note("c d e g").rev()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2094,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Reverse all haps in a pattern</p>",
    name: "rev",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note("c d e g").rev()'
    ],
    scope: "static",
    longname: "Pattern.rev",
    kind: "member"
  },
  {
    comment: `/** Like press, but allows you to specify the amount by which each
 * event is shifted. pressBy(0.5) is the same as press, while
 * pressBy(1/3) shifts each event by a third of its timespan.
 * @example
 * stack(s("hh*4"),
 *       s("bd mt sd ht").pressBy("<0 0.5 0.25>")
 *      ).slow(2)
 */`,
    meta: {
      range: [
        64037,
        64167
      ],
      filename: "pattern.mjs",
      lineno: 2135,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020259",
        name: "exports.pressBy",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Like press, but allows you to specify the amount by which each
event is shifted. pressBy(0.5) is the same as press, while
pressBy(1/3) shifts each event by a third of its timespan.</p>`,
    examples: [
      `stack(s("hh*4"),
      s("bd mt sd ht").pressBy("<0 0.5 0.25>")
     ).slow(2)`
    ],
    name: "pressBy",
    longname: "pressBy",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Syncopates a rhythm, by shifting each event halfway into its timespan.
 * @example
 * stack(s("hh*4"),
 *       s("bd mt sd ht").every(4, press)
 *      ).slow(2)
 */`,
    meta: {
      range: [
        64343,
        64430
      ],
      filename: "pattern.mjs",
      lineno: 2146,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020288",
        name: "exports.press",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Syncopates a rhythm, by shifting each event halfway into its timespan.</p>",
    examples: [
      `stack(s("hh*4"),
      s("bd mt sd ht").every(4, press)
     ).slow(2)`
    ],
    name: "press",
    longname: "press",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Silences a pattern.
 * @example
 * stack(
 *   s("bd").hush(),
 *   s("hh*3")
 * )
 */`,
    meta: {
      range: [
        64526,
        64584
      ],
      filename: "pattern.mjs",
      lineno: 2158,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020305",
        name: "Pattern.prototype.hush",
        type: "FunctionExpression",
        paramnames: []
      }
    },
    description: "<p>Silences a pattern.</p>",
    examples: [
      `stack(
  s("bd").hush(),
  s("hh*3")
)`
    ],
    name: "hush",
    longname: "Pattern#hush",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * Applies \`rev\` to a pattern every other cycle, so that the pattern alternates between forwards and backwards.
 * @example
 * note("c d e g").palindrome()
 */`,
    meta: {
      range: [
        64751,
        64876
      ],
      filename: "pattern.mjs",
      lineno: 2167,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020315",
        name: "exports.palindrome",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Applies <code>rev</code> to a pattern every other cycle, so that the pattern alternates between forwards and backwards.</p>",
    examples: [
      'note("c d e g").palindrome()'
    ],
    name: "palindrome",
    longname: "palindrome",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Jux with adjustable stereo width. 0 = mono, 1 = full stereo.
 * @name juxBy
 * @synonyms juxby
 * @example
 * s("bd lt [~ ht] mt cp ~ bd hh").juxBy("<0 .5 1>/2", rev)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2176,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Jux with adjustable stereo width. 0 = mono, 1 = full stereo.</p>",
    name: "juxBy",
    synonyms_text: "juxby",
    synonyms: [
      "juxby"
    ],
    examples: [
      's("bd lt [~ ht] mt cp ~ bd hh").juxBy("<0 .5 1>/2", rev)'
    ],
    longname: "juxBy",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * The jux function creates strange stereo effects, by applying a function to a pattern, but only in the right-hand channel.
 * @example
 * s("bd lt [~ ht] mt cp ~ bd hh").jux(rev)
 * @example
 * s("bd lt [~ ht] mt cp ~ bd hh").jux(press)
 * @example
 * s("bd lt [~ ht] mt cp ~ bd hh").jux(iter(4))
 */`,
    meta: {
      range: [
        65897,
        65993
      ],
      filename: "pattern.mjs",
      lineno: 2206,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020444",
        name: "exports.jux",
        type: "VariableDeclaration"
      }
    },
    description: "<p>The jux function creates strange stereo effects, by applying a function to a pattern, but only in the right-hand channel.</p>",
    examples: [
      's("bd lt [~ ht] mt cp ~ bd hh").jux(rev)',
      's("bd lt [~ ht] mt cp ~ bd hh").jux(press)',
      's("bd lt [~ ht] mt cp ~ bd hh").jux(iter(4))'
    ],
    name: "jux",
    longname: "jux",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Superimpose and offset multiple times, applying the given function each time.
 * @name echoWith
 * @synonyms echowith, stutWith, stutwith
 * @param {number} times how many times to repeat
 * @param {number} time cycle offset between iterations
 * @param {function} func function to apply, given the pattern and the iteration index
 * @example
 * "<0 [2 4]>"
 * .echoWith(4, 1/8, (p,n) => p.add(n*2))
 * .scale("C:minor").note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2210,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Superimpose and offset multiple times, applying the given function each time.</p>",
    name: "echoWith",
    synonyms_text: "echowith, stutWith, stutwith",
    synonyms: [
      "echowith",
      "stutWith",
      "stutwith"
    ],
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many times to repeat</p>",
        name: "times"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>cycle offset between iterations</p>",
        name: "time"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>function to apply, given the pattern and the iteration index</p>",
        name: "func"
      }
    ],
    examples: [
      `"<0 [2 4]>"
.echoWith(4, 1/8, (p,n) => p.add(n*2))
.scale("C:minor").note()`
    ],
    longname: "echoWith",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Superimpose and offset multiple times, gradually decreasing the velocity
 * @name echo
 * @memberof Pattern
 * @returns Pattern
 * @param {number} times how many times to repeat
 * @param {number} time cycle offset between iterations
 * @param {number} feedback velocity multiplicator for each iteration
 * @example
 * s("bd sd").echo(3, 1/6, .8)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2229,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Superimpose and offset multiple times, gradually decreasing the velocity</p>",
    name: "echo",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many times to repeat</p>",
        name: "times"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>cycle offset between iterations</p>",
        name: "time"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>velocity multiplicator for each iteration</p>",
        name: "feedback"
      }
    ],
    examples: [
      's("bd sd").echo(3, 1/6, .8)'
    ],
    scope: "static",
    longname: "Pattern.echo",
    kind: "member"
  },
  {
    comment: `/**
 * Deprecated. Like echo, but the last 2 parameters are flipped.
 * @name stut
 * @param {number} times how many times to repeat
 * @param {number} feedback velocity multiplicator for each iteration
 * @param {number} time cycle offset between iterations
 * @example
 * s("bd sd").stut(3, .8, 1/6)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2244,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Deprecated. Like echo, but the last 2 parameters are flipped.</p>",
    name: "stut",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many times to repeat</p>",
        name: "times"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>velocity multiplicator for each iteration</p>",
        name: "feedback"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>cycle offset between iterations</p>",
        name: "time"
      }
    ],
    examples: [
      's("bd sd").stut(3, .8, 1/6)'
    ],
    longname: "stut",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Divides a pattern into a given number of subdivisions, plays the subdivisions in order, but increments the starting subdivision each cycle. The pattern wraps to the first subdivision after the last subdivision is played.
 * @name iter
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note("0 1 2 3".scale('A minor')).iter(4)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2257,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Divides a pattern into a given number of subdivisions, plays the subdivisions in order, but increments the starting subdivision each cycle. The pattern wraps to the first subdivision after the last subdivision is played.</p>",
    name: "iter",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `note("0 1 2 3".scale('A minor')).iter(4)`
    ],
    scope: "static",
    longname: "Pattern.iter",
    kind: "member"
  },
  {
    comment: `/**
 * Like \`iter\`, but plays the subdivisions in reverse order. Known as iter' in tidalcycles
 * @name iterBack
 * @synonyms iterback
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note("0 1 2 3".scale('A minor')).iterBack(4)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2284,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like <code>iter</code>, but plays the subdivisions in reverse order. Known as iter' in tidalcycles</p>",
    name: "iterBack",
    synonyms_text: "iterback",
    synonyms: [
      "iterback"
    ],
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `note("0 1 2 3".scale('A minor')).iterBack(4)`
    ],
    scope: "static",
    longname: "Pattern.iterBack",
    kind: "member"
  },
  {
    comment: `/**
 * Repeats each cycle the given number of times.
 * @name repeatCycles
 * @memberof Pattern
 * @returns Pattern
 * @example
 * note(irand(12).add(34)).segment(4).repeatCycles(2).s("gm_acoustic_guitar_nylon")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2302,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Repeats each cycle the given number of times.</p>",
    name: "repeatCycles",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'note(irand(12).add(34)).segment(4).repeatCycles(2).s("gm_acoustic_guitar_nylon")'
    ],
    scope: "static",
    longname: "Pattern.repeatCycles",
    kind: "member"
  },
  {
    comment: `/**
 * Divides a pattern into a given number of parts, then cycles through those parts in turn, applying the given function to each part in turn (one part per cycle).
 * @name chunk
 * @synonyms slowChunk, slowchunk
 * @memberof Pattern
 * @returns Pattern
 * @example
 * "0 1 2 3".chunk(4, x=>x.add(7))
 * .scale("A:minor").note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2325,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Divides a pattern into a given number of parts, then cycles through those parts in turn, applying the given function to each part in turn (one part per cycle).</p>",
    name: "chunk",
    synonyms_text: "slowChunk, slowchunk",
    synonyms: [
      "slowChunk",
      "slowchunk"
    ],
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"0 1 2 3".chunk(4, x=>x.add(7))
.scale("A:minor").note()`
    ],
    scope: "static",
    longname: "Pattern.chunk",
    kind: "member"
  },
  {
    comment: `/**
 * Like \`chunk\`, but cycles through the parts in reverse order. Known as chunk' in tidalcycles
 * @name chunkBack
 * @synonyms chunkback
 * @memberof Pattern
 * @returns Pattern
 * @example
 * "0 1 2 3".chunkBack(4, x=>x.add(7))
 * .scale("A:minor").note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2351,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Like <code>chunk</code>, but cycles through the parts in reverse order. Known as chunk' in tidalcycles</p>",
    name: "chunkBack",
    synonyms_text: "chunkback",
    synonyms: [
      "chunkback"
    ],
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"0 1 2 3".chunkBack(4, x=>x.add(7))
.scale("A:minor").note()`
    ],
    scope: "static",
    longname: "Pattern.chunkBack",
    kind: "member"
  },
  {
    comment: `/**
 * Like \`chunk\`, but the cycles of the source pattern aren't repeated
 * for each set of chunks.
 * @name fastChunk
 * @synonyms fastchunk
 * @memberof Pattern
 * @returns Pattern
 * @example
 * "<0 8> 1 2 3 4 5 6 7"
 * .fastChunk(4, x => x.color('red')).slow(2)
 * .scale("C2:major").note()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2365,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Like <code>chunk</code>, but the cycles of the source pattern aren't repeated
for each set of chunks.</p>`,
    name: "fastChunk",
    synonyms_text: "fastchunk",
    synonyms: [
      "fastchunk"
    ],
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"<0 8> 1 2 3 4 5 6 7"
.fastChunk(4, x => x.color('red')).slow(2)
.scale("C2:major").note()`
    ],
    scope: "static",
    longname: "Pattern.fastChunk",
    kind: "member"
  },
  {
    comment: `/**
 * Loops the pattern inside at \`offset\` for \`cycles\`.
 * @param {number} offset start point of loop in cycles
 * @param {number} cycles loop length in cycles
 * @example
 * note("<c d e f>").ribbon(1, 2).fast(2)
 * @example
 * // Looping a portion of randomness
 * note(irand(8).segment(4).scale('C3 minor')).ribbon(1337, 2)
 */`,
    meta: {
      range: [
        71812,
        71927
      ],
      filename: "pattern.mjs",
      lineno: 2402,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100020955",
        name: "exports.ribbon",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Loops the pattern inside at <code>offset</code> for <code>cycles</code>.</p>",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>start point of loop in cycles</p>",
        name: "offset"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>loop length in cycles</p>",
        name: "cycles"
      }
    ],
    examples: [
      'note("<c d e f>").ribbon(1, 2).fast(2)',
      `// Looping a portion of randomness
note(irand(8).segment(4).scale('C3 minor')).ribbon(1337, 2)`
    ],
    name: "ribbon",
    longname: "ribbon",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Tags each Hap with an identifier. Good for filtering. The function populates Hap.context.tags (Array).
 * @name tag
 * @noAutocomplete
 * @param {string} tag anything unique
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2412,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Tags each Hap with an identifier. Good for filtering. The function populates Hap.context.tags (Array).</p>",
    name: "tag",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>anything unique</p>",
        name: "tag"
      }
    ],
    longname: "tag",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL* - Speeds a pattern up or down, to fit to the given number of steps per cycle (aka tactus).
 * @example
 * s("bd sd cp").steps(4)
 * // The same as s("{bd sd cp}%4")
 */`,
    meta: {
      range: [
        74741,
        75017
      ],
      filename: "pattern.mjs",
      lineno: 2484,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100021432",
        name: "exports.steps",
        type: "VariableDeclaration"
      }
    },
    description: "<p><em>EXPERIMENTAL</em> - Speeds a pattern up or down, to fit to the given number of steps per cycle (aka tactus).</p>",
    examples: [
      `s("bd sd cp").steps(4)
// The same as s("{bd sd cp}%4")`
    ],
    name: "steps",
    longname: "steps",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Aligns one or more given patterns to the given number of steps per cycle.
 * This relies on patterns having coherent number of steps per cycle,
 *
 * @name s_polymeterSteps
 * @param  {number} steps how many items are placed in one cycle
 * @param  {any[]} patterns one or more patterns
 * @example
 * // the same as "{c d, e f g}%4"
 * s_polymeterSteps(4, "c d", "e f g")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2517,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Aligns one or more given patterns to the given number of steps per cycle.
This relies on patterns having coherent number of steps per cycle,</p>`,
    name: "s_polymeterSteps",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>how many items are placed in one cycle</p>",
        name: "steps"
      },
      {
        type: {
          names: [
            "Array.<any>"
          ]
        },
        description: "<p>one or more patterns</p>",
        name: "patterns"
      }
    ],
    examples: [
      `// the same as "{c d, e f g}%4"
s_polymeterSteps(4, "c d", "e f g")`
    ],
    longname: "s_polymeterSteps",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL* - Combines the given lists of patterns with the same pulse, creating polymeters when different sized sequences are used.
 * @synonyms pm
 * @example
 * // The same as "{c eb g, c2 g2}"
 * s_polymeter("c eb g", "c2 g2")
 *
 */`,
    meta: {
      range: [
        76381,
        76937
      ],
      filename: "pattern.mjs",
      lineno: 2548,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100021621",
        name: "exports.s_polymeter",
        type: "FunctionDeclaration",
        paramnames: [
          "args"
        ]
      }
    },
    description: "<p><em>EXPERIMENTAL</em> - Combines the given lists of patterns with the same pulse, creating polymeters when different sized sequences are used.</p>",
    synonyms_text: "pm",
    synonyms: [
      "pm"
    ],
    examples: [
      `// The same as "{c eb g, c2 g2}"
s_polymeter("c eb g", "c2 g2")`
    ],
    name: "s_polymeter",
    longname: "s_polymeter",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** Sequences patterns like \`seq\`, but each pattern has a length, relative to the whole.
 * This length can either be provided as a [length, pattern] pair, or inferred from
 * the pattern's 'tactus', generally inferred by the mininotation. Has the alias \`timecat\`.
 * @return {Pattern}
 * @example
 * s_cat([3,"e3"],[1, "g3"]).note()
 * // the same as "e3@3 g3".note()
 * @example
 * s_cat("bd sd cp","hh hh").sound()
 * // the same as "bd sd cp hh hh".sound()
 */`,
    meta: {
      range: [
        77404,
        78644
      ],
      filename: "pattern.mjs",
      lineno: 2582,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100021720",
        name: "exports.s_cat",
        type: "FunctionDeclaration",
        paramnames: [
          "timepats"
        ]
      }
    },
    description: `<p>Sequences patterns like <code>seq</code>, but each pattern has a length, relative to the whole.
This length can either be provided as a [length, pattern] pair, or inferred from
the pattern's 'tactus', generally inferred by the mininotation. Has the alias <code>timecat</code>.</p>`,
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `s_cat([3,"e3"],[1, "g3"]).note()
// the same as "e3@3 g3".note()`,
      `s_cat("bd sd cp","hh hh").sound()
// the same as "bd sd cp hh hh".sound()`
    ],
    name: "s_cat",
    longname: "s_cat",
    kind: "function",
    scope: "global"
  },
  {
    comment: "/** Aliases for `s_cat` */",
    meta: {
      range: [
        78673,
        78702
      ],
      filename: "pattern.mjs",
      lineno: 2626,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100021996",
        name: "exports.timecat",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Aliases for <code>s_cat</code></p>",
    name: "timecat",
    longname: "timecat",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL* - Concatenates patterns stepwise, according to their 'tactus'.
 * Similar to \`s_cat\`, but if an argument is a list, the whole pattern will alternate between the elements in the list.
 *
 * @return {Pattern}
 * @example
 * s_alt(["bd cp", "mt"], "bd").sound()
 */`,
    meta: {
      range: [
        79019,
        79565
      ],
      filename: "pattern.mjs",
      lineno: 2637,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022006",
        name: "exports.s_alt",
        type: "FunctionDeclaration",
        paramnames: [
          "groups"
        ]
      }
    },
    description: `<p><em>EXPERIMENTAL</em> - Concatenates patterns stepwise, according to their 'tactus'.
Similar to <code>s_cat</code>, but if an argument is a list, the whole pattern will alternate between the elements in the list.</p>`,
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      's_alt(["bd cp", "mt"], "bd").sound()'
    ],
    name: "s_alt",
    longname: "s_alt",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL* - Retains the given number of steps in a pattern (and dropping the rest), according to its 'tactus'.
 */`,
    meta: {
      range: [
        79694,
        80189
      ],
      filename: "pattern.mjs",
      lineno: 2656,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022147",
        name: "exports.s_add",
        type: "VariableDeclaration"
      }
    },
    description: "<p><em>EXPERIMENTAL</em> - Retains the given number of steps in a pattern (and dropping the rest), according to its 'tactus'.</p>",
    name: "s_add",
    longname: "s_add",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL* - Removes the given number of steps from a pattern, according to its 'tactus'.
 */`,
    meta: {
      range: [
        80296,
        80548
      ],
      filename: "pattern.mjs",
      lineno: 2687,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022259",
        name: "exports.s_sub",
        type: "VariableDeclaration"
      }
    },
    description: "<p><em>EXPERIMENTAL</em> - Removes the given number of steps from a pattern, according to its 'tactus'.</p>",
    name: "s_sub",
    longname: "s_sub",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL*
 */`,
    meta: {
      range: [
        80852,
        81407
      ],
      filename: "pattern.mjs",
      lineno: 2710,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022372",
        name: "Pattern.prototype.s_taperlist",
        type: "FunctionExpression",
        paramnames: [
          "amount",
          "times"
        ]
      },
      vars: {
        pat: "Pattern#s_taperlist~pat",
        times: "Pattern#s_taperlist~times",
        list: "Pattern#s_taperlist~list",
        reverse: "Pattern#s_taperlist~reverse",
        amount: "Pattern#s_taperlist~amount",
        start: "Pattern#s_taperlist~start",
        i: "Pattern#s_taperlist~i"
      }
    },
    description: "<p><em>EXPERIMENTAL</em></p>",
    name: "s_taperlist",
    longname: "Pattern#s_taperlist",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * *EXPERIMENTAL*
 */`,
    meta: {
      range: [
        81519,
        81877
      ],
      filename: "pattern.mjs",
      lineno: 2742,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022519",
        name: "exports.s_taper",
        type: "VariableDeclaration"
      }
    },
    description: "<p><em>EXPERIMENTAL</em></p>",
    name: "s_taper",
    longname: "s_taper",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * *EXPERIMENTAL*
 */`,
    meta: {
      range: [
        81905,
        82131
      ],
      filename: "pattern.mjs",
      lineno: 2762,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100022588",
        name: "Pattern.prototype.s_tour",
        type: "FunctionExpression",
        paramnames: [
          "many"
        ]
      },
      vars: {
        "": null
      }
    },
    description: "<p><em>EXPERIMENTAL</em></p>",
    name: "s_tour",
    longname: "Pattern#s_tour",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * Cuts each sample into the given number of parts, allowing you to explore a technique known as 'granular synthesis'.
 * It turns a pattern of samples into a pattern of parts of samples.
 * @name chop
 * @memberof Pattern
 * @returns Pattern
 * @example
 * samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
 * s("rhodes")
 *  .chop(4)
 *  .rev() // reverse order of chops
 *  .loopAt(2) // fit sample into 2 cycles
 *
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2780,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Cuts each sample into the given number of parts, allowing you to explore a technique known as 'granular synthesis'.
It turns a pattern of samples into a pattern of parts of samples.</p>`,
    name: "chop",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
s("rhodes")
 .chop(4)
 .rev() // reverse order of chops
 .loopAt(2) // fit sample into 2 cycles`
    ],
    scope: "static",
    longname: "Pattern.chop",
    kind: "member"
  },
  {
    comment: `/**
 * Cuts each sample into the given number of parts, triggering progressive portions of each sample at each loop.
 * @name striate
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("numbers:0 numbers:1 numbers:2").striate(6).slow(3)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2803,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Cuts each sample into the given number of parts, triggering progressive portions of each sample at each loop.</p>",
    name: "striate",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("numbers:0 numbers:1 numbers:2").striate(6).slow(3)'
    ],
    scope: "static",
    longname: "Pattern.striate",
    kind: "member"
  },
  {
    comment: `/**
 * Makes the sample fit the given number of cycles by changing the speed.
 * @name loopAt
 * @memberof Pattern
 * @returns Pattern
 * @example
 * samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
 * s("rhodes").loopAt(2)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2821,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Makes the sample fit the given number of cycles by changing the speed.</p>",
    name: "loopAt",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
s("rhodes").loopAt(2)`
    ],
    scope: "static",
    longname: "Pattern.loopAt",
    kind: "member"
  },
  {
    comment: `/**
 * Chops samples into the given number of slices, triggering those slices with a given pattern of slice numbers.
 * Instead of a number, it also accepts a list of numbers from 0 to 1 to slice at specific points.
 * @name slice
 * @memberof Pattern
 * @returns Pattern
 * @example
 * samples('github:tidalcycles/dirt-samples')
 * s("breaks165").slice(8, "0 1 <2 2*2> 3 [4 0] 5 6 7".every(3, rev)).slow(0.75)
 * @example
 * samples('github:tidalcycles/dirt-samples')
 * s("breaks125").fit().slice([0,.25,.5,.75], "0 1 1 <2 3>")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2838,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Chops samples into the given number of slices, triggering those slices with a given pattern of slice numbers.
Instead of a number, it also accepts a list of numbers from 0 to 1 to slice at specific points.</p>`,
    name: "slice",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `samples('github:tidalcycles/dirt-samples')
s("breaks165").slice(8, "0 1 <2 2*2> 3 [4 0] 5 6 7".every(3, rev)).slow(0.75)`,
      `samples('github:tidalcycles/dirt-samples')
s("breaks125").fit().slice([0,.25,.5,.75], "0 1 1 <2 3>")`
    ],
    scope: "static",
    longname: "Pattern.slice",
    kind: "member"
  },
  {
    comment: `/**
 * Works the same as slice, but changes the playback speed of each slice to match the duration of its step.
 * @name splice
 * @example
 * samples('github:tidalcycles/dirt-samples')
 * s("breaks165")
 * .splice(8,  "0 1 [2 3 0]@2 3 0@2 7")
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2872,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Works the same as slice, but changes the playback speed of each slice to match the duration of its step.</p>",
    name: "splice",
    examples: [
      `samples('github:tidalcycles/dirt-samples')
s("breaks165")
.splice(8,  "0 1 [2 3 0]@2 3 0@2 7")`
    ],
    longname: "splice",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Makes the sample fit its event duration. Good for rhythmical loops like drum breaks.
 * Similar to \`loopAt\`.
 * @name fit
 * @example
 * samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
 * s("rhodes/2").fit()
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2907,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Makes the sample fit its event duration. Good for rhythmical loops like drum breaks.
Similar to <code>loopAt</code>.</p>`,
    name: "fit",
    examples: [
      `samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
s("rhodes/2").fit()`
    ],
    longname: "fit",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Makes the sample fit the given number of cycles and cps value, by
 * changing the speed. Please note that at some point cps will be
 * given by a global clock and this function will be
 * deprecated/removed.
 * @name loopAtCps
 * @memberof Pattern
 * @returns Pattern
 * @example
 * samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
 * s("rhodes").loopAtCps(4,1.5).cps(1.5)
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2927,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Makes the sample fit the given number of cycles and cps value, by
changing the speed. Please note that at some point cps will be
given by a global clock and this function will be
deprecated/removed.</p>`,
    name: "loopAtCps",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `samples({ rhodes: 'https://cdn.freesound.org/previews/132/132051_316502-lq.mp3' })
s("rhodes").loopAtCps(4,1.5).cps(1.5)`
    ],
    scope: "static",
    longname: "Pattern.loopAtCps",
    kind: "member"
  },
  {
    comment: "/** exposes a custom value at query time. basically allows mutating state without evaluation */",
    meta: {
      range: [
        87664,
        87764
      ],
      filename: "pattern.mjs",
      lineno: 2945,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100023140",
        name: "exports.ref",
        type: "VariableDeclaration"
      }
    },
    description: "<p>exposes a custom value at query time. basically allows mutating state without evaluation</p>",
    name: "ref",
    longname: "ref",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Cross-fades between left and right from 0 to 1:
 * - 0 = (full left, no right)
 * - .5 = (both equal)
 * - 1 = (no left, full right)
 *
 * @name xfade
 * @example
 * xfade(s("bd*2"), "<0 .25 .5 .75 1>", s("hh*8"))
 */`,
    meta: {
      filename: "pattern.mjs",
      lineno: 2952,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Cross-fades between left and right from 0 to 1:</p>
<ul>
<li>0 = (full left, no right)</li>
<li>.5 = (both equal)</li>
<li>1 = (no left, full right)</li>
</ul>`,
    name: "xfade",
    examples: [
      'xfade(s("bd*2"), "<0 .25 .5 .75 1>", s("hh*8"))'
    ],
    longname: "xfade",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *  A sawtooth signal between 0 and 1.
 *
 * @return {Pattern}
 * @example
 * note("<c3 [eb3,g3] g2 [g3,bb3]>*8")
 * .clip(saw.slow(2))
 * @example
 * n(saw.range(0,8).segment(8))
 * .scale('C major')
 *
 */`,
    meta: {
      range: [
        1602,
        1642
      ],
      filename: "signal.mjs",
      lineno: 37,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024137",
        name: "exports.saw",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A sawtooth signal between 0 and 1.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `note("<c3 [eb3,g3] g2 [g3,bb3]>*8")
.clip(saw.slow(2))`,
      `n(saw.range(0,8).segment(8))
.scale('C major')`
    ],
    name: "saw",
    longname: "saw",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 *  A sine signal between 0 and 1.
 *
 * @return {Pattern}
 * @example
 * n(sine.segment(16).range(0,15))
 * .scale("C:minor")
 *
 */`,
    meta: {
      range: [
        1883,
        1923
      ],
      filename: "signal.mjs",
      lineno: 51,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024175",
        name: "exports.sine",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A sine signal between 0 and 1.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `n(sine.segment(16).range(0,15))
.scale("C:minor")`
    ],
    name: "sine",
    longname: "sine",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 *  A cosine signal between 0 and 1.
 *
 * @return {Pattern}
 * @example
 * n(stack(sine,cosine).segment(16).range(0,15))
 * .scale("C:minor")
 *
 */`,
    meta: {
      range: [
        2079,
        2133
      ],
      filename: "signal.mjs",
      lineno: 62,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024183",
        name: "exports.cosine",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A cosine signal between 0 and 1.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `n(stack(sine,cosine).segment(16).range(0,15))
.scale("C:minor")`
    ],
    name: "cosine",
    longname: "cosine",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 *  A square signal between 0 and 1.
 *
 * @return {Pattern}
 * @example
 * n(square.segment(4).range(0,7)).scale("C:minor")
 *
 */`,
    meta: {
      range: [
        2328,
        2389
      ],
      filename: "signal.mjs",
      lineno: 73,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024213",
        name: "exports.square",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A square signal between 0 and 1.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'n(square.segment(4).range(0,7)).scale("C:minor")'
    ],
    name: "square",
    longname: "square",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 *  A triangle signal between 0 and 1.
 *
 * @return {Pattern}
 * @example
 * n(tri.segment(8).range(0,7)).scale("C:minor")
 *
 */`,
    meta: {
      range: [
        2569,
        2607
      ],
      filename: "signal.mjs",
      lineno: 84,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024238",
        name: "exports.tri",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A triangle signal between 0 and 1.</p>",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'n(tri.segment(8).range(0,7)).scale("C:minor")'
    ],
    name: "tri",
    longname: "tri",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 *  The mouse's x position value ranges from 0 to 1.
 * @name mousex
 * @return {Pattern}
 * @example
 * n(mousex.segment(4).range(0,7)).scale("C:minor")
 *
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 89,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The mouse's x position value ranges from 0 to 1.</p>",
    name: "mousex",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'n(mousex.segment(4).range(0,7)).scale("C:minor")'
    ],
    longname: "mousex",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *  The mouse's y position value ranges from 0 to 1.
 * @name mousey
 * @return {Pattern}
 * @example
 * n(mousey.segment(4).range(0,7)).scale("C:minor")
 *
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 98,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>The mouse's y position value ranges from 0 to 1.</p>",
    name: "mousey",
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'n(mousey.segment(4).range(0,7)).scale("C:minor")'
    ],
    longname: "mousey",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * A discrete pattern of numbers from 0 to n-1
 * @example
 * n(run(4)).scale("C4:pentatonic")
 * // n("0 1 2 3").scale("C4:pentatonic")
 */`,
    meta: {
      range: [
        4377,
        4438
      ],
      filename: "signal.mjs",
      lineno: 160,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024471",
        name: "exports.run",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A discrete pattern of numbers from 0 to n-1</p>",
    examples: [
      `n(run(4)).scale("C4:pentatonic")
// n("0 1 2 3").scale("C4:pentatonic")`
    ],
    name: "run",
    longname: "run",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * A continuous pattern of random numbers, between 0 and 1.
 *
 * @name rand
 * @example
 * // randomly change the cutoff
 * s("bd*4,hh*8").cutoff(rand.range(500,8000))
 *
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 162,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>A continuous pattern of random numbers, between 0 and 1.</p>",
    name: "rand",
    examples: [
      `// randomly change the cutoff
s("bd*4,hh*8").cutoff(rand.range(500,8000))`
    ],
    longname: "rand",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * A continuous pattern of random numbers, between -1 and 1
 */`,
    meta: {
      range: [
        4728,
        4766
      ],
      filename: "signal.mjs",
      lineno: 175,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024497",
        name: "exports.rand2",
        type: "VariableDeclaration"
      }
    },
    description: "<p>A continuous pattern of random numbers, between -1 and 1</p>",
    name: "rand2",
    longname: "rand2",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * A continuous pattern of 0 or 1 (binary random), with a probability for the value being 1
 *
 * @name brandBy
 * @param {number} probability - a number between 0 and 1
 * @example
 * s("hh*10").pan(brandBy(0.2))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 179,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>A continuous pattern of 0 or 1 (binary random), with a probability for the value being 1</p>",
    name: "brandBy",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>a number between 0 and 1</p>",
        name: "probability"
      }
    ],
    examples: [
      's("hh*10").pan(brandBy(0.2))'
    ],
    longname: "brandBy",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * A continuous pattern of 0 or 1 (binary random)
 *
 * @name brand
 * @example
 * s("hh*10").pan(brand)
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 189,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>A continuous pattern of 0 or 1 (binary random)</p>",
    name: "brand",
    examples: [
      's("hh*10").pan(brand)'
    ],
    longname: "brand",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * A continuous pattern of random integers, between 0 and n-1.
 *
 * @name irand
 * @param {number} n max value (exclusive)
 * @example
 * // randomly select scale notes from 0 - 7 (= C to C)
 * n(irand(8)).struct("x x*2 x x*3").scale("C:minor")
 *
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 200,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>A continuous pattern of random integers, between 0 and n-1.</p>",
    name: "irand",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>max value (exclusive)</p>",
        name: "n"
      }
    ],
    examples: [
      `// randomly select scale notes from 0 - 7 (= C to C)
n(irand(8)).struct("x x*2 x x*3").scale("C:minor")`
    ],
    longname: "irand",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/** * Picks patterns (or plain values) either from a list (by index) or a lookup table (by name).
 * Similar to \`inhabit\`, but maintains the structure of the original patterns.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 * @example
 * note("<0 1 2!2 3>".pick(["g a", "e f", "f g f g" , "g c d"]))
 * @example
 * sound("<0 1 [2,0]>".pick(["bd sd", "cp cp", "hh hh"]))
 * @example
 * sound("<0!2 [0,1] 1>".pick(["bd(3,8)", "sd sd"]))
 * @example
 * s("<a!2 [a,b] b>".pick({a: "bd(3,8)", b: "sd sd"}))
 */`,
    meta: {
      range: [
        6598,
        6800
      ],
      filename: "signal.mjs",
      lineno: 245,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024664",
        name: "exports.pick",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Picks patterns (or plain values) either from a list (by index) or a lookup table (by name).
Similar to <code>inhabit</code>, but maintains the structure of the original patterns.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'note("<0 1 2!2 3>".pick(["g a", "e f", "f g f g" , "g c d"]))',
      'sound("<0 1 [2,0]>".pick(["bd sd", "cp cp", "hh hh"]))',
      'sound("<0!2 [0,1] 1>".pick(["bd(3,8)", "sd sd"]))',
      's("<a!2 [a,b] b>".pick({a: "bd(3,8)", b: "sd sd"}))'
    ],
    name: "pick",
    longname: "pick",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * The same as \`pick\`, but if you pick a number greater than the size of the list,
 * it wraps around, rather than sticking at the maximum value.
 * For example, if you pick the fifth pattern of a list of three, you'll get the
 * second one.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        7225,
        7343
      ],
      filename: "signal.mjs",
      lineno: 266,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024709",
        name: "exports.pickmod",
        type: "VariableDeclaration"
      }
    },
    description: `<p>The same as <code>pick</code>, but if you pick a number greater than the size of the list,
it wraps around, rather than sticking at the maximum value.
For example, if you pick the fifth pattern of a list of three, you'll get the
second one.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickmod",
    longname: "pickmod",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * pickF lets you use a pattern of numbers to pick which function to apply to another pattern.
 * @param {Pattern} pat
 * @param {Pattern} lookup a pattern of indices
 * @param {function[]} funcs the array of functions from which to pull
 * @returns {Pattern}
 * @example
 * s("bd [rim hh]").pickF("<0 1 2>", [rev,jux(rev),fast(2)])
 * @example
 * note("<c2 d2>(3,8)").s("square")
 *     .pickF("<0 2> 1", [jux(rev),fast(2),x=>x.lpf(800)])
 */`,
    meta: {
      range: [
        7792,
        7907
      ],
      filename: "signal.mjs",
      lineno: 281,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024729",
        name: "exports.pickF",
        type: "VariableDeclaration"
      }
    },
    description: "<p>pickF lets you use a pattern of numbers to pick which function to apply to another pattern.</p>",
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        description: "<p>a pattern of indices</p>",
        name: "lookup"
      },
      {
        type: {
          names: [
            "Array.<function()>"
          ]
        },
        description: "<p>the array of functions from which to pull</p>",
        name: "funcs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      's("bd [rim hh]").pickF("<0 1 2>", [rev,jux(rev),fast(2)])',
      `note("<c2 d2>(3,8)").s("square")
    .pickF("<0 2> 1", [jux(rev),fast(2),x=>x.lpf(800)])`
    ],
    name: "pickF",
    longname: "pickF",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * The same as \`pickF\`, but if you pick a number greater than the size of the functions list,
 * it wraps around, rather than sticking at the maximum value.
 * @param {Pattern} pat
 * @param {Pattern} lookup a pattern of indices
 * @param {function[]} funcs the array of functions from which to pull
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        8238,
        8362
      ],
      filename: "signal.mjs",
      lineno: 292,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024750",
        name: "exports.pickmodF",
        type: "VariableDeclaration"
      }
    },
    description: `<p>The same as <code>pickF</code>, but if you pick a number greater than the size of the functions list,
it wraps around, rather than sticking at the maximum value.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        description: "<p>a pattern of indices</p>",
        name: "lookup"
      },
      {
        type: {
          names: [
            "Array.<function()>"
          ]
        },
        description: "<p>the array of functions from which to pull</p>",
        name: "funcs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickmodF",
    longname: "pickmodF",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * Similar to \`pick\`, but it applies an outerJoin instead of an innerJoin.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        8509,
        8628
      ],
      filename: "signal.mjs",
      lineno: 301,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024771",
        name: "exports.pickOut",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Similar to <code>pick</code>, but it applies an outerJoin instead of an innerJoin.</p>",
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickOut",
    longname: "pickOut",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * The same as \`pickOut\`, but if you pick a number greater than the size of the list,
 * it wraps around, rather than sticking at the maximum value.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        8849,
        8973
      ],
      filename: "signal.mjs",
      lineno: 311,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024791",
        name: "exports.pickmodOut",
        type: "VariableDeclaration"
      }
    },
    description: `<p>The same as <code>pickOut</code>, but if you pick a number greater than the size of the list,
it wraps around, rather than sticking at the maximum value.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickmodOut",
    longname: "pickmodOut",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * Similar to \`pick\`, but the choosen pattern is restarted when its index is triggered.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        9133,
        9262
      ],
      filename: "signal.mjs",
      lineno: 320,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024811",
        name: "exports.pickRestart",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Similar to <code>pick</code>, but the choosen pattern is restarted when its index is triggered.</p>",
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickRestart",
    longname: "pickRestart",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * The same as \`pickRestart\`, but if you pick a number greater than the size of the list,
 * it wraps around, rather than sticking at the maximum value.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        9487,
        9621
      ],
      filename: "signal.mjs",
      lineno: 330,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024831",
        name: "exports.pickmodRestart",
        type: "VariableDeclaration"
      }
    },
    description: `<p>The same as <code>pickRestart</code>, but if you pick a number greater than the size of the list,
it wraps around, rather than sticking at the maximum value.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickmodRestart",
    longname: "pickmodRestart",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * Similar to \`pick\`, but the choosen pattern is reset when its index is triggered.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        9777,
        9900
      ],
      filename: "signal.mjs",
      lineno: 339,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024851",
        name: "exports.pickReset",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Similar to <code>pick</code>, but the choosen pattern is reset when its index is triggered.</p>",
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickReset",
    longname: "pickReset",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/** * The same as \`pickReset\`, but if you pick a number greater than the size of the list,
 * it wraps around, rather than sticking at the maximum value.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        10123,
        10251
      ],
      filename: "signal.mjs",
      lineno: 349,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024871",
        name: "exports.pickmodReset",
        type: "VariableDeclaration"
      }
    },
    description: `<p>The same as <code>pickReset</code>, but if you pick a number greater than the size of the list,
it wraps around, rather than sticking at the maximum value.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "pickmodReset",
    longname: "pickmodReset",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
/** * Picks patterns (or plain values) either from a list (by index) or a lookup table (by name).
 * Similar to \`pick\`, but cycles are squeezed into the target ('inhabited') pattern.
 * @name inhabit
 * @synonyms pickSqueeze
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 * @example
 * "<a b [a,b]>".inhabit({a: s("bd(3,8)"),
                          b: s("cp sd")
                         })
 * @example
 * s("a@2 [a b] a".inhabit({a: "bd(3,8)", b: "sd sd"})).slow(4)
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 353,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>/** * Picks patterns (or plain values) either from a list (by index) or a lookup table (by name).
Similar to <code>pick</code>, but cycles are squeezed into the target ('inhabited') pattern.</p>`,
    name: "inhabit",
    synonyms_text: "pickSqueeze",
    synonyms: [
      "pickSqueeze"
    ],
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      `"<a b [a,b]>".inhabit({a: s("bd(3,8)"),
                          b: s("cp sd")
                         })`,
      's("a@2 [a b] a".inhabit({a: "bd(3,8)", b: "sd sd"})).slow(4)'
    ],
    longname: "inhabit",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/** * The same as \`inhabit\`, but if you pick a number greater than the size of the list,
 * it wraps around, rather than sticking at the maximum value.
 * For example, if you pick the fifth pattern of a list of three, you'll get the
 * second one.
 * @name inhabitmod
 * @synonyms pickmodSqueeze
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 372,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>The same as <code>inhabit</code>, but if you pick a number greater than the size of the list,
it wraps around, rather than sticking at the maximum value.
For example, if you pick the fifth pattern of a list of three, you'll get the
second one.</p>`,
    name: "inhabitmod",
    synonyms_text: "pickmodSqueeze",
    synonyms: [
      "pickmodSqueeze"
    ],
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    longname: "inhabitmod",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Pick from the list of values (or patterns of values) via the index using the given
 * pattern of integers. The selected pattern will be compressed to fit the duration of the selecting event
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 * @example
 * note(squeeze("<0@2 [1!2] 2>", ["g a", "f g f g" , "g a c d"]))
 */`,
    meta: {
      range: [
        11780,
        12021
      ],
      filename: "signal.mjs",
      lineno: 397,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100024943",
        name: "exports.squeeze",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Pick from the list of values (or patterns of values) via the index using the given
pattern of integers. The selected pattern will be compressed to fit the duration of the selecting event</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'note(squeeze("<0@2 [1!2] 2>", ["g a", "f g f g" , "g a c d"]))'
    ],
    name: "squeeze",
    longname: "squeeze",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Choose from the list of values (or patterns of values) using the given
 * pattern of numbers, which should be in the range of 0..1
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 * @example
 * note("c2 g2!2 d2 f1").s(chooseWith(sine.fast(2), ["sawtooth", "triangle", "bd:6"]))
 */`,
    meta: {
      range: [
        12586,
        12673
      ],
      filename: "signal.mjs",
      lineno: 430,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025062",
        name: "exports.chooseWith",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Choose from the list of values (or patterns of values) using the given
pattern of numbers, which should be in the range of 0..1</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'note("c2 g2!2 d2 f1").s(chooseWith(sine.fast(2), ["sawtooth", "triangle", "bd:6"]))'
    ],
    name: "chooseWith",
    longname: "chooseWith",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * As with {chooseWith}, but the structure comes from the chosen values, rather
 * than the pattern you're using to choose with.
 * @param {Pattern} pat
 * @param {*} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        12875,
        12964
      ],
      filename: "signal.mjs",
      lineno: 441,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025078",
        name: "exports.chooseInWith",
        type: "VariableDeclaration"
      }
    },
    description: `<p>As with {chooseWith}, but the structure comes from the chosen values, rather
than the pattern you're using to choose with.</p>`,
    params: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        name: "pat"
      },
      {
        type: {
          names: [
            "*"
          ]
        },
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "chooseInWith",
    longname: "chooseInWith",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Chooses randomly from the given list of elements.
 * @param  {...any} xs values / patterns to choose from.
 * @returns {Pattern} - a continuous pattern.
 * @example
 * note("c2 g2!2 d2 f1").s(choose("sine", "triangle", "bd:6"))
 */`,
    meta: {
      range: [
        13205,
        13259
      ],
      filename: "signal.mjs",
      lineno: 452,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025094",
        name: "exports.choose",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Chooses randomly from the given list of elements.</p>",
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        description: "<p>values / patterns to choose from.</p>",
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        description: `<ul>
<li>a continuous pattern.</li>
</ul>`
      }
    ],
    examples: [
      'note("c2 g2!2 d2 f1").s(choose("sine", "triangle", "bd:6"))'
    ],
    name: "choose",
    longname: "choose",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Chooses from the given list of values (or patterns of values), according
 * to the pattern that the method is called on. The pattern should be in
 * the range 0 .. 1.
 * @param  {...any} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        13484,
        13562
      ],
      filename: "signal.mjs",
      lineno: 461,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025106",
        name: "Pattern.prototype.choose",
        type: "FunctionExpression",
        paramnames: [
          "xs"
        ]
      }
    },
    description: `<p>Chooses from the given list of values (or patterns of values), according
to the pattern that the method is called on. The pattern should be in
the range 0 .. 1.</p>`,
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "choose",
    longname: "Pattern#choose",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * As with choose, but the pattern that this method is called on should be
 * in the range -1 .. 1
 * @param  {...any} xs
 * @returns {Pattern}
 */`,
    meta: {
      range: [
        13717,
        13810
      ],
      filename: "signal.mjs",
      lineno: 471,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025122",
        name: "Pattern.prototype.choose2",
        type: "FunctionExpression",
        paramnames: [
          "xs"
        ]
      }
    },
    description: `<p>As with choose, but the pattern that this method is called on should be
in the range -1 .. 1</p>`,
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        name: "xs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    name: "choose2",
    longname: "Pattern#choose2",
    kind: "function",
    memberof: "Pattern",
    scope: "instance"
  },
  {
    comment: `/**
 * Picks one of the elements at random each cycle.
 * @synonyms randcat
 * @returns {Pattern}
 * @example
 * chooseCycles("bd", "hh", "sd").s().fast(8)
 * @example
 * s("bd | hh | sd").fast(8)
 */`,
    meta: {
      range: [
        14014,
        14087
      ],
      filename: "signal.mjs",
      lineno: 484,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025140",
        name: "exports.chooseCycles",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Picks one of the elements at random each cycle.</p>",
    synonyms_text: "randcat",
    synonyms: [
      "randcat"
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'chooseCycles("bd", "hh", "sd").s().fast(8)',
      's("bd | hh | sd").fast(8)'
    ],
    name: "chooseCycles",
    longname: "chooseCycles",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Chooses randomly from the given list of elements by giving a probability to each element
 * @param {...any} pairs arrays of value and weight
 * @returns {Pattern} - a continuous pattern.
 * @example
 * note("c2 g2!2 d2 f1").s(wchoose(["sine",10], ["triangle",1], ["bd:6",1]))
 */`,
    meta: {
      range: [
        14886,
        14951
      ],
      filename: "signal.mjs",
      lineno: 513,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025256",
        name: "exports.wchoose",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Chooses randomly from the given list of elements by giving a probability to each element</p>",
    params: [
      {
        type: {
          names: [
            "any"
          ]
        },
        variable: !0,
        description: "<p>arrays of value and weight</p>",
        name: "pairs"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        },
        description: `<ul>
<li>a continuous pattern.</li>
</ul>`
      }
    ],
    examples: [
      'note("c2 g2!2 d2 f1").s(wchoose(["sine",10], ["triangle",1], ["bd:6",1]))'
    ],
    name: "wchoose",
    longname: "wchoose",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Picks one of the elements at random each cycle by giving a probability to each element
 * @synonyms wrandcat
 * @returns {Pattern}
 * @example
 * wchooseCycles(["bd",10], ["hh",1], ["sd",1]).s().fast(8)
 * @example
 * wchooseCycles(["bd bd bd",5], ["hh hh hh",3], ["sd sd sd",1]).fast(4).s()
 */`,
    meta: {
      range: [
        15256,
        15351
      ],
      filename: "signal.mjs",
      lineno: 524,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100025268",
        name: "exports.wchooseCycles",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Picks one of the elements at random each cycle by giving a probability to each element</p>",
    synonyms_text: "wrandcat",
    synonyms: [
      "wrandcat"
    ],
    returns: [
      {
        type: {
          names: [
            "Pattern"
          ]
        }
      }
    ],
    examples: [
      'wchooseCycles(["bd",10], ["hh",1], ["sd",1]).s().fast(8)',
      'wchooseCycles(["bd bd bd",5], ["hh hh hh",3], ["sd sd sd",1]).fast(4).s()'
    ],
    name: "wchooseCycles",
    longname: "wchooseCycles",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Generates a continuous pattern of [perlin noise](https://en.wikipedia.org/wiki/Perlin_noise), in the range 0..1.
 *
 * @name perlin
 * @example
 * // randomly change the cutoff
 * s("bd*4,hh*8").cutoff(perlin.range(500,8000))
 *
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 537,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: '<p>Generates a continuous pattern of <a href="https://en.wikipedia.org/wiki/Perlin_noise">perlin noise</a>, in the range 0..1.</p>',
    name: "perlin",
    examples: [
      `// randomly change the cutoff
s("bd*4,hh*8").cutoff(perlin.range(500,8000))`
    ],
    longname: "perlin",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Randomly removes events from the pattern by a given amount.
 * 0 = 0% chance of removal
 * 1 = 100% chance of removal
 *
 * @name degradeBy
 * @memberof Pattern
 * @param {number} amount - a number between 0 and 1
 * @returns Pattern
 * @example
 * s("hh*8").degradeBy(0.2)
 * @example
 * s("[hh?0.2]*8")
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 552,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Randomly removes events from the pattern by a given amount.
0 = 0% chance of removal
1 = 100% chance of removal</p>`,
    name: "degradeBy",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>a number between 0 and 1</p>",
        name: "amount"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").degradeBy(0.2)',
      's("[hh?0.2]*8")'
    ],
    scope: "static",
    longname: "Pattern.degradeBy",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Randomly removes 50% of events from the pattern. Shorthand for \`.degradeBy(0.5)\`
 *
 * @name degrade
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").degrade()
 * @example
 * s("[hh?]*8")
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 570,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Randomly removes 50% of events from the pattern. Shorthand for <code>.degradeBy(0.5)</code></p>",
    name: "degrade",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").degrade()',
      's("[hh?]*8")'
    ],
    scope: "static",
    longname: "Pattern.degrade",
    kind: "member"
  },
  {
    comment: `/**
 * Inverse of \`degradeBy\`: Randomly removes events from the pattern by a given amount.
 * 0 = 100% chance of removal
 * 1 = 0% chance of removal
 * Events that would be removed by degradeBy are let through by undegradeBy and vice versa (see second example).
 *
 * @name undegradeBy
 * @memberof Pattern
 * @param {number} amount - a number between 0 and 1
 * @returns Pattern
 * @example
 * s("hh*8").undegradeBy(0.2)
 * @example
 * s("hh*10").layer(
 *   x => x.degradeBy(0.2).pan(0),
 *   x => x.undegradeBy(0.8).pan(1)
 * )
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 584,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Inverse of <code>degradeBy</code>: Randomly removes events from the pattern by a given amount.
0 = 100% chance of removal
1 = 0% chance of removal
Events that would be removed by degradeBy are let through by undegradeBy and vice versa (see second example).</p>`,
    name: "undegradeBy",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>a number between 0 and 1</p>",
        name: "amount"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").undegradeBy(0.2)',
      `s("hh*10").layer(
  x => x.degradeBy(0.2).pan(0),
  x => x.undegradeBy(0.8).pan(1)
)`
    ],
    scope: "static",
    longname: "Pattern.undegradeBy",
    kind: "member"
  },
  {
    comment: `/**
 * Inverse of \`degrade\`: Randomly removes 50% of events from the pattern. Shorthand for \`.undegradeBy(0.5)\`
 * Events that would be removed by degrade are let through by undegrade and vice versa (see second example).
 *
 * @name undegrade
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").undegrade()
 * @example
 * s("hh*10").layer(
 *   x => x.degrade().pan(0),
 *   x => x.undegrade().pan(1)
 * )
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 609,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Inverse of <code>degrade</code>: Randomly removes 50% of events from the pattern. Shorthand for <code>.undegradeBy(0.5)</code>
Events that would be removed by degrade are let through by undegrade and vice versa (see second example).</p>`,
    name: "undegrade",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").undegrade()',
      `s("hh*10").layer(
  x => x.degrade().pan(0),
  x => x.undegrade().pan(1)
)`
    ],
    scope: "static",
    longname: "Pattern.undegrade",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Randomly applies the given function by the given probability.
 * Similar to \`someCyclesBy\`
 *
 * @name sometimesBy
 * @memberof Pattern
 * @param {number | Pattern} probability - a number between 0 and 1
 * @param {function} function - the transformation to apply
 * @returns Pattern
 * @example
 * s("hh*8").sometimesBy(.4, x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 626,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Randomly applies the given function by the given probability.
Similar to <code>someCyclesBy</code></p>`,
    name: "sometimesBy",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>a number between 0 and 1</p>",
        name: "probability"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the transformation to apply</p>",
        name: "function"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").sometimesBy(.4, x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.sometimesBy",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Applies the given function with a 50% chance
 *
 * @name sometimes
 * @memberof Pattern
 * @param {function} function - the transformation to apply
 * @returns Pattern
 * @example
 * s("hh*8").sometimes(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 646,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Applies the given function with a 50% chance</p>",
    name: "sometimes",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the transformation to apply</p>",
        name: "function"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").sometimes(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.sometimes",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Randomly applies the given function by the given probability on a cycle by cycle basis.
 * Similar to \`sometimesBy\`
 *
 * @name someCyclesBy
 * @memberof Pattern
 * @param {number | Pattern} probability - a number between 0 and 1
 * @param {function} function - the transformation to apply
 * @returns Pattern
 * @example
 * s("bd,hh*8").someCyclesBy(.3, x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 661,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: `<p>Randomly applies the given function by the given probability on a cycle by cycle basis.
Similar to <code>sometimesBy</code></p>`,
    name: "someCyclesBy",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "number",
            "Pattern"
          ]
        },
        description: "<p>a number between 0 and 1</p>",
        name: "probability"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        description: "<p>the transformation to apply</p>",
        name: "function"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("bd,hh*8").someCyclesBy(.3, x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.someCyclesBy",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.someCyclesBy(0.5, fn)\`
 *
 * @name someCycles
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("bd,hh*8").someCycles(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 686,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.someCyclesBy(0.5, fn)</code></p>",
    name: "someCycles",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("bd,hh*8").someCycles(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.someCycles",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(0.75, fn)\`
 *
 * @name often
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").often(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 700,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(0.75, fn)</code></p>",
    name: "often",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").often(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.often",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(0.25, fn)\`
 *
 * @name rarely
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").rarely(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 714,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(0.25, fn)</code></p>",
    name: "rarely",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").rarely(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.rarely",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(0.1, fn)\`
 *
 * @name almostNever
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").almostNever(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 728,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(0.1, fn)</code></p>",
    name: "almostNever",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").almostNever(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.almostNever",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(0.9, fn)\`
 *
 * @name almostAlways
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").almostAlways(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 742,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(0.9, fn)</code></p>",
    name: "almostAlways",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").almostAlways(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.almostAlways",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(0, fn)\` (never calls fn)
 *
 * @name never
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").never(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 756,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(0, fn)</code> (never calls fn)</p>",
    name: "never",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").never(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.never",
    kind: "member"
  },
  {
    comment: `/**
 *
 * Shorthand for \`.sometimesBy(1, fn)\` (always calls fn)
 *
 * @name always
 * @memberof Pattern
 * @returns Pattern
 * @example
 * s("hh*8").always(x=>x.speed("0.5"))
 */`,
    meta: {
      filename: "signal.mjs",
      lineno: 770,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {}
    },
    description: "<p>Shorthand for <code>.sometimesBy(1, fn)</code> (always calls fn)</p>",
    name: "always",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      's("hh*8").always(x=>x.speed("0.5"))'
    ],
    scope: "static",
    longname: "Pattern.always",
    kind: "member"
  },
  {
    comment: `/**
 * @deprecated does not appear to be referenced or invoked anywhere in the codebase
 * @noAutocomplete
 */`,
    meta: {
      range: [
        2812,
        2979
      ],
      filename: "util.mjs",
      lineno: 73,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100037042",
        name: "exports.getFreq",
        type: "VariableDeclaration"
      }
    },
    deprecated: "does not appear to be referenced or invoked anywhere in the codebase",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "getFreq",
    longname: "getFreq",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * @deprecated only used in workshop (first-notes)
 * @noAutocomplete
 */`,
    meta: {
      range: [
        3138,
        3257
      ],
      filename: "util.mjs",
      lineno: 85,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/core",
      code: {
        id: "astnode100037081",
        name: "exports.midi2note",
        type: "VariableDeclaration"
      }
    },
    deprecated: "only used in workshop (first-notes)",
    tags: [
      {
        originalTitle: "noAutocomplete",
        title: "noautocomplete",
        text: ""
      }
    ],
    name: "midi2note",
    longname: "midi2note",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Sends notes to Csound for rendering with MIDI semantics. The hap value is
 * translated to these Csound pfields:
 *
 *  p1 -- Csound instrument either as a number (1-based, can be a fraction),
 *        or as a string name.
 *  p2 -- time in beats (usually seconds) from start of performance.
 *  p3 -- duration in beats (usually seconds).
 *  p4 -- MIDI key number (as a real number, not an integer but in [0, 127].
 *  p5 -- MIDI velocity (as a real number, not an integer but in [0, 127].
 *  p6 -- Strudel controls, as a string.
 */`,
    meta: {
      range: [
        4695,
        6078
      ],
      filename: "index.mjs",
      lineno: 139,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/csound",
      code: {
        id: "astnode100039257",
        name: "exports.csoundm",
        type: "VariableDeclaration"
      }
    },
    description: `<p>Sends notes to Csound for rendering with MIDI semantics. The hap value is
translated to these Csound pfields:</p>
<p>p1 -- Csound instrument either as a number (1-based, can be a fraction),
or as a string name.
p2 -- time in beats (usually seconds) from start of performance.
p3 -- duration in beats (usually seconds).
p4 -- MIDI key number (as a real number, not an integer but in [0, 127].
p5 -- MIDI velocity (as a real number, not an integer but in [0, 127].
p6 -- Strudel controls, as a string.</p>`,
    name: "csoundm",
    longname: "csoundm",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Displays a midi-style piano roll
 *
 * @name pianoroll
 * @param {Object} options Object containing all the optional following parameters as key value pairs:
 * @param {integer} cycles number of cycles to be displayed at the same time - defaults to 4
 * @param {number} playhead location of the active notes on the time axis - 0 to 1, defaults to 0.5
 * @param {boolean} vertical displays the roll vertically - 0 by default
 * @param {boolean} labels displays labels on individual notes (see the label function) - 0 by default
 * @param {boolean} flipTime reverse the direction of the roll - 0 by default
 * @param {boolean} flipValues reverse the relative location of notes on the value axis - 0 by default
 * @param {number} overscan lookup X cycles outside of the cycles window to display notes in advance - 1 by default
 * @param {boolean} hideNegative hide notes with negative time (before starting playing the pattern) - 0 by default
 * @param {boolean} smear notes leave a solid trace - 0 by default
 * @param {boolean} fold notes takes the full value axis width - 0 by default
 * @param {string} active hexadecimal or CSS color of the active notes - defaults to #FFCA28
 * @param {string} inactive hexadecimal or CSS color of the inactive notes - defaults to #7491D2
 * @param {string} background hexadecimal or CSS color of the background - defaults to transparent
 * @param {string} playheadColor hexadecimal or CSS color of the line representing the play head - defaults to white
 * @param {boolean} fill notes are filled with color (otherwise only the label is displayed) - 0 by default
 * @param {boolean} fillActive active notes are filled with color - 0 by default
 * @param {boolean} stroke notes are shown with colored borders - 0 by default
 * @param {boolean} strokeActive active notes are shown with colored borders - 0 by default
 * @param {boolean} hideInactive only active notes are shown - 0 by default
 * @param {boolean} colorizeInactive use note color for inactive notes - 1 by default
 * @param {string} fontFamily define the font used by notes labels - defaults to 'monospace'
 * @param {integer} minMidi minimum note value to display on the value axis - defaults to 10
 * @param {integer} maxMidi maximum note value to display on the value axis - defaults to 90
 * @param {boolean} autorange automatically calculate the minMidi and maxMidi parameters - 0 by default
 *
 * @example
 * note("C2 A2 G2").euclid(5,8).s('piano').clip(1).color('salmon').pianoroll({vertical:1, labels:1})
 */`,
    meta: {
      filename: "pianoroll.mjs",
      lineno: 66,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/draw",
      code: {}
    },
    description: "<p>Displays a midi-style piano roll</p>",
    name: "pianoroll",
    params: [
      {
        type: {
          names: [
            "Object"
          ]
        },
        description: "<p>Object containing all the optional following parameters as key value pairs:</p>",
        name: "options"
      },
      {
        type: {
          names: [
            "integer"
          ]
        },
        description: "<p>number of cycles to be displayed at the same time - defaults to 4</p>",
        name: "cycles"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>location of the active notes on the time axis - 0 to 1, defaults to 0.5</p>",
        name: "playhead"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>displays the roll vertically - 0 by default</p>",
        name: "vertical"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>displays labels on individual notes (see the label function) - 0 by default</p>",
        name: "labels"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>reverse the direction of the roll - 0 by default</p>",
        name: "flipTime"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>reverse the relative location of notes on the value axis - 0 by default</p>",
        name: "flipValues"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>lookup X cycles outside of the cycles window to display notes in advance - 1 by default</p>",
        name: "overscan"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>hide notes with negative time (before starting playing the pattern) - 0 by default</p>",
        name: "hideNegative"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>notes leave a solid trace - 0 by default</p>",
        name: "smear"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>notes takes the full value axis width - 0 by default</p>",
        name: "fold"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>hexadecimal or CSS color of the active notes - defaults to #FFCA28</p>",
        name: "active"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>hexadecimal or CSS color of the inactive notes - defaults to #7491D2</p>",
        name: "inactive"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>hexadecimal or CSS color of the background - defaults to transparent</p>",
        name: "background"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>hexadecimal or CSS color of the line representing the play head - defaults to white</p>",
        name: "playheadColor"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>notes are filled with color (otherwise only the label is displayed) - 0 by default</p>",
        name: "fill"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>active notes are filled with color - 0 by default</p>",
        name: "fillActive"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>notes are shown with colored borders - 0 by default</p>",
        name: "stroke"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>active notes are shown with colored borders - 0 by default</p>",
        name: "strokeActive"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>only active notes are shown - 0 by default</p>",
        name: "hideInactive"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>use note color for inactive notes - 1 by default</p>",
        name: "colorizeInactive"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>define the font used by notes labels - defaults to 'monospace'</p>",
        name: "fontFamily"
      },
      {
        type: {
          names: [
            "integer"
          ]
        },
        description: "<p>minimum note value to display on the value axis - defaults to 10</p>",
        name: "minMidi"
      },
      {
        type: {
          names: [
            "integer"
          ]
        },
        description: "<p>maximum note value to display on the value axis - defaults to 90</p>",
        name: "maxMidi"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>automatically calculate the minMidi and maxMidi parameters - 0 by default</p>",
        name: "autorange"
      }
    ],
    examples: [
      `note("C2 A2 G2").euclid(5,8).s('piano').clip(1).color('salmon').pianoroll({vertical:1, labels:1})`
    ],
    longname: "pianoroll",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Displays a vertical pianoroll with event labels.
 * Supports all the same options as pianoroll.
 *
 * @name wordfall
 */`,
    meta: {
      filename: "pianoroll.mjs",
      lineno: 282,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/draw",
      code: {}
    },
    description: `<p>Displays a vertical pianoroll with event labels.
Supports all the same options as pianoroll.</p>`,
    name: "wordfall",
    longname: "wordfall",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 *
 * Sends each hap as an OSC message, which can be picked up by SuperCollider or any other OSC-enabled software.
 * For more info, read [MIDI & OSC in the docs](https://strudel.cc/learn/input-output/)
 *
 * @name osc
 * @memberof Pattern
 * @returns Pattern
 */`,
    meta: {
      filename: "osc.mjs",
      lineno: 37,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/osc",
      code: {}
    },
    description: `<p>Sends each hap as an OSC message, which can be picked up by SuperCollider or any other OSC-enabled software.
For more info, read <a href="https://strudel.cc/learn/input-output/">MIDI &amp; OSC in the docs</a></p>`,
    name: "osc",
    memberof: "Pattern",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    scope: "static",
    longname: "Pattern.osc",
    kind: "member"
  },
  {
    comment: `/** Generates a reverb impulse response.

 @param {!Object} params TODO: Document the properties.
 @param {!function(!AudioBuffer)} callback Function to call when
  the impulse response has been generated. The impulse response
  is passed to this function as its parameter. May be called
  immediately within the current execution context, or later. */`,
    meta: {
      range: [
        969,
        2138
      ],
      filename: "reverbGen.mjs",
      lineno: 24,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100070097",
        name: "reverbGen.generateReverb",
        type: "FunctionExpression",
        paramnames: [
          "params",
          "callback"
        ]
      },
      vars: {
        audioContext: "reverbGen.generateReverb~audioContext",
        sampleRate: "reverbGen.generateReverb~sampleRate",
        numChannels: "reverbGen.generateReverb~numChannels",
        totalTime: "reverbGen.generateReverb~totalTime",
        decaySampleFrames: "reverbGen.generateReverb~decaySampleFrames",
        numSampleFrames: "reverbGen.generateReverb~numSampleFrames",
        fadeInSampleFrames: "reverbGen.generateReverb~fadeInSampleFrames",
        decayBase: "reverbGen.generateReverb~decayBase",
        reverbIR: "reverbGen.generateReverb~reverbIR",
        i: "reverbGen.generateReverb~i",
        chan: "reverbGen.generateReverb~chan",
        j: "reverbGen.generateReverb~j",
        "chan[undefined]": "reverbGen.generateReverb~chan.undefined]"
      }
    },
    description: "<p>Generates a reverb impulse response.</p>",
    params: [
      {
        type: {
          names: [
            "Object"
          ]
        },
        nullable: !1,
        description: "<p>TODO: Document the properties.</p>",
        name: "params"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        nullable: !1,
        description: `<p>Function to call when
the impulse response has been generated. The impulse response
is passed to this function as its parameter. May be called
immediately within the current execution context, or later.</p>`,
        name: "callback"
      }
    ],
    name: "generateReverb",
    longname: "reverbGen.generateReverb",
    kind: "function",
    memberof: "reverbGen",
    scope: "static"
  },
  {
    comment: `/** Creates a canvas element showing a graph of the given data.


 @param {!Float32Array} data An array of numbers, or a Float32Array.
 @param {number} width Width in pixels of the canvas.
 @param {number} height Height in pixels of the canvas.
 @param {number} min Minimum value of data for the graph (lower edge).
 @param {number} max Maximum value of data in the graph (upper edge).
 @return {!CanvasElement} The generated canvas element. */`,
    meta: {
      range: [
        2586,
        3097
      ],
      filename: "reverbGen.mjs",
      lineno: 58,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100070277",
        name: "reverbGen.generateGraph",
        type: "FunctionExpression",
        paramnames: [
          "data",
          "width",
          "height",
          "min",
          "max"
        ]
      },
      vars: {
        canvas: "reverbGen.generateGraph~canvas",
        "canvas.width": "reverbGen.generateGraph~canvas.width",
        "canvas.height": "reverbGen.generateGraph~canvas.height",
        gc: "reverbGen.generateGraph~gc",
        "gc.fillStyle": "reverbGen.generateGraph~gc.fillStyle",
        xscale: "reverbGen.generateGraph~xscale",
        yscale: "reverbGen.generateGraph~yscale",
        i: "reverbGen.generateGraph~i"
      }
    },
    description: "<p>Creates a canvas element showing a graph of the given data.</p>",
    params: [
      {
        type: {
          names: [
            "Float32Array"
          ]
        },
        nullable: !1,
        description: "<p>An array of numbers, or a Float32Array.</p>",
        name: "data"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Width in pixels of the canvas.</p>",
        name: "width"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Height in pixels of the canvas.</p>",
        name: "height"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Minimum value of data for the graph (lower edge).</p>",
        name: "min"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>Maximum value of data in the graph (upper edge).</p>",
        name: "max"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "CanvasElement"
          ]
        },
        nullable: !1,
        description: "<p>The generated canvas element.</p>"
      }
    ],
    name: "generateGraph",
    longname: "reverbGen.generateGraph",
    kind: "function",
    memberof: "reverbGen",
    scope: "static"
  },
  {
    comment: `/** Applies a constantly changing lowpass filter to the given sound.

 @private
 @param {!AudioBuffer} input
 @param {number} lpFreqStart
 @param {number} lpFreqEnd
 @param {number} lpFreqEndAt
 @param {!function(!AudioBuffer)} callback May be called
  immediately within the current execution context, or later.*/`,
    meta: {
      range: [
        3419,
        4357
      ],
      filename: "reverbGen.mjs",
      lineno: 83,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100070392",
        name: "applyGradualLowpass",
        type: "FunctionExpression"
      },
      vars: {
        channelData: "applyGradualLowpass~channelData",
        context: "applyGradualLowpass~context",
        player: "applyGradualLowpass~player",
        "player.buffer": "applyGradualLowpass~player.buffer",
        filter: "applyGradualLowpass~filter",
        lpFreqStart: "applyGradualLowpass~lpFreqStart",
        lpFreqEnd: "applyGradualLowpass~lpFreqEnd",
        "filter.type": "applyGradualLowpass~filter.type",
        "filter.Q.value": "applyGradualLowpass~filter.Q.value",
        "context.oncomplete": "applyGradualLowpass~context.oncomplete",
        "": null,
        "window.filterNode": "window.filterNode"
      }
    },
    description: "<p>Applies a constantly changing lowpass filter to the given sound.</p>",
    access: "private",
    params: [
      {
        type: {
          names: [
            "AudioBuffer"
          ]
        },
        nullable: !1,
        name: "input"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "lpFreqStart"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "lpFreqEnd"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        name: "lpFreqEndAt"
      },
      {
        type: {
          names: [
            "function"
          ]
        },
        nullable: !1,
        description: `<p>May be called
immediately within the current execution context, or later.</p>`,
        name: "callback"
      }
    ],
    name: "applyGradualLowpass",
    longname: "applyGradualLowpass",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** @private
 @param {!AudioBuffer} buffer
 @return {!Array.<!Float32Array>} An array containing the Float32Array of each channel's samples. */`,
    meta: {
      range: [
        4508,
        4691
      ],
      filename: "reverbGen.mjs",
      lineno: 116,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100070556",
        name: "getAllChannelData",
        type: "FunctionExpression"
      },
      vars: {
        channels: "getAllChannelData~channels",
        i: "getAllChannelData~i",
        "channels[undefined]": "getAllChannelData~channels.undefined]"
      }
    },
    access: "private",
    params: [
      {
        type: {
          names: [
            "AudioBuffer"
          ]
        },
        nullable: !1,
        name: "buffer"
      }
    ],
    returns: [
      {
        type: {
          names: [
            "Array.<!Float32Array>"
          ]
        },
        nullable: !1,
        description: "<p>An array containing the Float32Array of each channel's samples.</p>"
      }
    ],
    name: "getAllChannelData",
    longname: "getAllChannelData",
    kind: "function",
    scope: "global"
  },
  {
    comment: `/** @private
 @return {number} A random number from -1 to 1. */`,
    meta: {
      range: [
        4762,
        4824
      ],
      filename: "reverbGen.mjs",
      lineno: 126,
      columnno: 4,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100070591",
        name: "randomSample",
        type: "FunctionExpression"
      }
    },
    access: "private",
    returns: [
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>A random number from -1 to 1.</p>"
      }
    ],
    name: "randomSample",
    longname: "randomSample",
    kind: "function",
    scope: "global",
    params: []
  },
  {
    comment: `/**
 * Loads a collection of samples to use with \`s\`
 * @example
 * samples('github:tidalcycles/dirt-samples');
 * s("[bd ~]*2, [~ hh]*2, ~ sd")
 * @example
 * samples({
 *  bd: '808bd/BD0000.WAV',
 *  sd: '808sd/SD0010.WAV'
 *  }, 'https://raw.githubusercontent.com/tidalcycles/Dirt-Samples/master/');
 * s("[bd ~]*2, [~ hh]*2, ~ sd")
 * @example
 * samples('shabda:noise,chimp:2')
 * s("noise <chimp:0*2 chimp:1>")
 * @example
 * samples('shabda/speech/fr-FR/f:chocolat')
 * s("chocolat*4")
 */`,
    meta: {
      range: [
        6005,
        7989
      ],
      filename: "sampler.mjs",
      lineno: 186,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/superdough",
      code: {
        id: "astnode100071442",
        name: "exports.samples",
        type: "VariableDeclaration"
      }
    },
    description: "<p>Loads a collection of samples to use with <code>s</code></p>",
    examples: [
      `samples('github:tidalcycles/dirt-samples');
s("[bd ~]*2, [~ hh]*2, ~ sd")`,
      `samples({
 bd: '808bd/BD0000.WAV',
 sd: '808sd/SD0010.WAV'
 }, 'https://raw.githubusercontent.com/tidalcycles/Dirt-Samples/master/');
s("[bd ~]*2, [~ hh]*2, ~ sd")`,
      `samples('shabda:noise,chimp:2')
s("noise <chimp:0*2 chimp:1>")`,
      `samples('shabda/speech/fr-FR/f:chocolat')
s("chocolat*4")`
    ],
    name: "samples",
    longname: "samples",
    kind: "constant",
    scope: "global"
  },
  {
    comment: `/**
 * Change the pitch of each value by the given amount. Expects numbers or note strings as values.
 * The amount can be given as a number of semitones or as a string in interval short notation.
 * If you don't care about enharmonic correctness, just use numbers. Otherwise, pass the interval of
 * the form: ST where S is the degree number and T the type of interval with
 *
 * - M = major
 * - m = minor
 * - P = perfect
 * - A = augmented
 * - d = diminished
 *
 * Examples intervals:
 *
 * - 1P = unison
 * - 3M = major third
 * - 3m = minor third
 * - 4P = perfect fourth
 * - 4A = augmented fourth
 * - 5P = perfect fifth
 * - 5d = diminished fifth
 *
 * @param {string | number} amount Either number of semitones or interval string.
 * @returns Pattern
 * @memberof Pattern
 * @name transpose
 * @example
 * "c2 c3".fast(2).transpose("<0 -2 5 3>".slow(2)).note()
 * @example
 * "c2 c3".fast(2).transpose("<1P -2M 4P 3m>".slow(2)).note()
 */`,
    meta: {
      filename: "tonal.mjs",
      lineno: 65,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: `<p>Change the pitch of each value by the given amount. Expects numbers or note strings as values.
The amount can be given as a number of semitones or as a string in interval short notation.
If you don't care about enharmonic correctness, just use numbers. Otherwise, pass the interval of
the form: ST where S is the degree number and T the type of interval with</p>
<ul>
<li>M = major</li>
<li>m = minor</li>
<li>P = perfect</li>
<li>A = augmented</li>
<li>d = diminished</li>
</ul>
<p>Examples intervals:</p>
<ul>
<li>1P = unison</li>
<li>3M = major third</li>
<li>3m = minor third</li>
<li>4P = perfect fourth</li>
<li>4A = augmented fourth</li>
<li>5P = perfect fifth</li>
<li>5d = diminished fifth</li>
</ul>`,
    params: [
      {
        type: {
          names: [
            "string",
            "number"
          ]
        },
        description: "<p>Either number of semitones or interval string.</p>",
        name: "amount"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    memberof: "Pattern",
    name: "transpose",
    examples: [
      '"c2 c3".fast(2).transpose("<0 -2 5 3>".slow(2)).note()',
      '"c2 c3".fast(2).transpose("<1P -2M 4P 3m>".slow(2)).note()'
    ],
    scope: "static",
    longname: "Pattern.transpose",
    kind: "member"
  },
  {
    comment: `/**
 * Transposes notes inside the scale by the number of steps.
 * Expected to be called on a Pattern which already has a {@link Pattern#scale}
 *
 * @memberof Pattern
 * @name scaleTranspose
 * @param {offset} offset number of steps inside the scale
 * @returns Pattern
 * @example
 * "-8 [2,4,6]"
 * .scale('C4 bebop major')
 * .scaleTranspose("<0 -1 -2 -3 -4 -5 -6 -4>")
 * .note()
 */`,
    meta: {
      filename: "tonal.mjs",
      lineno: 137,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: `<p>Transposes notes inside the scale by the number of steps.
Expected to be called on a Pattern which already has a {@link Pattern#scale}</p>`,
    memberof: "Pattern",
    name: "scaleTranspose",
    params: [
      {
        type: {
          names: [
            "offset"
          ]
        },
        description: "<p>number of steps inside the scale</p>",
        name: "offset"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `"-8 [2,4,6]"
.scale('C4 bebop major')
.scaleTranspose("<0 -1 -2 -3 -4 -5 -6 -4>")
.note()`
    ],
    scope: "static",
    longname: "Pattern.scaleTranspose",
    kind: "member"
  },
  {
    comment: `/**
 * Turns numbers into notes in the scale (zero indexed). Also sets scale for other scale operations, like {@link Pattern#scaleTranspose}.
 *
 * A scale consists of a root note (e.g. \`c4\`, \`c\`, \`f#\`, \`bb4\`) followed by semicolon (':') and then a [scale type](https://github.com/tonaljs/tonal/blob/main/packages/scale-type/data.ts).
 *
 * The root note defaults to octave 3, if no octave number is given.
 *
 * @name scale
 * @param {string} scale Name of scale
 * @returns Pattern
 * @example
 * n("0 2 4 6 4 2").scale("C:major")
 * @example
 * n("[0,7] 4 [2,7] 4")
 * .scale("C:<major minor>/2")
 * .s("piano")
 * @example
 * n(rand.range(0,12).segment(8))
 * .scale("C:ritusen")
 * .s("piano")
 */`,
    meta: {
      filename: "tonal.mjs",
      lineno: 169,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: `<p>Turns numbers into notes in the scale (zero indexed). Also sets scale for other scale operations, like {@link Pattern#scaleTranspose}.</p>
<p>A scale consists of a root note (e.g. <code>c4</code>, <code>c</code>, <code>f#</code>, <code>bb4</code>) followed by semicolon (':') and then a <a href="https://github.com/tonaljs/tonal/blob/main/packages/scale-type/data.ts">scale type</a>.</p>
<p>The root note defaults to octave 3, if no octave number is given.</p>`,
    name: "scale",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>Name of scale</p>",
        name: "scale"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'n("0 2 4 6 4 2").scale("C:major")',
      `n("[0,7] 4 [2,7] 4")
.scale("C:<major minor>/2")
.s("piano")`,
      `n(rand.range(0,12).segment(8))
.scale("C:ritusen")
.s("piano")`
    ],
    longname: "scale",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Adds a new custom voicing dictionary.
 *
 * @name addVoicings
 * @memberof Pattern
 * @param {string} name identifier for the voicing dictionary
 * @param {Object} dictionary maps chord symbol to possible voicings
 * @param {Array} range min, max note
 * @returns Pattern
 * @example
 * addVoicings('cookie', {
 *   7: ['3M 7m 9M 12P 15P', '7m 10M 13M 16M 19P'],
 *   '^7': ['3M 6M 9M 12P 14M', '7M 10M 13M 16M 19P'],
 *   m7: ['8P 11P 14m 17m 19P', '5P 8P 11P 14m 17m'],
 *   m7b5: ['3m 5d 8P 11P 14m', '5d 8P 11P 14m 17m'],
 *   o7: ['3m 6M 9M 11A 15P'],
 *   '7alt': ['3M 7m 10m 13m 15P'],
 *   '7#11': ['7m 10m 13m 15P 17m'],
 * }, ['C3', 'C6'])
 * "<C^7 A7 Dm7 G7>".voicings('cookie').note()
 */`,
    meta: {
      filename: "voicings.mjs",
      lineno: 89,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: "<p>Adds a new custom voicing dictionary.</p>",
    name: "addVoicings",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>identifier for the voicing dictionary</p>",
        name: "name"
      },
      {
        type: {
          names: [
            "Object"
          ]
        },
        description: "<p>maps chord symbol to possible voicings</p>",
        name: "dictionary"
      },
      {
        type: {
          names: [
            "Array"
          ]
        },
        description: "<p>min, max note</p>",
        name: "range"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `addVoicings('cookie', {
  7: ['3M 7m 9M 12P 15P', '7m 10M 13M 16M 19P'],
  '^7': ['3M 6M 9M 12P 14M', '7M 10M 13M 16M 19P'],
  m7: ['8P 11P 14m 17m 19P', '5P 8P 11P 14m 17m'],
  m7b5: ['3m 5d 8P 11P 14m', '5d 8P 11P 14m 17m'],
  o7: ['3m 6M 9M 11A 15P'],
  '7alt': ['3M 7m 10m 13m 15P'],
  '7#11': ['7m 10m 13m 15P 17m'],
}, ['C3', 'C6'])
"<C^7 A7 Dm7 G7>".voicings('cookie').note()`
    ],
    scope: "static",
    longname: "Pattern.addVoicings",
    kind: "member"
  },
  {
    comment: `/**
 * DEPRECATED: still works, but it is recommended you use .voicing instead (without s).
 * Turns chord symbols into voicings, using the smoothest voice leading possible.
 * Uses [chord-voicings package](https://github.com/felixroos/chord-voicings#chord-voicings).
 *
 * @name voicings
 * @memberof Pattern
 * @param {string} dictionary which voicing dictionary to use.
 * @returns Pattern
 * @example
 * stack("<C^7 A7 Dm7 G7>".voicings('lefthand'), "<C3 A2 D3 G2>").note()
 */`,
    meta: {
      filename: "voicings.mjs",
      lineno: 130,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: `<p>DEPRECATED: still works, but it is recommended you use .voicing instead (without s).
Turns chord symbols into voicings, using the smoothest voice leading possible.
Uses <a href="https://github.com/felixroos/chord-voicings#chord-voicings">chord-voicings package</a>.</p>`,
    name: "voicings",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>which voicing dictionary to use.</p>",
        name: "dictionary"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      `stack("<C^7 A7 Dm7 G7>".voicings('lefthand'), "<C3 A2 D3 G2>").note()`
    ],
    scope: "static",
    longname: "Pattern.voicings",
    kind: "member"
  },
  {
    comment: `/**
 * Maps the chords of the incoming pattern to root notes in the given octave.
 *
 * @name rootNotes
 * @memberof Pattern
 * @param {octave} octave octave to use
 * @returns Pattern
 * @example
 * "<C^7 A7 Dm7 G7>".rootNotes(2).note()
 */`,
    meta: {
      filename: "voicings.mjs",
      lineno: 156,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: "<p>Maps the chords of the incoming pattern to root notes in the given octave.</p>",
    name: "rootNotes",
    memberof: "Pattern",
    params: [
      {
        type: {
          names: [
            "octave"
          ]
        },
        description: "<p>octave to use</p>",
        name: "octave"
      }
    ],
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      '"<C^7 A7 Dm7 G7>".rootNotes(2).note()'
    ],
    scope: "static",
    longname: "Pattern.rootNotes",
    kind: "member"
  },
  {
    comment: '/**\n * Turns chord symbols into voicings. You can use the following control params:\n *\n * - `chord`: Note, followed by chord symbol, e.g. C Am G7 Bb^7\n * - `dict`: voicing dictionary to use, falls back to default dictionary\n * - `anchor`: the note that is used to align the chord\n * - `mode`: how the voicing is aligned to the anchor\n *   - `below`: top note <= anchor\n *   - `duck`: top note <= anchor, anchor excluded\n *   - `above`: bottom note >= anchor\n * - `offset`: whole number that shifts the voicing up or down to the next voicing\n * - `n`: if set, the voicing is played like a scale. Overshooting numbers will be octaved\n *\n * All of the above controls are optional, except `chord`.\n * If you pass a pattern of strings to voicing, they will be interpreted as chords.\n *\n * @name voicing\n * @returns Pattern\n * @example\n * n("0 1 2 3").chord("<C Am F G>").voicing()\n */',
    meta: {
      filename: "voicings.mjs",
      lineno: 175,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/tonal",
      code: {}
    },
    description: `<p>Turns chord symbols into voicings. You can use the following control params:</p>
<ul>
<li><code>chord</code>: Note, followed by chord symbol, e.g. C Am G7 Bb^7</li>
<li><code>dict</code>: voicing dictionary to use, falls back to default dictionary</li>
<li><code>anchor</code>: the note that is used to align the chord</li>
<li><code>mode</code>: how the voicing is aligned to the anchor
<ul>
<li><code>below</code>: top note &lt;= anchor</li>
<li><code>duck</code>: top note &lt;= anchor, anchor excluded</li>
<li><code>above</code>: bottom note &gt;= anchor</li>
</ul>
</li>
<li><code>offset</code>: whole number that shifts the voicing up or down to the next voicing</li>
<li><code>n</code>: if set, the voicing is played like a scale. Overshooting numbers will be octaved</li>
</ul>
<p>All of the above controls are optional, except <code>chord</code>.
If you pass a pattern of strings to voicing, they will be interpreted as chords.</p>`,
    name: "voicing",
    returns: [
      {
        description: "<p>Pattern</p>"
      }
    ],
    examples: [
      'n("0 1 2 3").chord("<C Am F G>").voicing()'
    ],
    longname: "voicing",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Renders an oscilloscope for the frequency domain of the audio signal.
 * @name fscope
 * @param {string} color line color as hex or color name. defaults to white.
 * @param {number} scale scales the y-axis. Defaults to 0.25
 * @param {number} pos y-position relative to screen height. 0 = top, 1 = bottom of screen
 * @param {number} lean y-axis alignment where 0 = top and 1 = bottom
 * @param {number} min min value
 * @param {number} max max value
 * @example
 * s("sawtooth").fscope()
 */`,
    meta: {
      filename: "scope.mjs",
      lineno: 98,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/webaudio",
      code: {}
    },
    description: "<p>Renders an oscilloscope for the frequency domain of the audio signal.</p>",
    name: "fscope",
    params: [
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>line color as hex or color name. defaults to white.</p>",
        name: "color"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>scales the y-axis. Defaults to 0.25</p>",
        name: "scale"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>y-position relative to screen height. 0 = top, 1 = bottom of screen</p>",
        name: "pos"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>y-axis alignment where 0 = top and 1 = bottom</p>",
        name: "lean"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>min value</p>",
        name: "min"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>max value</p>",
        name: "max"
      }
    ],
    examples: [
      's("sawtooth").fscope()'
    ],
    longname: "fscope",
    kind: "member",
    scope: "global"
  },
  {
    comment: `/**
 * Renders an oscilloscope for the time domain of the audio signal.
 * @name scope
 * @synonyms tscope
 * @param {object} config optional config with options:
 * @param {boolean} align if 1, the scope will be aligned to the first zero crossing. defaults to 1
 * @param {string} color line color as hex or color name. defaults to white.
 * @param {number} thickness line thickness. defaults to 3
 * @param {number} scale scales the y-axis. Defaults to 0.25
 * @param {number} pos y-position relative to screen height. 0 = top, 1 = bottom of screen
 * @param {number} trigger amplitude value that is used to align the scope. defaults to 0.
 * @example
 * s("sawtooth").scope()
 */`,
    meta: {
      filename: "scope.mjs",
      lineno: 121,
      columnno: 0,
      path: "/Users/felix/projects/strudel/packages/webaudio",
      code: {}
    },
    description: "<p>Renders an oscilloscope for the time domain of the audio signal.</p>",
    name: "scope",
    synonyms_text: "tscope",
    synonyms: [
      "tscope"
    ],
    params: [
      {
        type: {
          names: [
            "object"
          ]
        },
        description: "<p>optional config with options:</p>",
        name: "config"
      },
      {
        type: {
          names: [
            "boolean"
          ]
        },
        description: "<p>if 1, the scope will be aligned to the first zero crossing. defaults to 1</p>",
        name: "align"
      },
      {
        type: {
          names: [
            "string"
          ]
        },
        description: "<p>line color as hex or color name. defaults to white.</p>",
        name: "color"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>line thickness. defaults to 3</p>",
        name: "thickness"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>scales the y-axis. Defaults to 0.25</p>",
        name: "scale"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>y-position relative to screen height. 0 = top, 1 = bottom of screen</p>",
        name: "pos"
      },
      {
        type: {
          names: [
            "number"
          ]
        },
        description: "<p>amplitude value that is used to align the scope. defaults to 0.</p>",
        name: "trigger"
      }
    ],
    examples: [
      's("sawtooth").scope()'
    ],
    longname: "scope",
    kind: "member",
    scope: "global"
  },
  {
    kind: "package",
    longname: "package:undefined",
    files: [
      "/Users/felix/projects/strudel/packages/codemirror/autocomplete.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/codemirror.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/flash.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/highlight.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/html.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/index.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/keybindings.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/slider.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/algoboy.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/blackscreen.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/bluescreen.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/strudel-theme.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/teletext.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/terminal.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes/whitescreen.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/themes.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/tooltip.mjs",
      "/Users/felix/projects/strudel/packages/codemirror/vite.config.js",
      "/Users/felix/projects/strudel/packages/codemirror/widget.mjs",
      "/Users/felix/projects/strudel/packages/core/bench/pattern.bench.mjs",
      "/Users/felix/projects/strudel/packages/core/clockworker.js",
      "/Users/felix/projects/strudel/packages/core/controls.mjs",
      "/Users/felix/projects/strudel/packages/core/cyclist.mjs",
      "/Users/felix/projects/strudel/packages/core/drawLine.mjs",
      "/Users/felix/projects/strudel/packages/core/euclid.mjs",
      "/Users/felix/projects/strudel/packages/core/evaluate.mjs",
      "/Users/felix/projects/strudel/packages/core/fraction.mjs",
      "/Users/felix/projects/strudel/packages/core/hap.mjs",
      "/Users/felix/projects/strudel/packages/core/index.mjs",
      "/Users/felix/projects/strudel/packages/core/logger.mjs",
      "/Users/felix/projects/strudel/packages/core/neocyclist.mjs",
      "/Users/felix/projects/strudel/packages/core/pattern.mjs",
      "/Users/felix/projects/strudel/packages/core/repl.mjs",
      "/Users/felix/projects/strudel/packages/core/signal.mjs",
      "/Users/felix/projects/strudel/packages/core/speak.mjs",
      "/Users/felix/projects/strudel/packages/core/state.mjs",
      "/Users/felix/projects/strudel/packages/core/test/controls.test.mjs",
      "/Users/felix/projects/strudel/packages/core/test/drawLine.test.mjs",
      "/Users/felix/projects/strudel/packages/core/test/fraction.test.mjs",
      "/Users/felix/projects/strudel/packages/core/test/pattern.test.mjs",
      "/Users/felix/projects/strudel/packages/core/test/solmization.test.js",
      "/Users/felix/projects/strudel/packages/core/test/util.test.mjs",
      "/Users/felix/projects/strudel/packages/core/test/value.test.mjs",
      "/Users/felix/projects/strudel/packages/core/time.mjs",
      "/Users/felix/projects/strudel/packages/core/timespan.mjs",
      "/Users/felix/projects/strudel/packages/core/ui.mjs",
      "/Users/felix/projects/strudel/packages/core/util.mjs",
      "/Users/felix/projects/strudel/packages/core/value.mjs",
      "/Users/felix/projects/strudel/packages/core/vite.config.js",
      "/Users/felix/projects/strudel/packages/core/zyklus.mjs",
      "/Users/felix/projects/strudel/packages/csound/index.mjs",
      "/Users/felix/projects/strudel/packages/csound/vite.config.js",
      "/Users/felix/projects/strudel/packages/desktopbridge/index.mjs",
      "/Users/felix/projects/strudel/packages/desktopbridge/loggerbridge.mjs",
      "/Users/felix/projects/strudel/packages/desktopbridge/midibridge.mjs",
      "/Users/felix/projects/strudel/packages/desktopbridge/oscbridge.mjs",
      "/Users/felix/projects/strudel/packages/desktopbridge/utils.mjs",
      "/Users/felix/projects/strudel/packages/draw/animate.mjs",
      "/Users/felix/projects/strudel/packages/draw/color.mjs",
      "/Users/felix/projects/strudel/packages/draw/draw.mjs",
      "/Users/felix/projects/strudel/packages/draw/index.mjs",
      "/Users/felix/projects/strudel/packages/draw/pianoroll.mjs",
      "/Users/felix/projects/strudel/packages/draw/pitchwheel.mjs",
      "/Users/felix/projects/strudel/packages/draw/spiral.mjs",
      "/Users/felix/projects/strudel/packages/draw/vite.config.js",
      "/Users/felix/projects/strudel/packages/embed/embed.js",
      "/Users/felix/projects/strudel/packages/hs2js/src/hs2js.mjs",
      "/Users/felix/projects/strudel/packages/hs2js/src/index.mjs",
      "/Users/felix/projects/strudel/packages/hs2js/src/parser.mjs",
      "/Users/felix/projects/strudel/packages/hs2js/vite.config.js",
      "/Users/felix/projects/strudel/packages/hydra/hydra.mjs",
      "/Users/felix/projects/strudel/packages/hydra/vite.config.js",
      "/Users/felix/projects/strudel/packages/midi/index.mjs",
      "/Users/felix/projects/strudel/packages/midi/midi.mjs",
      "/Users/felix/projects/strudel/packages/midi/vite.config.js",
      "/Users/felix/projects/strudel/packages/mini/bench/mini.bench.mjs",
      "/Users/felix/projects/strudel/packages/mini/index.mjs",
      "/Users/felix/projects/strudel/packages/mini/krill-parser.js",
      "/Users/felix/projects/strudel/packages/mini/mini.mjs",
      "/Users/felix/projects/strudel/packages/mini/test/mini.test.mjs",
      "/Users/felix/projects/strudel/packages/mini/vite.config.js",
      "/Users/felix/projects/strudel/packages/osc/osc.mjs",
      "/Users/felix/projects/strudel/packages/osc/server.js",
      "/Users/felix/projects/strudel/packages/osc/tidal-sniffer.js",
      "/Users/felix/projects/strudel/packages/osc/vite.config.js",
      "/Users/felix/projects/strudel/packages/repl/index.mjs",
      "/Users/felix/projects/strudel/packages/repl/prebake.mjs",
      "/Users/felix/projects/strudel/packages/repl/repl-component.mjs",
      "/Users/felix/projects/strudel/packages/repl/vite.config.js",
      "/Users/felix/projects/strudel/packages/sampler/sample-server.mjs",
      "/Users/felix/projects/strudel/packages/serial/serial.mjs",
      "/Users/felix/projects/strudel/packages/serial/vite.config.js",
      "/Users/felix/projects/strudel/packages/soundfonts/convert.js",
      "/Users/felix/projects/strudel/packages/soundfonts/fontloader.mjs",
      "/Users/felix/projects/strudel/packages/soundfonts/gm.mjs",
      "/Users/felix/projects/strudel/packages/soundfonts/index.mjs",
      "/Users/felix/projects/strudel/packages/soundfonts/list.mjs",
      "/Users/felix/projects/strudel/packages/soundfonts/sfumato.mjs",
      "/Users/felix/projects/strudel/packages/soundfonts/vite.config.js",
      "/Users/felix/projects/strudel/packages/superdough/dspworklet.mjs",
      "/Users/felix/projects/strudel/packages/superdough/feedbackdelay.mjs",
      "/Users/felix/projects/strudel/packages/superdough/helpers.mjs",
      "/Users/felix/projects/strudel/packages/superdough/index.mjs",
      "/Users/felix/projects/strudel/packages/superdough/logger.mjs",
      "/Users/felix/projects/strudel/packages/superdough/noise.mjs",
      "/Users/felix/projects/strudel/packages/superdough/reverb.mjs",
      "/Users/felix/projects/strudel/packages/superdough/reverbGen.mjs",
      "/Users/felix/projects/strudel/packages/superdough/sampler.mjs",
      "/Users/felix/projects/strudel/packages/superdough/superdough.mjs",
      "/Users/felix/projects/strudel/packages/superdough/synth.mjs",
      "/Users/felix/projects/strudel/packages/superdough/util.mjs",
      "/Users/felix/projects/strudel/packages/superdough/vite.config.js",
      "/Users/felix/projects/strudel/packages/superdough/vowel.mjs",
      "/Users/felix/projects/strudel/packages/superdough/worklets.mjs",
      "/Users/felix/projects/strudel/packages/superdough/zzfx.mjs",
      "/Users/felix/projects/strudel/packages/superdough/zzfx_fork.mjs",
      "/Users/felix/projects/strudel/packages/tidal/tidal.mjs",
      "/Users/felix/projects/strudel/packages/tonal/index.mjs",
      "/Users/felix/projects/strudel/packages/tonal/ireal.mjs",
      "/Users/felix/projects/strudel/packages/tonal/test/tonal.test.mjs",
      "/Users/felix/projects/strudel/packages/tonal/test/tonleiter.test.mjs",
      "/Users/felix/projects/strudel/packages/tonal/tonal.mjs",
      "/Users/felix/projects/strudel/packages/tonal/tonleiter.mjs",
      "/Users/felix/projects/strudel/packages/tonal/vite.config.js",
      "/Users/felix/projects/strudel/packages/tonal/voicings.mjs",
      "/Users/felix/projects/strudel/packages/transpiler/index.mjs",
      "/Users/felix/projects/strudel/packages/transpiler/test/transpiler.test.mjs",
      "/Users/felix/projects/strudel/packages/transpiler/transpiler.mjs",
      "/Users/felix/projects/strudel/packages/transpiler/vite.config.js",
      "/Users/felix/projects/strudel/packages/web/vite.config.js",
      "/Users/felix/projects/strudel/packages/web/web.mjs",
      "/Users/felix/projects/strudel/packages/webaudio/index.mjs",
      "/Users/felix/projects/strudel/packages/webaudio/scope.mjs",
      "/Users/felix/projects/strudel/packages/webaudio/vite.config.js",
      "/Users/felix/projects/strudel/packages/webaudio/webaudio.mjs",
      "/Users/felix/projects/strudel/packages/xen/index.mjs",
      "/Users/felix/projects/strudel/packages/xen/test/xen.test.mjs",
      "/Users/felix/projects/strudel/packages/xen/tune.mjs",
      "/Users/felix/projects/strudel/packages/xen/tunejs.js",
      "/Users/felix/projects/strudel/packages/xen/vite.config.js",
      "/Users/felix/projects/strudel/packages/xen/xen.mjs"
    ]
  }
], M = {
  docs: kn
}, vn = typeof DOMParser < "u" ? new DOMParser() : null;
let wn = (e) => vn?.parseFromString(e, "text/html").querySelectorAll("*"), W = (e) => Array.isArray(e) ? e.flat().join("") : e === void 0 ? "" : e, jn = (e, ...n) => {
  let a = "";
  for (let s in e)
    a += W(e[s]), a += W(n[s]);
  return wn(a);
};
function Pn(e) {
  const n = document.createElement("div");
  return n.innerText = e, n.innerHTML;
}
const F = (e) => e.name || e.longname, Un = (e) => {
  var n = document.createElement("div");
  return n.innerHTML = e, n.textContent || n.innerText || "";
};
function Z({ doc: e, label: n }) {
  return jn`<div class="prose dark:prose-invert max-h-[400px] overflow-auto p-2">
<h1 class="pt-0 mt-0">${n || F(e)}</h1>
${e.description}
<ul>
  ${e.params?.map(
    ({ name: a, type: s, description: o }) => `<li>${a} : ${s.names?.join(" | ")} ${o ? ` - ${Un(o)}` : ""}</li>`
  )}
</ul>
<div>
  ${e.examples?.map((a) => `<div><pre>${Pn(a)}</pre></div>`)}
</div>
</div>`[0];
}
const An = M.docs.filter(
  (e) => F(e) && !F(e).startsWith("_") && !["package"].includes(e.kind) && !["superdirtOnly", "noAutocomplete"].some((n) => e.tags?.find((a) => a.originalTitle === n))
).map((e) => ({
  label: F(e),
  // detail: 'xxx', // An optional short piece of information to show (with a different style) after the label.
  info: () => Z({ doc: e }),
  type: "function"
  // https://codemirror.net/docs/ref/#autocomplete.Completion.type
})), Fn = (e) => {
  let n = e.matchBefore(/\w*/);
  return n.from == n.to && !e.explicit ? null : {
    from: n.from,
    options: An
    /*     options: [
      { label: 'match', type: 'keyword' },
      { label: 'hello', type: 'variable', info: '(World)' },
      { label: 'magic', type: 'text', apply: '⠁⭒*.✩.*⭒⠁', detail: 'macro' },
    ], */
  };
};
function Sn(e) {
  return e ? [
    ge({ override: [Fn] })
    //javascriptLanguage.data.of({ autocomplete: strudelAutocomplete }),
  ] : [];
}
const Cn = (e) => e.name || e.longname;
let _ = !1;
typeof window < "u" && (window.addEventListener(
  "keyup",
  function(e) {
    e.key == "Control" && (_ = !1);
  },
  !0
), window.addEventListener(
  "keydown",
  function(e) {
    e.key == "Control" && (_ = !0);
  },
  !0
));
const qn = Se(
  (e, n, a) => {
    if (!_)
      return null;
    let { from: s, to: o, text: r } = e.state.doc.lineAt(n), p = n, i = n;
    for (; p > s && /\w/.test(r[p - s - 1]); )
      p--;
    for (; i < o && /\w/.test(r[i - s]); )
      i++;
    if (p == n && a < 0 || i == n && a > 0)
      return null;
    let l = r.slice(p - s, i - s), u = M.docs.filter((f) => Cn(f) === l)[0];
    return !u && (u = M.docs.filter((f) => f.synonyms && f.synonyms.includes(l))[0], !u) ? null : {
      pos: p,
      end: i,
      above: !1,
      arrow: !0,
      create(f) {
        let h = document.createElement("div");
        h.className = "strudel-tooltip";
        const U = Z({ doc: u, label: l });
        return h.appendChild(U), { dom: h };
      }
    };
  },
  { hoverTime: 10 }
), Tn = (e) => e ? qn : [], L = w.define(), Bn = T.define({
  create() {
    return d.none;
  },
  update(e, n) {
    try {
      for (let a of n.effects)
        if (a.is(L))
          if (a.value && n.newDoc.length > 0) {
            const s = d.mark({ attributes: { style: "background-color: #FFCA2880" } });
            e = d.set([s.range(0, n.newDoc.length)]);
          } else
            e = d.set([]);
      return e;
    } catch (a) {
      return console.warn("flash error", a), e;
    }
  },
  provide: (e) => x.decorations.from(e)
}), Dn = (e, n = 200) => {
  e.dispatch({ effects: L.of(!0) }), setTimeout(() => {
    e.dispatch({ effects: L.of(!1) });
  }, n);
}, Rn = (e) => e ? Bn : [], ee = w.define(), ne = w.define(), N = (e, n) => {
  e.dispatch({ effects: ee.of(n) });
}, En = (e, n, a) => {
  e.dispatch({ effects: ne.of({ atTime: n, haps: a }) });
}, z = T.define({
  create() {
    return d.none;
  },
  update(e, n) {
    n.docChanged && (e = e.map(n.changes));
    for (let a of n.effects)
      if (a.is(ee)) {
        const s = a.value.filter(([o]) => o < n.newDoc.length).map(([o, r]) => [o, Math.min(r, n.newDoc.length)]).map(
          (o) => d.mark({
            id: o.join(":"),
            // this green is only to verify that the decoration moves when the document is edited
            // it will be removed later, so the mark is not visible by default
            attributes: { style: "background-color: #00CA2880" }
          }).range(...o)
          // -> Decoration
        );
        e = d.set(s, !0);
      }
    return e;
  }
}), H = T.define({
  create() {
    return { atTime: 0, haps: /* @__PURE__ */ new Map() };
  },
  update(e, n) {
    for (let a of n.effects)
      if (a.is(ne)) {
        const s = /* @__PURE__ */ new Map();
        for (let o of a.value.haps)
          if (!(!o.context?.locations || !o.whole))
            for (let { start: r, end: p } of o.context.locations) {
              let i = `${r}:${p}`;
              (!s.has(i) || s.get(i).whole.begin.lt(o.whole.begin)) && s.set(i, o);
            }
        e = { atTime: a.value.atTime, haps: s };
      }
    return e;
  }
}), Mn = x.decorations.compute([z, H], (e) => {
  const n = e.field(z).iter(), { haps: a } = e.field(H), s = new Ue();
  for (; n.value; ) {
    const {
      from: o,
      to: r,
      value: {
        spec: { id: p }
      }
    } = n;
    if (a.has(p)) {
      const l = a.get(p).value?.color ?? "var(--foreground)";
      s.add(
        o,
        r,
        d.mark({
          // attributes: { style: `outline: solid 2px rgba(${channels.join(', ')})` },
          attributes: { style: `outline: solid 2px ${l}` }
        })
      );
    }
    n.next();
  }
  return s.finish();
}), _n = [z, H, Mn], Ln = (e, n) => (e && n && setTimeout(() => {
  N(n.editor, n.miniLocations);
}, 100), e ? _n : []), Nn = Y.fromClass(
  class {
    constructor() {
    }
  },
  {
    provide: () => X.highest(q.of([...ze]))
  }
), zn = (e) => [Nn].concat(e ?? []), Hn = {
  vim: Ne,
  emacs: Le,
  vscode: zn
};
function Gn(e) {
  const n = Hn[e];
  return [q.of(ye), q.of(xe), n ? n() : []];
}
const In = b({
  theme: "dark",
  settings: {
    background: "#222",
    foreground: "#75baff",
    // whats that?
    caret: "#ffcc00",
    selection: "rgba(128, 203, 196, 0.5)",
    selectionMatch: "#036dd626",
    // lineHighlight: '#8a91991a', // original
    lineHighlight: "#00000050",
    gutterBackground: "transparent",
    // gutterForeground: '#8a919966',
    gutterForeground: "#8a919966"
  },
  styles: [
    { tag: t.labelName, color: "#89ddff" },
    { tag: t.keyword, color: "#c792ea" },
    { tag: t.operator, color: "#89ddff" },
    { tag: t.special(t.variableName), color: "#eeffff" },
    // { tag: t.typeName, color: '#f07178' }, // original
    { tag: t.typeName, color: "#c3e88d" },
    { tag: t.atom, color: "#f78c6c" },
    // { tag: t.number, color: '#ff5370' }, // original
    { tag: t.number, color: "#c3e88d" },
    { tag: t.definition(t.variableName), color: "#82aaff" },
    { tag: t.string, color: "#c3e88d" },
    //     { tag: t.special(t.string), color: '#f07178' }, // original
    { tag: t.special(t.string), color: "#c3e88d" },
    { tag: t.comment, color: "#7d8799" },
    // { tag: t.variableName, color: '#f07178' }, // original
    { tag: t.variableName, color: "#c792ea" },
    // { tag: t.tagName, color: '#ff5370' }, // original
    { tag: t.tagName, color: "#c3e88d" },
    { tag: t.bracket, color: "#525154" },
    // { tag: t.bracket, color: '#a2a1a4' }, // original
    { tag: t.meta, color: "#ffcb6b" },
    { tag: t.attributeName, color: "#c792ea" },
    { tag: t.propertyName, color: "#c792ea" },
    { tag: t.className, color: "#decb6b" },
    { tag: t.invalid, color: "#ffffff" },
    { tag: [t.unit, t.punctuation], color: "#82aaff" }
  ]
}), te = {
  background: "#051DB5",
  lineBackground: "#051DB550",
  foreground: "white",
  // whats that?
  caret: "white",
  selection: "rgba(128, 203, 196, 0.5)",
  selectionMatch: "#036dd626",
  // lineHighlight: '#8a91991a', // original
  lineHighlight: "#00000050",
  gutterBackground: "transparent",
  // gutterForeground: '#8a919966',
  gutterForeground: "#8a919966"
}, On = b({
  theme: "dark",
  settings: te,
  styles: [
    { tag: t.labelName, color: "white" },
    { tag: t.keyword, color: "white" },
    { tag: t.operator, color: "white" },
    { tag: t.special(t.variableName), color: "white" },
    { tag: t.typeName, color: "white" },
    { tag: t.atom, color: "white" },
    { tag: t.number, color: "white" },
    { tag: t.definition(t.variableName), color: "white" },
    { tag: t.string, color: "white" },
    { tag: t.special(t.string), color: "white" },
    { tag: t.comment, color: "white" },
    { tag: t.variableName, color: "white" },
    { tag: t.tagName, color: "white" },
    { tag: t.bracket, color: "white" },
    { tag: t.meta, color: "white" },
    { tag: t.attributeName, color: "white" },
    { tag: t.propertyName, color: "white" },
    { tag: t.className, color: "white" },
    { tag: t.invalid, color: "white" },
    { tag: [t.unit, t.punctuation], color: "white" }
  ]
}), ae = {
  background: "black",
  foreground: "white",
  // whats that?
  caret: "white",
  selection: "#ffffff20",
  selectionMatch: "#036dd626",
  lineHighlight: "#ffffff10",
  lineBackground: "#00000050",
  gutterBackground: "transparent",
  gutterForeground: "#8a919966"
}, Wn = b({
  theme: "dark",
  settings: ae,
  styles: [
    { tag: t.labelName, color: "white" },
    { tag: t.keyword, color: "white" },
    { tag: t.operator, color: "white" },
    { tag: t.special(t.variableName), color: "white" },
    { tag: t.typeName, color: "white" },
    { tag: t.atom, color: "white" },
    { tag: t.number, color: "white" },
    { tag: t.definition(t.variableName), color: "white" },
    { tag: t.string, color: "white" },
    { tag: t.special(t.string), color: "white" },
    { tag: t.comment, color: "white" },
    { tag: t.variableName, color: "white" },
    { tag: t.tagName, color: "white" },
    { tag: t.bracket, color: "white" },
    { tag: t.meta, color: "white" },
    { tag: t.attributeName, color: "white" },
    { tag: t.propertyName, color: "white" },
    { tag: t.className, color: "white" },
    { tag: t.invalid, color: "white" },
    { tag: [t.unit, t.punctuation], color: "white" }
  ]
}), se = {
  background: "white",
  foreground: "black",
  // whats that?
  caret: "black",
  selection: "rgba(128, 203, 196, 0.5)",
  selectionMatch: "#ffffff26",
  lineHighlight: "#cccccc50",
  lineBackground: "#ffffff50",
  gutterBackground: "transparent",
  gutterForeground: "black",
  light: !0
}, Vn = b({
  theme: "light",
  settings: se,
  styles: [
    { tag: t.labelName, color: "black" },
    { tag: t.keyword, color: "black" },
    { tag: t.operator, color: "black" },
    { tag: t.special(t.variableName), color: "black" },
    { tag: t.typeName, color: "black" },
    { tag: t.atom, color: "black" },
    { tag: t.number, color: "black" },
    { tag: t.definition(t.variableName), color: "black" },
    { tag: t.string, color: "black" },
    { tag: t.special(t.string), color: "black" },
    { tag: t.comment, color: "black" },
    { tag: t.variableName, color: "black" },
    { tag: t.tagName, color: "black" },
    { tag: t.bracket, color: "black" },
    { tag: t.meta, color: "black" },
    { tag: t.attributeName, color: "black" },
    { tag: t.propertyName, color: "black" },
    { tag: t.className, color: "black" },
    { tag: t.invalid, color: "black" }
  ]
});
let c = "#6edee4", oe = "white", re = "red", ie = "#f8fc55";
const pe = {
  background: "#000000",
  foreground: c,
  // whats that?
  caret: re,
  selection: ie,
  selectionMatch: c,
  lineHighlight: "#6edee440",
  // panel bg
  lineBackground: "#00000040",
  gutterBackground: "transparent",
  gutterForeground: "#8a919966",
  customStyle: ".cm-line { line-height: 1 }"
};
let D = ie, A = oe;
const $n = b({
  theme: "dark",
  settings: pe,
  styles: [
    { tag: t.labelName, color: oe },
    { tag: t.keyword, color: c },
    { tag: t.operator, color: A },
    { tag: t.special(t.variableName), color: c },
    { tag: t.typeName, color: c },
    { tag: t.atom, color: c },
    { tag: t.number, color: A },
    { tag: t.definition(t.variableName), color: c },
    { tag: t.string, color: A },
    { tag: t.special(t.string), color: A },
    { tag: t.comment, color: D },
    { tag: t.variableName, color: c },
    { tag: t.tagName, color: c },
    { tag: t.bracket, color: D },
    { tag: t.meta, color: c },
    { tag: t.attributeName, color: c },
    { tag: t.propertyName, color: c },
    // methods
    { tag: t.className, color: c },
    { tag: t.invalid, color: re },
    { tag: [t.unit, t.punctuation], color: D }
  ]
}), le = {
  background: "#9bbc0f",
  foreground: "#0f380f",
  // whats that?
  caret: "#0f380f",
  selection: "#306230",
  selectionMatch: "#ffffff26",
  lineHighlight: "#8bac0f",
  lineBackground: "#9bbc0f50",
  //lineBackground: 'transparent',
  gutterBackground: "transparent",
  gutterForeground: "#0f380f",
  light: !0,
  customStyle: ".cm-line { line-height: 1 }"
}, Qn = b({
  theme: "light",
  settings: le,
  styles: [
    { tag: t.labelName, color: "#0f380f" },
    { tag: t.keyword, color: "#0f380f" },
    { tag: t.operator, color: "#0f380f" },
    { tag: t.special(t.variableName), color: "#0f380f" },
    { tag: t.typeName, color: "#0f380f" },
    { tag: t.atom, color: "#0f380f" },
    { tag: t.number, color: "#0f380f" },
    { tag: t.definition(t.variableName), color: "#0f380f" },
    { tag: t.string, color: "#0f380f" },
    { tag: t.special(t.string), color: "#0f380f" },
    { tag: t.comment, color: "#0f380f" },
    { tag: t.variableName, color: "#0f380f" },
    { tag: t.tagName, color: "#0f380f" },
    { tag: t.bracket, color: "#0f380f" },
    { tag: t.meta, color: "#0f380f" },
    { tag: t.attributeName, color: "#0f380f" },
    { tag: t.propertyName, color: "#0f380f" },
    { tag: t.className, color: "#0f380f" },
    { tag: t.invalid, color: "#0f380f" },
    { tag: [t.unit, t.punctuation], color: "#0f380f" }
  ]
}), me = {
  background: "black",
  foreground: "#41FF00",
  // whats that?
  caret: "#41FF00",
  selection: "#ffffff20",
  selectionMatch: "#036dd626",
  lineHighlight: "#ffffff10",
  gutterBackground: "transparent",
  gutterForeground: "#8a919966"
}, Xn = b({
  theme: "dark",
  settings: me,
  styles: [
    { tag: t.labelName, color: "#41FF00" },
    { tag: t.keyword, color: "#41FF00" },
    { tag: t.operator, color: "#41FF00" },
    { tag: t.special(t.variableName), color: "#41FF00" },
    { tag: t.typeName, color: "#41FF00" },
    { tag: t.atom, color: "#41FF00" },
    { tag: t.number, color: "#41FF00" },
    { tag: t.definition(t.variableName), color: "#41FF00" },
    { tag: t.string, color: "#41FF00" },
    { tag: t.special(t.string), color: "#41FF00" },
    { tag: t.comment, color: "#41FF00" },
    { tag: t.variableName, color: "#41FF00" },
    { tag: t.tagName, color: "#41FF00" },
    { tag: t.bracket, color: "#41FF00" },
    { tag: t.meta, color: "#41FF00" },
    { tag: t.attributeName, color: "#41FF00" },
    { tag: t.propertyName, color: "#41FF00" },
    { tag: t.className, color: "#41FF00" },
    { tag: t.invalid, color: "#41FF00" }
  ]
}), V = {
  strudelTheme: In,
  bluescreen: On,
  blackscreen: Wn,
  whitescreen: Vn,
  teletext: $n,
  algoboy: Qn,
  terminal: Xn,
  abcdef: He,
  androidstudio: Ge,
  atomone: Ie,
  aura: Oe,
  bespin: We,
  darcula: Ve,
  dracula: $e,
  duotoneDark: Qe,
  eclipse: Xe,
  githubDark: Ye,
  gruvboxDark: Je,
  materialDark: Ke,
  nord: Ze,
  okaidia: en,
  solarizedDark: nn,
  sublime: tn,
  tokyoNight: an,
  tokyoNightStorm: sn,
  vscodeDark: on,
  xcodeDark: rn,
  bbedit: pn,
  duotoneLight: ln,
  githubLight: mn,
  gruvboxLight: cn,
  materialLight: dn,
  noctisLilac: un,
  solarizedLight: hn,
  tokyoNightDay: fn,
  xcodeLight: gn
}, R = {
  strudelTheme: {
    background: "#222",
    lineBackground: "#22222299",
    foreground: "#fff",
    // foreground: '#75baff',
    caret: "#ffcc00",
    selection: "rgba(128, 203, 196, 0.5)",
    selectionMatch: "#036dd626",
    // lineHighlight: '#8a91991a', // original
    lineHighlight: "#00000050",
    gutterBackground: "transparent",
    // gutterForeground: '#8a919966',
    gutterForeground: "#8a919966"
  },
  bluescreen: te,
  blackscreen: ae,
  whitescreen: se,
  teletext: pe,
  algoboy: le,
  terminal: me,
  abcdef: {
    background: "#0f0f0f",
    lineBackground: "#0f0f0f99",
    foreground: "#defdef",
    caret: "#00FF00",
    selection: "#515151",
    selectionMatch: "#515151",
    gutterBackground: "#555",
    gutterForeground: "#FFFFFF",
    lineHighlight: "#314151"
  },
  androidstudio: {
    background: "#282b2e",
    lineBackground: "#282b2e99",
    foreground: "#a9b7c6",
    caret: "#00FF00",
    selection: "#343739",
    selectionMatch: "#343739",
    lineHighlight: "#343739"
  },
  atomone: {
    background: "#272C35",
    lineBackground: "#272C3599",
    foreground: "#9d9b97",
    caret: "#797977",
    selection: "#ffffff30",
    selectionMatch: "#2B323D",
    gutterBackground: "#272C35",
    gutterForeground: "#465063",
    gutterBorder: "transparent",
    lineHighlight: "#2B323D"
  },
  aura: {
    background: "#21202e",
    lineBackground: "#21202e99",
    foreground: "#edecee",
    caret: "#a277ff",
    selection: "#3d375e7f",
    selectionMatch: "#3d375e7f",
    gutterBackground: "#21202e",
    gutterForeground: "#edecee",
    gutterBorder: "transparent",
    lineHighlight: "#a394f033"
  },
  bbedit: {
    light: !0,
    background: "#FFFFFF",
    lineBackground: "#FFFFFF99",
    foreground: "#000000",
    caret: "#FBAC52",
    selection: "#FFD420",
    selectionMatch: "#FFD420",
    gutterBackground: "#f5f5f5",
    gutterForeground: "#4D4D4C",
    gutterBorder: "transparent",
    lineHighlight: "#00000012"
  },
  bespin: {
    background: "#28211c",
    lineBackground: "#28211c99",
    foreground: "#9d9b97",
    caret: "#797977",
    selection: "#36312e",
    selectionMatch: "#4f382b",
    gutterBackground: "#28211c",
    gutterForeground: "#666666",
    lineHighlight: "rgba(255, 255, 255, 0.1)"
  },
  darcula: {
    background: "#2B2B2B",
    lineBackground: "#2B2B2B99",
    foreground: "#f8f8f2",
    caret: "#FFFFFF",
    selection: "rgba(255, 255, 255, 0.1)",
    selectionMatch: "rgba(255, 255, 255, 0.2)",
    gutterBackground: "rgba(255, 255, 255, 0.1)",
    gutterForeground: "#999",
    gutterBorder: "transparent",
    lineHighlight: "rgba(255, 255, 255, 0.1)"
  },
  dracula: {
    background: "#282a36",
    lineBackground: "#282a3699",
    foreground: "#f8f8f2",
    caret: "#f8f8f0",
    selection: "rgba(255, 255, 255, 0.1)",
    selectionMatch: "rgba(255, 255, 255, 0.2)",
    gutterBackground: "#282a36",
    gutterForeground: "#6D8A88",
    gutterBorder: "transparent",
    lineHighlight: "rgba(255, 255, 255, 0.1)"
  },
  duotoneLight: {
    light: !0,
    background: "#faf8f5",
    lineBackground: "#faf8f599",
    foreground: "#b29762",
    caret: "#93abdc",
    selection: "#e3dcce",
    selectionMatch: "#e3dcce",
    gutterBackground: "#faf8f5",
    gutterForeground: "#cdc4b1",
    gutterBorder: "transparent",
    lineHighlight: "#EFEFEF"
  },
  duotoneDark: {
    background: "#2a2734",
    lineBackground: "#2a273499",
    foreground: "#6c6783",
    caret: "#ffad5c",
    selection: "rgba(255, 255, 255, 0.1)",
    gutterBackground: "#2a2734",
    gutterForeground: "#545167",
    lineHighlight: "#36334280"
  },
  eclipse: {
    light: !0,
    background: "#fff",
    lineBackground: "#ffffff99",
    foreground: "#000",
    caret: "#FFFFFF",
    selection: "#d7d4f0",
    selectionMatch: "#d7d4f0",
    gutterBackground: "#f7f7f7",
    gutterForeground: "#999",
    lineHighlight: "#e8f2ff",
    gutterBorder: "transparent"
  },
  githubLight: {
    light: !0,
    background: "#fff",
    lineBackground: "#ffffff99",
    foreground: "#24292e",
    selection: "#BBDFFF",
    selectionMatch: "#BBDFFF",
    gutterBackground: "#fff",
    gutterForeground: "#6e7781"
  },
  githubDark: {
    background: "#0d1117",
    lineBackground: "#0d111799",
    foreground: "#c9d1d9",
    caret: "#c9d1d9",
    selection: "#003d73",
    selectionMatch: "#003d73",
    lineHighlight: "#36334280"
  },
  gruvboxDark: {
    background: "#282828",
    lineBackground: "#28282899",
    foreground: "#ebdbb2",
    caret: "#ebdbb2",
    selection: "#bdae93",
    selectionMatch: "#bdae93",
    lineHighlight: "#3c3836",
    gutterBackground: "#282828",
    gutterForeground: "#7c6f64"
  },
  gruvboxLight: {
    light: !0,
    background: "#fbf1c7",
    lineBackground: "#fbf1c799",
    foreground: "#3c3836",
    caret: "#af3a03",
    selection: "#ebdbb2",
    selectionMatch: "#bdae93",
    lineHighlight: "#ebdbb2",
    gutterBackground: "#ebdbb2",
    gutterForeground: "#665c54",
    gutterBorder: "transparent"
  },
  materialDark: {
    background: "#2e3235",
    lineBackground: "#2e323599",
    foreground: "#bdbdbd",
    caret: "#a0a4ae",
    selection: "#d7d4f0",
    selectionMatch: "#d7d4f0",
    gutterBackground: "#2e3235",
    gutterForeground: "#999",
    gutterActiveForeground: "#4f5b66",
    lineHighlight: "#545b61"
  },
  materialLight: {
    light: !0,
    background: "#FAFAFA",
    lineBackground: "#FAFAFA99",
    foreground: "#90A4AE",
    caret: "#272727",
    selection: "#80CBC440",
    selectionMatch: "#FAFAFA",
    gutterBackground: "#FAFAFA",
    gutterForeground: "#90A4AE",
    gutterBorder: "transparent",
    lineHighlight: "#CCD7DA50"
  },
  noctisLilac: {
    light: !0,
    background: "#f2f1f8",
    lineBackground: "#f2f1f899",
    foreground: "#0c006b",
    caret: "#5c49e9",
    selection: "#d5d1f2",
    selectionMatch: "#d5d1f2",
    gutterBackground: "#f2f1f8",
    gutterForeground: "#0c006b70",
    lineHighlight: "#e1def3"
  },
  nord: {
    background: "#2e3440",
    lineBackground: "#2e344099",
    foreground: "#FFFFFF",
    caret: "#FFFFFF",
    selection: "#3b4252",
    selectionMatch: "#e5e9f0",
    gutterBackground: "#2e3440",
    gutterForeground: "#4c566a",
    gutterActiveForeground: "#d8dee9",
    lineHighlight: "#4c566a"
  },
  okaidia: {
    background: "#272822",
    lineBackground: "#27282299",
    foreground: "#FFFFFF",
    caret: "#FFFFFF",
    selection: "#49483E",
    selectionMatch: "#49483E",
    gutterBackground: "#272822",
    gutterForeground: "#FFFFFF70",
    lineHighlight: "#00000059"
  },
  solarizedLight: {
    light: !0,
    background: "#fdf6e3",
    lineBackground: "#fdf6e399",
    foreground: "#657b83",
    caret: "#586e75",
    selection: "#dfd9c8",
    selectionMatch: "#dfd9c8",
    gutterBackground: "#00000010",
    gutterForeground: "#657b83",
    lineHighlight: "#dfd9c8"
  },
  solarizedDark: {
    background: "#002b36",
    lineBackground: "#002b3699",
    foreground: "#93a1a1",
    caret: "#839496",
    selection: "#173541",
    selectionMatch: "#aafe661a",
    gutterBackground: "#00252f",
    gutterForeground: "#839496",
    lineHighlight: "#173541"
  },
  sublime: {
    background: "#303841",
    lineBackground: "#30384199",
    foreground: "#FFFFFF",
    caret: "#FBAC52",
    selection: "#4C5964",
    selectionMatch: "#3A546E",
    gutterBackground: "#303841",
    gutterForeground: "#FFFFFF70",
    lineHighlight: "#00000059"
  },
  tokyoNightDay: {
    light: !0,
    background: "#e1e2e7",
    lineBackground: "#e1e2e799",
    foreground: "#3760bf",
    caret: "#3760bf",
    selection: "#99a7df",
    selectionMatch: "#99a7df",
    gutterBackground: "#e1e2e7",
    gutterForeground: "#3760bf",
    gutterBorder: "transparent",
    lineHighlight: "#5f5faf11"
  },
  tokyoNightStorm: {
    background: "#24283b",
    lineBackground: "#24283b99",
    foreground: "#7982a9",
    caret: "#c0caf5",
    selection: "#6f7bb630",
    selectionMatch: "#1f2335",
    gutterBackground: "#24283b",
    gutterForeground: "#7982a9",
    gutterBorder: "transparent",
    lineHighlight: "#292e42"
  },
  tokyoNight: {
    background: "#1a1b26",
    lineBackground: "#1a1b2699",
    foreground: "#787c99",
    caret: "#c0caf5",
    selection: "#515c7e40",
    selectionMatch: "#16161e",
    gutterBackground: "#1a1b26",
    gutterForeground: "#787c99",
    gutterBorder: "transparent",
    lineHighlight: "#1e202e"
  },
  vscodeDark: {
    background: "#1e1e1e",
    lineBackground: "#1e1e1e99",
    foreground: "#9cdcfe",
    caret: "#c6c6c6",
    selection: "#6199ff2f",
    selectionMatch: "#72a1ff59",
    lineHighlight: "#ffffff0f",
    gutterBackground: "#1e1e1e",
    gutterForeground: "#838383",
    gutterActiveForeground: "#fff"
  },
  xcodeLight: {
    light: !0,
    background: "#fff",
    lineBackground: "#ffffff99",
    foreground: "#3D3D3D",
    selection: "#BBDFFF",
    selectionMatch: "#BBDFFF",
    gutterBackground: "#fff",
    gutterForeground: "#AFAFAF",
    lineHighlight: "#EDF4FF"
  },
  xcodeDark: {
    background: "#292A30",
    lineBackground: "#292A3099",
    foreground: "#CECFD0",
    caret: "#fff",
    selection: "#727377",
    selectionMatch: "#727377",
    lineHighlight: "#2F3239"
  }
};
function Yn(e) {
  const n = /#([0-9A-Fa-f]{6}|[0-9A-Fa-f]{3})/g, a = [];
  let s;
  for (; (s = n.exec(e)) !== null; ) {
    const o = s[0];
    a.includes(o) || a.push(o);
  }
  return a;
}
function Bt(e) {
  return Yn(Kn(e));
}
function Jn() {
  const e = /* @__PURE__ */ new WeakSet();
  return (n, a) => {
    if (typeof a == "object" && a !== null) {
      if (e.has(a))
        return;
      e.add(a);
    }
    return a;
  };
}
function Kn(e) {
  return JSON.stringify(e, Jn());
}
const Zn = (e) => V[e] || V.strudelTheme;
function et(e) {
  const n = document.createElement("style");
  document.head.appendChild(n);
  const a = n.sheet, s = a.insertRule(e, 0);
  return () => a.deleteRule(s);
}
let $, E, S, Q = "strudel-theme-vars";
function nt(e) {
  document.getElementById(Q) || (S = document.createElement("style"), S.id = Q, document.head.append(S)), ce(e);
}
function ce(e) {
  if ($ === e)
    return;
  $ = e, R[e] || console.warn("theme", e, "has no settings.. defaulting to strudelTheme settings");
  const n = R[e] || R.strudelTheme;
  S.innerHTML = `:root {
      ${Object.entries(n).map(([a, s]) => `--${a}: ${s} !important;`).join(`
`)}
    }`, Me(n), n.light ? document.documentElement.classList.remove("dark") : document.documentElement.classList.add("dark"), E?.(), E = void 0, n.customStyle && (E = et(n.customStyle));
}
let v = {};
const tt = (e) => `slider_${e}`;
class at extends J {
  constructor(n, a, s, o, r, p, i) {
    super(), this.value = n, this.min = a, this.max = s, this.from = o, this.originalFrom = o, this.to = r, this.step = p, this.view = i;
  }
  eq() {
    return !1;
  }
  toDOM() {
    let n = document.createElement("span");
    n.setAttribute("aria-hidden", "true"), n.className = "cm-slider";
    let a = n.appendChild(document.createElement("input"));
    return a.type = "range", a.min = this.min, a.max = this.max, a.step = this.step ?? (this.max - this.min) / 1e3, a.originalValue = this.value, a.value = a.originalValue, a.from = this.from, a.originalFrom = this.originalFrom, a.to = this.to, a.style = "width:64px;margin-right:4px;transform:translateY(4px)", this.slider = a, a.addEventListener("input", (s) => {
      const o = s.target.value;
      let r = o;
      const p = a.from + a.originalValue.length;
      let i = { from: a.from, to: p, insert: r };
      a.originalValue = r, a.value = r, this.view.dispatch({ changes: i });
      const l = tt(a.originalFrom);
      window.postMessage({ type: "cm-slider", value: Number(o), id: l });
    }), n;
  }
  ignoreEvent(n) {
    return !0;
  }
}
const de = w.define(), st = (e, n) => {
  e.dispatch({ effects: de.of(n) });
};
function ot(e, n) {
  return e.filter((a) => a.type === "slider").map(({ from: a, to: s, value: o, min: r, max: p, step: i }) => d.widget({
    widget: new at(o, r, p, a, s, i, n),
    side: 0
  }).range(
    a
    /* , to */
  ));
}
const rt = Y.fromClass(
  class {
    decorations;
    //: DecorationSet
    constructor(e) {
      this.decorations = d.set([]);
    }
    update(e) {
      e.transactions.forEach((n) => {
        if (n.docChanged) {
          this.decorations = this.decorations.map(n.changes);
          const a = this.decorations.iter();
          for (; a.value; )
            a.value?.widget?.slider && (a.value.widget.slider.from = a.from, a.value.widget.slider.to = a.to), a.next();
        }
        for (let a of n.effects)
          a.is(de) && (this.decorations = d.set(ot(a.value, e.view)));
      });
    }
  },
  {
    decorations: (e) => e.decorations
  }
);
let Dt = (e) => (console.warn("slider will only work when the transpiler is used... passing value as is"), De(e)), Rt = (e, n, a, s) => (v[e] = n, Re(() => v[e]));
typeof window < "u" && window.addEventListener("message", (e) => {
  e.data.type === "cm-slider" && (v[e.data.id] !== void 0 ? v[e.data.id] = e.data.value : console.warn(`slider with id "${e.data.id}" is not registered. Only ${Object.keys(v)}`));
});
const ue = w.define({
  map: ({ from: e, to: n }, a) => ({ from: a.mapPos(e), to: a.mapPos(n) })
}), it = (e, n) => {
  e.dispatch({ effects: ue.of(n) });
};
function pt(e) {
  return e.sort((n, a) => n.to - a.to).map((n) => d.widget({
    widget: new ct(n),
    side: 0,
    block: !0
  }).range(n.to));
}
const lt = T.define(
  /* <DecorationSet> */
  {
    create() {
      return d.none;
    },
    update(e, n) {
      e = e.map(n.changes);
      for (let a of n.effects)
        if (a.is(ue))
          try {
            e = e.update({
              filter: () => !1,
              add: pt(a.value)
            });
          } catch (s) {
            console.log("err", s);
          }
      return e;
    },
    provide: (e) => x.decorations.from(e)
  }
), he = {};
function mt(e, n) {
  he[e] = n, n.id = e;
}
class ct extends J {
  constructor(n) {
    super(), this.widgetConfig = n;
  }
  eq() {
    return !0;
  }
  toDOM() {
    const n = bn(this.widgetConfig);
    return he[n];
  }
  ignoreEvent(n) {
    return !0;
  }
}
const dt = [lt];
function j(e, n) {
  yn(e), n && (K.prototype[e] = function(a, s = { fold: 1 }) {
    return n(a, s, this);
  });
}
function P(e, n = {}) {
  const { width: a = 500, height: s = 60, pixelRatio: o = window.devicePixelRatio } = n;
  let r = document.getElementById(e) || document.createElement("canvas");
  return r.width = a * o, r.height = s * o, r.style.width = a + "px", r.style.height = s + "px", mt(e, r), r;
}
j("_pianoroll", (e, n = {}, a) => {
  const s = P(e, n).getContext("2d");
  return a.tag(e).pianoroll({ fold: 1, ...n, ctx: s, id: e });
});
j("_punchcard", (e, n = {}, a) => {
  const s = P(e, n).getContext("2d");
  return a.tag(e).punchcard({ fold: 1, ...n, ctx: s, id: e });
});
j("_spiral", (e, n = {}, a) => {
  let s = n.size || 275;
  n = { width: s, height: s, ...n, size: s / 5 };
  const o = P(e, n).getContext("2d");
  return a.tag(e).spiral({ ...n, ctx: o, id: e });
});
j("_scope", (e, n = {}, a) => {
  n = { width: 500, height: 60, pos: 0.5, scale: 1, ...n };
  const s = P(e, n).getContext("2d");
  return a.tag(e).scope({ ...n, ctx: s, id: e });
});
j("_pitchwheel", (e, n = {}, a) => {
  let s = n.size || 200;
  n = { width: s, height: s, ...n, size: s / 5 };
  const o = P(e, n).getContext("2d");
  return a.pitchwheel({ ...n, ctx: o, id: e });
});
const y = {
  isLineWrappingEnabled: (e) => e ? x.lineWrapping : [],
  isBracketMatchingEnabled: (e) => e ? we({ brackets: "()[]{}<>" }) : [],
  isBracketClosingEnabled: (e) => e ? be() : [],
  isLineNumbersDisplayed: (e) => e ? Ce() : [],
  theme: Zn,
  isAutoCompletionEnabled: Sn,
  isTooltipEnabled: Tn,
  isPatternHighlightingEnabled: Ln,
  isActiveLineHighlighted: (e) => e ? [qe(), Te()] : [],
  isFlashEnabled: Rn,
  keybindings: Gn
}, G = Object.fromEntries(Object.keys(y).map((e) => [e, new Ae()])), ut = {
  keybindings: "codemirror",
  isBracketMatchingEnabled: !1,
  isBracketClosingEnabled: !0,
  isLineNumbersDisplayed: !0,
  isActiveLineHighlighted: !1,
  isAutoCompletionEnabled: !1,
  isPatternHighlightingEnabled: !0,
  isFlashEnabled: !0,
  isTooltipEnabled: !1,
  isLineWrappingEnabled: !1,
  theme: "strudelTheme",
  fontFamily: "monospace",
  fontSize: 18
}, C = xn("codemirror-settings", ut, {
  encode: JSON.stringify,
  decode: JSON.parse
});
function ht({ initialCode: e = "", onChange: n, onEvaluate: a, onStop: s, root: o }) {
  const r = C.get(), p = Object.keys(G).map(
    (l) => G[l].of(y[l](fe(r[l])))
  );
  nt(r.theme);
  let i = Fe.create({
    doc: e,
    extensions: [
      /* search(),
      highlightSelectionMatches(), */
      ...p,
      ve(),
      rt,
      dt,
      // indentOnInput(), // works without. already brought with javascript extension?
      // bracketMatching(), // does not do anything
      je(Pe),
      ke(),
      x.updateListener.of((l) => n(l)),
      Be({ cursorBlinkRate: 0 }),
      X.highest(
        q.of([
          {
            key: "Ctrl-Enter",
            run: () => a?.()
          },
          {
            key: "Alt-Enter",
            run: () => a?.()
          },
          {
            key: "Ctrl-.",
            run: () => s?.()
          },
          {
            key: "Alt-.",
            run: (l, u) => {
              u.preventDefault(), s?.();
            }
          }
          /* {
            key: 'Ctrl-Shift-.',
            run: () => (onPanic ? onPanic() : onStop?.()),
          },
          {
            key: 'Ctrl-Shift-Enter',
            run: () => (onReEvaluate ? onReEvaluate() : onEvaluate?.()),
          }, */
        ])
      )
    ]
  });
  return new x({
    state: i,
    parent: o
  });
}
class Et {
  constructor(n) {
    const {
      root: a,
      id: s,
      initialCode: o = "",
      onDraw: r,
      drawContext: p,
      drawTime: i = [0, 0],
      autodraw: l,
      prebake: u,
      bgFill: f = !0,
      ...h
    } = n;
    this.code = o, this.root = a, this.miniLocations = [], this.widgets = [], this.painters = [], this.drawTime = i, this.drawContext = p, this.onDraw = r || this.draw, this.id = s || ft(), this.drawer = new _e((m, g) => {
      const B = m.filter((k) => k.isActive(g));
      this.highlight(B, g), this.onDraw(m, g, this.painters);
    }, i), this.prebaked = u(), l && this.drawFirstFrame(), this.repl = Ee({
      ...h,
      onToggle: (m) => {
        h?.onToggle?.(m), m ? (this.adjustDrawTime(), this.drawer.start(this.repl.scheduler), document.dispatchEvent(
          new CustomEvent("start-repl", {
            detail: this.id
          })
        )) : (this.drawer.stop(), N(this.editor, []), O(!1));
      },
      beforeEval: async () => {
        O(), this.painters = [];
        const m = this;
        K.prototype.onPaint = function(g) {
          return m.painters.push(g), this;
        }, await this.prebaked, await h?.beforeEval?.();
      },
      afterEval: (m) => {
        this.miniLocations = m.meta?.miniLocations, this.widgets = m.meta?.widgets;
        const g = this.widgets.filter((k) => k.type === "slider");
        st(this.editor, g);
        const B = this.widgets.filter((k) => k.type !== "slider");
        it(this.editor, B), N(this.editor, this.miniLocations), h?.afterEval?.(m), this.adjustDrawTime(), this.drawer.invalidate();
      }
    }), this.editor = ht({
      root: a,
      initialCode: o,
      onChange: (m) => {
        m.docChanged && (this.code = m.state.doc.toString(), this.repl.setCode?.(this.code));
      },
      onEvaluate: () => this.evaluate(),
      onStop: () => this.stop()
    });
    const U = this.root.querySelector(".cm-editor");
    U && (this.root.style.display = "block", f && (this.root.style.backgroundColor = "var(--background)"), U.style.backgroundColor = "transparent");
    const I = C.get();
    this.setFontSize(I.fontSize), this.setFontFamily(I.fontFamily), this.onStartRepl = (m) => {
      m.detail !== this.id && this.stop();
    }, document.addEventListener("start-repl", this.onStartRepl);
  }
  // adjusts draw time depending on if there are painters
  adjustDrawTime() {
    this.drawer.setDrawTime(this.painters.length ? this.drawTime : [0, 0]);
  }
  draw(n, a) {
    this.painters?.forEach((s) => s(this.drawContext, a, n, this.drawTime));
  }
  async drawFirstFrame() {
    if (this.onDraw) {
      await this.prebaked;
      try {
        await this.repl.evaluate(this.code, !1), this.drawer.invalidate(this.repl.scheduler, -1e-3), this.onDraw?.(this.drawer.visibleHaps, -1e-3, this.painters);
      } catch {
        console.warn("first frame could not be painted");
      }
    }
  }
  async evaluate() {
    this.flash(), await this.repl.evaluate(this.code);
  }
  async stop() {
    this.repl.scheduler.stop();
  }
  async toggle() {
    this.repl.scheduler.started ? this.repl.stop() : this.evaluate();
  }
  flash(n) {
    Dn(this.editor, n);
  }
  highlight(n, a) {
    En(this.editor, a, n);
  }
  setFontSize(n) {
    this.root.style.fontSize = n + "px";
  }
  setFontFamily(n) {
    this.root.style.fontFamily = n;
    const a = this.root.querySelector(".cm-scroller");
    a && (a.style.fontFamily = n);
  }
  reconfigureExtension(n, a) {
    if (!y[n]) {
      console.warn(`extension ${n} is not known`);
      return;
    }
    a = fe(a);
    const s = y[n](a, this);
    this.editor.dispatch({
      effects: G[n].reconfigure(s)
    }), n === "theme" && ce(a);
  }
  setLineWrappingEnabled(n) {
    this.reconfigureExtension("isLineWrappingEnabled", n);
  }
  setBracketMatchingEnabled(n) {
    this.reconfigureExtension("isBracketMatchingEnabled", n);
  }
  setLineNumbersDisplayed(n) {
    this.reconfigureExtension("isLineNumbersDisplayed", n);
  }
  setBracketClosingEnabled(n) {
    this.reconfigureExtension("isBracketClosingEnabled", n);
  }
  setTheme(n) {
    this.reconfigureExtension("theme", n);
  }
  setAutocompletionEnabled(n) {
    this.reconfigureExtension("isAutoCompletionEnabled", n);
  }
  updateSettings(n) {
    this.setFontSize(n.fontSize), this.setFontFamily(n.fontFamily);
    for (let s in y)
      this.reconfigureExtension(s, n[s]);
    const a = { ...C.get(), ...n };
    C.set(a);
  }
  changeSetting(n, a) {
    if (y[n]) {
      this.reconfigureExtension(n, a);
      return;
    } else
      n === "fontFamily" ? this.setFontFamily(a) : n === "fontSize" && this.setFontSize(a);
  }
  setCode(n) {
    const a = { from: 0, to: this.editor.state.doc.length, insert: n };
    this.editor.dispatch({ changes: a });
  }
  clear() {
    this.onStartRepl && document.removeEventListener("start-repl", this.onStartRepl);
  }
  getCursorLocation() {
    return this.editor.state.selection.main.head;
  }
  setCursorLocation(n) {
    return this.editor.dispatch({ selection: { anchor: n } });
  }
  appendCode(n) {
    const a = this.getCursorLocation();
    this.setCode(this.code + n), this.setCursorLocation(a);
  }
}
function fe(e) {
  return { true: !0, false: !1 }[e] ?? e;
}
function ft() {
  return Math.floor((1 + Math.random()) * 65536).toString(16).substring(1);
}
export {
  ct as BlockWidget,
  at as SliderWidget,
  Et as StrudelMirror,
  ce as activateTheme,
  ue as addWidget,
  C as codemirrorSettings,
  ut as defaultSettings,
  Dn as flash,
  Bn as flashField,
  _n as highlightExtension,
  En as highlightMiniLocations,
  ht as initEditor,
  nt as initTheme,
  et as injectStyle,
  Rn as isFlashEnabled,
  Ln as isPatternHighlightingEnabled,
  j as registerWidget,
  L as setFlash,
  ee as setMiniLocations,
  de as setSliderWidgets,
  mt as setWidget,
  R as settings,
  ne as showMiniLocations,
  Dt as slider,
  rt as sliderPlugin,
  v as sliderValues,
  Rt as sliderWithID,
  Zn as theme,
  Bt as themeColors,
  V as themes,
  N as updateMiniLocations,
  st as updateSliderWidgets,
  it as updateWidgets,
  dt as widgetPlugin
};
